package SOFA.Component.DCUP;


/** Component update control interface of the component manager. It provides methods for 
  * dynamic update.
  * Generated by SOFA CodeGen.
  */

public interface ComponentUpdateOperations  {
        /** Updates component by new version.
          * @param newDeploymentDescriptor    deployment dscriptor of the new version of the component
          * @param stateStore    storage for the component state
          * @exception   ComponentLifecycleException   component cannot be updated
          */
  void updateComponent(SOFA.SOFAnode.Run.Deployment.DeploymentDescriptor newDeploymentDescriptor, SOFA.SOFAnode.Run.Storage stateStore) throws SOFA.Component.ComponentLifecycleException;
        /** Tests if this component is stopped, i.e. all own threads was stopped and destroyed.
          * This method calls method <tt>isUpdatable</tt> of the <tt>ComponentBuilder</tt>.
          * @return   <tt>true</tt> if component is stopped
          */
  boolean isUpdatable();
}
