package SOFA.Component;


/** Register interface of the component manager. It allows registering of subcomponents
  * and maipulating of requirments/provisions.
  * Generated by SOFA CodeGen.
  */
public interface RegisterOperations  {
      /** Register subcomponent in the component manager.
        * @param name    name of the subcomponent
        * @param target  reference to the subcomponent's component manager
        * @exception  NamingException   subcomponent with given name is already registered
        * @exception  InstantiationException    subcomponent cannot be registered (probably bad reference)
        */
  void registerSubcomponent(java.lang.String name, SOFA.Connector.Reference target) throws SOFA.Component.NamingException, InstantiationException;
      /** Unregister subcomponent.
        * @param name   name of the subcomponent
        * @exception NamingException   no subcomponent with given name
        */
  void unregisterSubcomponent(java.lang.String name) throws SOFA.Component.NamingException;
      /** Return reference to the provided interface.
        * @param name    name of the provision
        * @exception   NamingException   no provision with given name
        * @return      SOFA reference to the provision
        */
  SOFA.Connector.Reference getProvisionReference(String name) throws NamingException;
      /** Set reference for the requirment.
        * @param    name   name of the requirment
        * @param    ref    SOFA reference to another component's provision
        * @exception  NamingException   no requirment with given name
        * @exception  InstantiationException  reference cannot be set (probably bad reference)
        */
  void setRequirement(String name, SOFA.Connector.Reference ref) throws InstantiationException, NamingException;
      /** Connect component subsumtions.
        * @exception NamingException    error in the names of the requirments
        * @exception InstantiationException   subsumption cannot be connected
        */
  void connectSubsumable() throws NamingException, InstantiationException;
}
