/* $Id: DCUPComponentManagerCRole.java,v 1.3 2004/05/20 14:23:50 bures Exp $ */
package SOFA.Connector.Boot;

import SOFA.Component.ComponentLifecycleException;
import SOFA.Component.NamingException;
import SOFA.Component.DCUP.DCUPComponentManager;
import SOFA.Connector.LinkException;
import SOFA.Connector.RoleBaseImpl;
import SOFA.Connector.TaggedProfile;
import SOFA.SOFAnode.Run.Storage;

public class DCUPComponentManagerCRole extends RoleBaseImpl implements DCUPComponentManager {

  private DCUPComponentManager tgt = null;

  public DCUPComponentManagerCRole() {}

  public void link(Object target) throws LinkException {
    try {
      if (target instanceof SOFA.Connector.Reference) {
        SOFA.Connector.Reference ref = (SOFA.Connector.Reference) target;
        setSOFAReference(ref);
        TaggedProfile[] profiles = ref.profiles;
        for (int i = 0; i<profiles.length; i++) {
          if ("LOCAL".equals(profiles[i].tag)) {
            tgt = (DCUPComponentManager)((SOFA.Connector.ECG.Profiles.LocalProfile)profiles[i]).link;
            return;
          } else if ("RMI".equals(profiles[i].tag)) {
            tgt = new DCUPComponentManagerRMIStub(((SOFA.Connector.ECG.Profiles.RMIProfile)profiles[i]).URL);
            return;
          }
        }
      } else {
        tgt = (DCUPComponentManager) target;
      }
    } catch (Exception e) {
      throw new LinkException("Can't link DCUPComponentManagerCRole.", e);
    }
  }

  public void createComponent(Storage stateStore) throws ComponentLifecycleException {
    tgt.createComponent(stateStore);
  }

  public void destroyComponent(Storage stateStore) throws ComponentLifecycleException {
    tgt.destroyComponent(stateStore);
  }

  public void storeComponent(Storage stateStore) throws ComponentLifecycleException {
    tgt.storeComponent(stateStore);
  }

  public void restoreComponent(Storage stateStore) throws ComponentLifecycleException {
    tgt.restoreComponent(stateStore);
  }

  public void registerSubcomponent(java.lang.String name, SOFA.Connector.Reference target) throws SOFA.Component.NamingException, SOFA.Component.InstantiationException {
    tgt.registerSubcomponent(name, target);
  }
  
  public void unregisterSubcomponent(java.lang.String name) throws SOFA.Component.NamingException {
    tgt.unregisterSubcomponent(name);
  }


  public void updateComponent(SOFA.SOFAnode.Run.Deployment.DeploymentDescriptor newDeploymentDescriptor, Storage stateStore) throws ComponentLifecycleException {
    tgt.updateComponent(newDeploymentDescriptor, stateStore);
  }

  public SOFA.Connector.Reference getProvisionReference(String name) throws NamingException {
    return tgt.getProvisionReference(name);
  }
  
  public void setRequirement(String name, SOFA.Connector.Reference ref) throws SOFA.Component.InstantiationException, NamingException {
    tgt.setRequirement(name, ref);
  }
  
  public void connectSubsumable() throws NamingException, SOFA.Component.InstantiationException {
    tgt.connectSubsumable();
  }

  public SOFA.SOFAnode.Run.Deployment.DeplDock getLocalDeplDock() {
    return tgt.getLocalDeplDock();
  }

  public String getFullName() {
    return tgt.getFullName();
  }

  public boolean isUpdatable() {
    return tgt.isUpdatable();
  }

  public Object[] getFcInterfaces() {
    return tgt.getFcInterfaces();
  }
  
  public Object getFcInterface(java.lang.String itfName) throws org.objectweb.fractal.api.NoSuchInterfaceException {
    return tgt.getFcInterface(itfName);
  }
  
  public org.objectweb.fractal.api.Type getFcType() {
    return this;
  }

  public boolean isFcSubtypeOf(org.objectweb.fractal.api.Type t) {
    return tgt.isFcSubtypeOf(t);
  }
}
