/*
 * RMIC.java
 *
 * Created on 2. duben 2002, 23:37
 */

package SOFA.Connector.EEG.EEM.Actions;

import SOFA.Connector.EEG.EEM.ActionException;
import SOFA.Connector.EEG.EEM.ActionInterface;

/**
 *
 * @author  ghort
 * @version 
 */
public class RMIC implements ActionInterface {

	/** Creates new RMIC */
   public RMIC(java.util.HashMap props) {
   }

	public String getName() {
		return "rmic";
	}
	 
	public void perform(SOFA.Connector.Property[] params, String sourceDir, String sourcePackage, String destDir, String destPackage) throws ActionException {
		String source;
                String iface;
		if ((source=SOFA.Connector.Property.findFirst(params,"class"))==null) {
			throw new ActionException("class param not specified");
		}
		if ((iface=SOFA.Connector.Property.findFirst(params,"iface"))==null) {
			throw new ActionException("iface param not specified");
		}
		 
		int ret;
    String options="";
		try {
      options = "-classpath "+SOFA.Util.ConnGenPathInfo.getConnGenClassPath(iface)+" -d "+SOFA.Util.ConnGenPathInfo.getRMICOutDir()+"  ";
			Runtime runtime=Runtime.getRuntime();
			Process process=runtime.exec("rmic "+options+destPackage+"."+source);
			ret=process.waitFor();
		} catch (Exception e) {
			throw new ActionException("Can't create RMI skeleton for class "+destPackage+"."+source+".",e);
		}
		if (ret!=0) {
			throw new ActionException("Creating RMI skeleton 'rmic "+options+destPackage+"."+source+"' returned error ("+ret+").");
		}
	}
	 
}
