/*
 * CORBAStubGen.java
 *
 * Created on 13. duben 2002, 21:08
 */

package SOFA.Connector.EEG.EEM.Elements;

import SOFA.Connector.EEG.CodeWriter.CDL2IDL2JavaMapping;
import SOFA.Connector.EEG.CodeWriter.CodeWriterException;
import SOFA.Connector.EEG.CodeWriter.JWriterDirectorException;
import SOFA.Connector.EEG.EEM.Actions.JIfaceCN;
import SOFA.Connector.EEG.EEM.Actions.JIfaceCNCORBA;
import SOFA.Connector.EEG.EEM.Actions.JImplWriterDirectorBase;
import SOFA.SOFAnode.Made.TIR.OperationDef;
import SOFA.SOFAnode.Made.TIR.ParamDescr;
import SOFA.SOFAnode.Made.TIR.ParamMode;
import SOFA.SOFAnode.Made.TIR.TIRExceptLock;

/**
 *
 * @author  ghort
 * @version 
 */
public class CORBAStubGen extends JImplWriterDirectorBase {

	/** Creates new CORBAStubGen */
	public CORBAStubGen(String provIfaceCDL, SOFA.Connector.Property[] params) {
		super(provIfaceCDL,params);
	}

	public String[] getImplements() {
		return new String[] {"SOFA.Connector.EEG.Types.Stub"};
	}
	
	public String getClassBody() {
		String reqIfaceMapped=SOFA.Connector.Property.findFirst(params,"reqIfaceMapped");
		return managerTieImpl() + "\n" +
			"\tprotected "+reqIfaceMapped+" target;\n\n"+
			"\tpublic void link(SOFA.Connector.TaggedProfile target) throws SOFA.Connector.LinkException {\n"+
			"\t\ttry {\n"+
			"\t\t\torg.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init((String[])null, null);\n"+
			"\t\t\tthis.target = "+reqIfaceMapped+"Helper.narrow(orb.string_to_object(((SOFA.Connector.ECG.Profiles.CORBAProfile)target).IOR));\n"+
			"\t\t} catch (Exception e) {\n"+
			"\t\t\tthrow new SOFA.Connector.LinkException(\"Can't link to '\"+((SOFA.Connector.ECG.Profiles.CORBAProfile)target).IOR+\"'.\",e);\n"+
			"\t\t}\n"+
			"\t}\n\n"+
			"\tpublic String[] getSupportedProfiles() {\n"+
			"\t\treturn new String[] {\"CORBA\"};\n"+
			"\t}\n";
	}
	
	public String getMethodDef(OperationDef mt) throws JWriterDirectorException {
		return JIfaceCN.getMethodDef(mt);
	}
	
	public String getMethodBody(OperationDef method) throws JWriterDirectorException {
		try {
			String ret="\t\ttry {\n";

			int i;
			ParamDescr[] params=method.params();

			for (i=0;i<params.length;i++) {
				int mode=params[i].mode().value();
				if (mode==ParamMode.PARAM_INOUT || mode==ParamMode.PARAM_OUT) {
					String holderName=CDL2IDL2JavaMapping.getTypeName(params[i].type(),mode);
					ret+="\t\t\t"+holderName+" _corbaholder_"+params[i].name()+"=new "+holderName+"();  _corbaholder_"+params[i].name()+".value="+params[i].name()+".value;\n";
				}
			}
			
			ret+="\t\t\t"+declareRet(method,"ret")+"\n"+
				"\t\t\t"+assignRet(method,"ret")+targetCall(method,JIfaceCNCORBA.targetCallParams(method))+";\n";

			for (i=0;i<params.length;i++) {
				int mode=params[i].mode().value();
				if (mode==ParamMode.PARAM_INOUT || mode==ParamMode.PARAM_OUT) {
					ret+="\t\t\t"+params[i].name()+".value=_corbaholder_"+params[i].name()+".value;\n";
				}
			}

			ret+="\t\t\t"+returnRet(method,"ret")+"\n"+
				"\t\t} catch (org.omg.CORBA.SystemException e) {\n"+
				"\t\t\tthrow new SOFA.Connector.ConnectorTransportException(\"Can't call method '"+method.get_identification().absolute_name().name()+"'.\",e);\n"+
				"\t\t}\n";

			return ret;

		} catch (java.rmi.RemoteException e) {
			throw new JWriterDirectorException("Cannot access TIR.",e);
		} catch (TIRExceptLock e) {
			throw new JWriterDirectorException("Cannot access TIR.",e);
		} catch (CodeWriterException e) {
			throw new JWriterDirectorException("Cannot map operation to Java.",e);
		}

	}
}
