/*
 * CRoleImplGen.java
 *
 * Created on 13. duben 2002, 21:08
 */

package SOFA.Connector.EEG.EEM.Elements;

import SOFA.Connector.EEG.CodeWriter.JWriterDirectorException;
import SOFA.Connector.EEG.EEM.Actions.JIfaceCN;
import SOFA.Connector.EEG.EEM.Actions.JImplWriterDirectorBase;
import SOFA.SOFAnode.Made.TIR.OperationDef;

/**
 *
 * @author  ghort
 * @version 
 */
public class CRoleImplGen extends JImplWriterDirectorBase {

	/** Creates new CRoleImplGen */
	public CRoleImplGen(String provIfaceCDL, SOFA.Connector.Property[] params) {
		super(provIfaceCDL,params);
	}

	public String[] getImplements() {
		return new String[] {"SOFA.Connector.EEG.Types.CRole"};
	}

	public String getExtends() {
		return "SOFA.Connector.EEG.ElementRoleBase";
	}

	public String getClassBody() {
		String reqIfaceMapped=SOFA.Connector.Property.findFirst(params,"reqIfaceMapped");
		return 
			"\tprotected "+reqIfaceMapped+" target;\n\n"+
			"\tpublic void link(Object target) throws SOFA.Connector.LinkException {\n"+
			"\t\tif (target instanceof SOFA.Connector.Reference) {\n"+
			"\t\t\tmanager.link(target);\n"+
			"\t\t} else {\n"+
			"\t\t\tthis.target=("+reqIfaceMapped+")target;\n"+
			"\t\t}\n"+
			"\t}\n\n"+
                        "\tpublic org.objectweb.fractal.api.Type getFcItfType() { return new SOFA.Util.FcTypeImpl(); }\n\n"+
                        "\tpublic boolean isFcInternalItf() { return false; }\n\n"+
                        "\tpublic String getFcItfName() { return this.target.getFcItfName(); }\n\n"+
                        "\tpublic org.objectweb.fractal.api.Component getFcItfOwner() { return this.target.getFcItfOwner(); }\n\n";
	}

	public String getMethodBody(OperationDef method) throws JWriterDirectorException {
		return 
			"\t\t"+declareRet(method,"ret")+"\n"+
			"\t\tSOFA.Component.ThreadIDRegistry thrReg=manager.getThrIDRegistry();\n"+
			"\t\tString thr_id=thrReg.threadOutCall();\n"+
			"\t\t"+assignRet(method,"ret")+targetCall(method,JIfaceCN.targetCallParams(method))+";\n"+
			"\t\tthrReg.threadInReturn(thr_id);\n"+
			"\t\t"+returnRet(method,"ret");
	}
	 
}
