/*
 * ContractDesc.java
 *
 * Created on 18. kvten 2004, 14:24
 */

package SOFA.SOFAnet.Admin.RMI;

import SOFA.SOFAnet.Repository.Contract;
import java.io.Serializable;

/**
 *
 * @author  Ladislav Sobr
 */
public class ContractDesc implements Comparable, Serializable
{
  public String name;
  public String description;
  
  /** Creates a new instance of ContractDesc */
  public ContractDesc(Contract contract)
  {
    this.name = contract.getName();
    this.description = contract.getDescription();
  }
    
  ContractDesc(String name, String description)
  {
    this.name = name;
    this.description = description;
  }

  public boolean equals(Object o)
  {
    if (this == o) return true;
    if (o instanceof ContractDesc)
    {
      ContractDesc contractDesc = (ContractDesc)o;
      return toString().compareTo(contractDesc.toString()) == 0;
    }
    else return false;
  }

  public int compareTo(Object o)
  {
    ContractDesc contractDesc = (ContractDesc)o;
    return toString().compareTo(contractDesc.toString());
  }

  public String toString()
  {
    if (description.length() == 0) return name;
    else return name + " (" + description + ")";
  }
}
