/*
 * LocalInfoDesc.java
 *
 * Created on 11. kvten 2004, 14:42
 */

package SOFA.SOFAnet.Admin.RMI;

import SOFA.SOFAnet.Repository.LocalInfo;
import java.io.Serializable;

/**
 *
 * @author  Ladislav Sobr
 */
public class LocalInfoDesc implements Serializable, Comparable
{
  public String bundleName;
  public int state;
  
  /** Creates a new instance of LocalInfoDesc */
  public LocalInfoDesc(LocalInfo localInfo)
  {
    bundleName = localInfo.getName();
    state = localInfo.getState();
  }
  
  public LocalInfoDesc(String bundleName, int state)
  {
    this.bundleName = bundleName;
    this.state = state;
  }
  
  public String toString()
  {
    return bundleName;
  }
  
  public boolean equals(Object o)
  {
    if (this == o) return true;
    if (o instanceof LocalInfoDesc)
    {
      LocalInfoDesc localInfoDesc = (LocalInfoDesc)o;
      return bundleName.compareTo(localInfoDesc.bundleName) == 0;
    }
    else return false;
  }

  public int compareTo(Object o)
  {
    LocalInfoDesc localInfoDesc = (LocalInfoDesc)o;
    return bundleName.compareTo(localInfoDesc.bundleName);
  }
  
  
  public boolean isInstalled()
  {
    return (state & LocalInfo.STATE_INSTALLED) != 0;
  }
  
  public boolean isShareManager()
  {
    return (state & LocalInfo.STATE_SHARE_MANAGER) != 0;
  }
  
  public boolean isShareClient()
  {
    return (state & LocalInfo.STATE_SHARE_CLIENT) != 0;
  }

  public boolean areShareClientModes()
  {
    return (state & (LocalInfo.STATE_SHARE_CLIENT | LocalInfo.STATE_SHARE_PRECLIENT)) != 0;
  }

  public boolean isSharePreClient()
  {
    return (state & LocalInfo.STATE_SHARE_PRECLIENT) != 0;
  }

  public boolean isInSharing()
  {
    return (state & (LocalInfo.STATE_SHARE_MANAGER | LocalInfo.STATE_SHARE_CLIENT | LocalInfo.STATE_SHARE_PRECLIENT)) != 0;
  }
  
}
