/*
 * OutputTriggerDesc.java
 *
 * Created on 18. kvten 2004, 14:29
 */

package SOFA.SOFAnet.Admin.RMI;

import SOFA.SOFAnet.Repository.OutputTrigger;
import java.io.Serializable;

/**
 *
 * @author  Ladislav Sobr
 */
public class OutputTriggerDesc implements Comparable, Serializable
{
  public String name;
  public String description;
  
  /** Creates a new instance of OutputTriggerDesc */
  public OutputTriggerDesc(OutputTrigger outputTrigger)
  {
    this.name = outputTrigger.getName();
    this.description = outputTrigger.getDescription();
  }
    
  OutputTriggerDesc(String name, String description)
  {
    this.name = name;
    this.description = description;
  }

  public boolean equals(Object o)
  {
    if (this == o) return true;
    if (o instanceof OutputTriggerDesc)
    {
      OutputTriggerDesc outputTriggerDesc = (OutputTriggerDesc)o;
      return toString().compareTo(outputTriggerDesc.toString()) == 0;
    }
    else return false;
  }

  public int compareTo(Object o)
  {
    OutputTriggerDesc outputTriggerDesc = (OutputTriggerDesc)o;
    return toString().compareTo(outputTriggerDesc.toString());
  }

  public String toString()
  {
    if (description.length() == 0) return name;
    else return name + " (" + description + ")";
  }
}