/*
 * BinBundlesAndLicencesPanel.java
 *
 * Created on 10. kvten 2004, 17:17
 */

package SOFA.SOFAnet.Browser;

import javax.swing.*;
import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.Licence;
import java.rmi.RemoteException;
import java.util.SortedSet;
import java.util.TreeSet;
import java.util.Iterator;

/**
 *
 * @author  Ladislav Sobr
 */
public class BinBundlesAndLicencesPanel extends javax.swing.JPanel
{
  private RMIAdminInterface admin;
  private DefaultListModel content;
  
  private class BundleLic implements Comparable
  {
    public String bundleName;
    public boolean isBinBundle;
    public boolean isLicence;
    
    BundleLic(String bundleName, boolean isBinBundle, boolean isLicence)
    {
      this.bundleName = bundleName;
      this.isBinBundle = isBinBundle;
      this.isLicence = isLicence;
    }
    
    public boolean equals(Object o)
    {
      if (this == o) return true;
      if (o instanceof BundleLic)
      {
        BundleLic bundleLic = (BundleLic)o;
        return bundleName.compareTo(bundleLic.bundleName) == 0;
      }
      else return false;
    }

    public int compareTo(Object o)
    {
      BundleLic bundleLic = (BundleLic)o;
      return bundleName.compareTo(bundleLic.bundleName);
    }
    
    public String toString()
    {
      if (isBinBundle)
      {
        if (isLicence) return bundleName + " (with licence)";
        else return bundleName;
      }
      else
      {
        if (isLicence) return bundleName + " (LICENCE ONLY!)";
        else return "error";
      }
    }
  }
  /** Creates new form BinBundlesAndLicencesPanel */
  public BinBundlesAndLicencesPanel(RMIAdminInterface admin)
  {
    this.admin = admin;
    content = new DefaultListModel();
//    reload();
    initComponents();
  }
  
  private void reload()
  {
    content.clear();
    
    String[] bundles = null;
    String[] licences = null;
    try
    {
      bundles = admin.binBundlesList();
      licences = admin.licencesList();
    }
    /*
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, "Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
     */
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    SortedSet ss = new TreeSet();
    int i;
    BundleLic tmpBundleLic = new BundleLic("", false, false);
    for (i = 0; i < bundles.length; i++) ss.add(new BundleLic(bundles[i], true, false));
    for (i = 0; i < licences.length; i++)
    {
      tmpBundleLic.bundleName = licences[i];
      if (ss.contains(tmpBundleLic))
      {
        Iterator it = ss.iterator();
        while (it.hasNext())
        {
          BundleLic bundleLic = (BundleLic)it.next();
          if (bundleLic.equals(tmpBundleLic))
          {
            bundleLic.isLicence = true;
            break;
          }
        }
      }
      else ss.add(new BundleLic(tmpBundleLic.bundleName, false, true));
    }
    
    content.ensureCapacity(ss.size());
    
    Iterator it = ss.iterator();
    while (it.hasNext()) content.addElement(it.next());
  }
  
  private String getSelectedBundleName()
  {
    String bundleName = "";

    int index = contentList.getSelectedIndex();
    if (index != -1) bundleName = ((BundleLic)content.getElementAt(index)).bundleName;
    return bundleName;
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel3 = new javax.swing.JPanel();
    binBundleCheckBox = new javax.swing.JCheckBox();
    licenceCheckBox = new javax.swing.JCheckBox();
    jPanel2 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    installButton = new javax.swing.JButton();
    shareButton = new javax.swing.JButton();
    deleteButton = new javax.swing.JButton();
    deleteBinaryButton = new javax.swing.JButton();
    createOfferButton = new javax.swing.JButton();
    testPushButton = new javax.swing.JButton();
    pushButton = new javax.swing.JButton();
    showLicenceButton = new javax.swing.JButton();
    editLicenceButton = new javax.swing.JButton();
    deleteLicenceButton = new javax.swing.JButton();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    refreshButton = new javax.swing.JButton();
    testPullButton = new javax.swing.JButton();
    pullButton = new javax.swing.JButton();
    jScrollPane1 = new javax.swing.JScrollPane();
    contentList = new javax.swing.JList();

    setLayout(new java.awt.BorderLayout());

    addComponentListener(new java.awt.event.ComponentAdapter()
    {
      public void componentShown(java.awt.event.ComponentEvent evt)
      {
        formComponentShown(evt);
      }
    });

    jPanel3.setLayout(new java.awt.GridLayout(1, 0));

    jPanel3.setBorder(new javax.swing.border.TitledBorder("Bundle & Licence Info"));
    binBundleCheckBox.setText("Binary Bundle");
    binBundleCheckBox.setBorderPaintedFlat(true);
    binBundleCheckBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        CheckBoxNoChangeAction(evt);
      }
    });

    jPanel3.add(binBundleCheckBox);

    licenceCheckBox.setText("Licence");
    licenceCheckBox.setBorderPaintedFlat(true);
    licenceCheckBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        CheckBoxNoChangeAction(evt);
      }
    });

    jPanel3.add(licenceCheckBox);

    add(jPanel3, java.awt.BorderLayout.SOUTH);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel2.setPreferredSize(new java.awt.Dimension(200, 379));
    jPanel4.setLayout(new java.awt.GridLayout(10, 0));

    jPanel4.setBorder(new javax.swing.border.TitledBorder("Bundle Specific"));
    installButton.setText("Install Bundle");
    installButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        installButtonActionPerformed(evt);
      }
    });

    jPanel4.add(installButton);

    shareButton.setText("Share Bundle");
    shareButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        shareButtonActionPerformed(evt);
      }
    });

    jPanel4.add(shareButton);

    deleteButton.setText("Delete Bundle");
    deleteButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteButtonActionPerformed(evt);
      }
    });

    jPanel4.add(deleteButton);

    deleteBinaryButton.setText("Delete Binary Bundle");
    deleteBinaryButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteBinaryButtonActionPerformed(evt);
      }
    });

    jPanel4.add(deleteBinaryButton);

    createOfferButton.setText("Create Bundle Offer");
    createOfferButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createOfferButtonActionPerformed(evt);
      }
    });

    jPanel4.add(createOfferButton);

    testPushButton.setText("Test Push Bundle");
    testPushButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        testPushButtonActionPerformed(evt);
      }
    });

    jPanel4.add(testPushButton);

    pushButton.setText("Push Bundle");
    pushButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        pushButtonActionPerformed(evt);
      }
    });

    jPanel4.add(pushButton);

    showLicenceButton.setText("Show Licence");
    showLicenceButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        showLicenceButtonActionPerformed(evt);
      }
    });

    jPanel4.add(showLicenceButton);

    editLicenceButton.setText("Edit Licence (HACK!)");
    editLicenceButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        editLicenceButtonActionPerformed(evt);
      }
    });

    jPanel4.add(editLicenceButton);

    deleteLicenceButton.setText("Delete Licence (HACK!)");
    deleteLicenceButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteLicenceButtonActionPerformed(evt);
      }
    });

    jPanel4.add(deleteLicenceButton);

    jPanel2.add(jPanel4, java.awt.BorderLayout.NORTH);

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.TitledBorder("General"));
    jPanel5.setLayout(new java.awt.GridLayout(3, 0));

    refreshButton.setText("Refresh");
    refreshButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        refreshButtonActionPerformed(evt);
      }
    });

    jPanel5.add(refreshButton);

    testPullButton.setText("Test Pull Bundle");
    testPullButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        testPullButtonActionPerformed(evt);
      }
    });

    jPanel5.add(testPullButton);

    pullButton.setText("Pull Bundle");
    pullButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        pullButtonActionPerformed(evt);
      }
    });

    jPanel5.add(pullButton);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    jPanel2.add(jPanel1, java.awt.BorderLayout.CENTER);

    add(jPanel2, java.awt.BorderLayout.EAST);

    contentList.setModel(content);
    contentList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    contentList.setVisibleRowCount(-1);
    contentList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
    {
      public void valueChanged(javax.swing.event.ListSelectionEvent evt)
      {
        contentListValueChanged(evt);
      }
    });
    contentList.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseClicked(java.awt.event.MouseEvent evt)
      {
        contentListMouseClicked(evt);
      }
    });

    jScrollPane1.setViewportView(contentList);

    add(jScrollPane1, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents

  private void contentListMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_contentListMouseClicked
  {//GEN-HEADEREND:event_contentListMouseClicked
    if (evt.getClickCount() == 2)
    {
      showLicenceButton.doClick(); //emulate button click
    }
  }//GEN-LAST:event_contentListMouseClicked

  private void testPullButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_testPullButtonActionPerformed
  {//GEN-HEADEREND:event_testPullButtonActionPerformed
    TestPullBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_testPullButtonActionPerformed

  private void pullButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_pullButtonActionPerformed
  {//GEN-HEADEREND:event_pullButtonActionPerformed
    if (PullBundleDialog.showDialog(this, admin, "")) reload();
  }//GEN-LAST:event_pullButtonActionPerformed

  private void deleteLicenceButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteLicenceButtonActionPerformed
  {//GEN-HEADEREND:event_deleteLicenceButtonActionPerformed
    String bundleName = getSelectedBundleName();
    
    if (bundleName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "No bundle selected", "Warning", JOptionPane.WARNING_MESSAGE);
      return;
    }
    else
    {
      if (JOptionPane.showConfirmDialog(this, "Do you really want to delete Licence File for bundle '" + bundleName + "'?") != JOptionPane.YES_OPTION) return;
    }
    
    Licence licence = null;    
    try
    {
      licence = admin.getLicence(bundleName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    if (licence == null)
    {
      JOptionPane.showMessageDialog(this, "No Licence File present for bundle '" + bundleName + "'");
      return;
    }

    try
    {
      admin.updateLicence(bundleName, null);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    reload();
  }//GEN-LAST:event_deleteLicenceButtonActionPerformed

  private void editLicenceButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_editLicenceButtonActionPerformed
  {//GEN-HEADEREND:event_editLicenceButtonActionPerformed
    String bundleName = getSelectedBundleName();
    
    if (bundleName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "No bundle selected", "Warning", JOptionPane.WARNING_MESSAGE);
      return;
    }
    
    Licence licence = null;    
    try
    {
      licence = admin.getLicence(bundleName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    if (licence == null)
    {
      if (JOptionPane.showConfirmDialog(this, "No Licence File present for bundle '" + bundleName + "'\nDo you want to create licence file?") != JOptionPane.YES_OPTION) return;
      licence = new Licence();
    }
    else
    {
      if (JOptionPane.showConfirmDialog(this, "Do you really want to edit Licence File for bundle '" + bundleName + "'?") != JOptionPane.YES_OPTION) return;
    }
    
    if (LicenceEditDialog.showDialog(this, licence, true, "Licence File of '" + bundleName + "'"))
    {
      try
      {
        admin.updateLicence(bundleName, licence);
      }
      catch (RemoteException e)
      {
        JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      catch (RMIAdminException e)
      {
        JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      
      reload();
    }
    
  }//GEN-LAST:event_editLicenceButtonActionPerformed

  private void showLicenceButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_showLicenceButtonActionPerformed
  {//GEN-HEADEREND:event_showLicenceButtonActionPerformed
    String bundleName = getSelectedBundleName();
    
    if (bundleName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "No bundle selected", "Warning", JOptionPane.WARNING_MESSAGE);
      return;
    }
    
    Licence licence = null;    
    try
    {
      licence = admin.getLicence(bundleName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    if (licence != null)
    {
      LicenceEditDialog.showDialog(this, licence, false, "Licence File of '" + bundleName + "'");
    }
    else
    {
      JOptionPane.showMessageDialog(this, "No Licence File present for bundle '" + bundleName + "'", "No Licence File Present", JOptionPane.INFORMATION_MESSAGE);
    }
  }//GEN-LAST:event_showLicenceButtonActionPerformed

  private void pushButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_pushButtonActionPerformed
  {//GEN-HEADEREND:event_pushButtonActionPerformed
    PushBundleDialog.showDialog(this, admin, getSelectedBundleName());
  }//GEN-LAST:event_pushButtonActionPerformed

  private void testPushButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_testPushButtonActionPerformed
  {//GEN-HEADEREND:event_testPushButtonActionPerformed
    TestPushBundleDialog.showDialog(this, admin, getSelectedBundleName());
  }//GEN-LAST:event_testPushButtonActionPerformed

  private void createOfferButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createOfferButtonActionPerformed
  {//GEN-HEADEREND:event_createOfferButtonActionPerformed
    CreateBundleOfferDialog.showDialog(this, admin, getSelectedBundleName());
  }//GEN-LAST:event_createOfferButtonActionPerformed

  private void deleteBinaryButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteBinaryButtonActionPerformed
  {//GEN-HEADEREND:event_deleteBinaryButtonActionPerformed
    if (DeleteBinaryBundleDialog.showDialog(this, admin, getSelectedBundleName())) reload();
  }//GEN-LAST:event_deleteBinaryButtonActionPerformed

  private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteButtonActionPerformed
  {//GEN-HEADEREND:event_deleteButtonActionPerformed
    if (DeleteBundleDialog.showDialog(this, admin, getSelectedBundleName())) reload();
  }//GEN-LAST:event_deleteButtonActionPerformed

  private void shareButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_shareButtonActionPerformed
  {//GEN-HEADEREND:event_shareButtonActionPerformed
    ShareBundleDialog.showDialog(this, admin, getSelectedBundleName());
  }//GEN-LAST:event_shareButtonActionPerformed

  private void formComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_formComponentShown
  {//GEN-HEADEREND:event_formComponentShown
    reload();
  }//GEN-LAST:event_formComponentShown

  private void installButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_installButtonActionPerformed
  {//GEN-HEADEREND:event_installButtonActionPerformed
    InstallBundleDialog.showDialog(this, admin, getSelectedBundleName());
  }//GEN-LAST:event_installButtonActionPerformed

  private void contentListValueChanged(javax.swing.event.ListSelectionEvent evt)//GEN-FIRST:event_contentListValueChanged
  {//GEN-HEADEREND:event_contentListValueChanged
    int index = contentList.getSelectedIndex();
    BundleLic bundleLic = null;
    if (index != -1) bundleLic = (BundleLic)content.getElementAt(index);
    
    if (bundleLic != null)
    {
      binBundleCheckBox.setSelected(bundleLic.isBinBundle);
      licenceCheckBox.setSelected(bundleLic.isLicence);
    }
    else
    {
      binBundleCheckBox.setSelected(false);
      licenceCheckBox.setSelected(false);
    }
  }//GEN-LAST:event_contentListValueChanged

  private void refreshButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_refreshButtonActionPerformed
  {//GEN-HEADEREND:event_refreshButtonActionPerformed
    reload();
  }//GEN-LAST:event_refreshButtonActionPerformed

  private void CheckBoxNoChangeAction(java.awt.event.ActionEvent evt)//GEN-FIRST:event_CheckBoxNoChangeAction
  {//GEN-HEADEREND:event_CheckBoxNoChangeAction
    JCheckBox checkBox = (JCheckBox)evt.getSource();
    checkBox.setSelected(!checkBox.isSelected());
  }//GEN-LAST:event_CheckBoxNoChangeAction
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JCheckBox binBundleCheckBox;
  private javax.swing.JList contentList;
  private javax.swing.JButton createOfferButton;
  private javax.swing.JButton deleteBinaryButton;
  private javax.swing.JButton deleteButton;
  private javax.swing.JButton deleteLicenceButton;
  private javax.swing.JButton editLicenceButton;
  private javax.swing.JButton installButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JCheckBox licenceCheckBox;
  private javax.swing.JButton pullButton;
  private javax.swing.JButton pushButton;
  private javax.swing.JButton refreshButton;
  private javax.swing.JButton shareButton;
  private javax.swing.JButton showLicenceButton;
  private javax.swing.JButton testPullButton;
  private javax.swing.JButton testPushButton;
  // End of variables declaration//GEN-END:variables
  
}
