/*
 * BundleOfferDialog.java
 *
 * Created on 17. kvten 2004, 13:12
 */

package SOFA.SOFAnet.Browser;

import javax.swing.*;
import SOFA.SOFAnet.Repository.BundleOffer;
import SOFA.SOFAnode.TR.ComponentInfo;
import java.util.Iterator;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class BundleOfferDialog extends javax.swing.JDialog
{
  private BundleOffer bundleOffer;
  private DefaultListModel content;
  
  public static void showDialog(Component frameComp, BundleOffer bundleOffer)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    BundleOfferDialog dialog = new BundleOfferDialog(frame, true, bundleOffer);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
  }
  
  /** Creates new form BundleOfferDialog */
  public BundleOfferDialog(java.awt.Frame parent, boolean modal, BundleOffer bundleOffer)
  {
    super(parent, modal);
    this.bundleOffer = bundleOffer;
    content = new DefaultListModel();
    initComponents();
    
    nodeTextField.setText(bundleOffer.getNodeName());
    
    Iterator it = bundleOffer.getComponents().iterator();
    while (it.hasNext())
    {
      ComponentInfo componentInfo = (ComponentInfo)it.next();
      content.addElement(componentInfo.getName() + "[" + componentInfo.getImplementationVersion() + "]");
    }
    
    setTitle("Bundle Offer for '" + bundleOffer.getName() + "'");
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel3 = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    nodeLabel = new javax.swing.JLabel();
    nodeTextField = new javax.swing.JTextField();
    componentsLabel = new javax.swing.JLabel();
    jScrollPane1 = new javax.swing.JScrollPane();
    componentsList = new javax.swing.JList();
    jPanel2 = new javax.swing.JPanel();
    closeButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    jPanel3.setLayout(new java.awt.BorderLayout());

    jPanel3.setMinimumSize(new java.awt.Dimension(400, 122));
    jPanel3.setPreferredSize(new java.awt.Dimension(400, 300));
    jPanel1.setLayout(new java.awt.GridLayout(3, 0));

    jPanel1.setMinimumSize(new java.awt.Dimension(200, 63));
    jPanel1.setPreferredSize(new java.awt.Dimension(200, 63));
    nodeLabel.setText("Source Node:");
    nodeLabel.setMinimumSize(new java.awt.Dimension(66, 15));
    nodeLabel.setPreferredSize(new java.awt.Dimension(66, 15));
    jPanel1.add(nodeLabel);

    nodeTextField.setEditable(false);
    jPanel1.add(nodeTextField);

    componentsLabel.setText("Components in the Bundle:");
    jPanel1.add(componentsLabel);

    jPanel3.add(jPanel1, java.awt.BorderLayout.NORTH);

    jScrollPane1.setMinimumSize(new java.awt.Dimension(260, 24));
    componentsList.setModel(content);
    componentsList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jScrollPane1.setViewportView(componentsList);

    jPanel3.add(jScrollPane1, java.awt.BorderLayout.CENTER);

    jPanel2.setMinimumSize(new java.awt.Dimension(200, 35));
    jPanel2.setPreferredSize(new java.awt.Dimension(200, 35));
    closeButton.setText("Close");
    closeButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        closeButtonActionPerformed(evt);
      }
    });

    jPanel2.add(closeButton);

    jPanel3.add(jPanel2, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel3, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void closeButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_closeButtonActionPerformed
  {//GEN-HEADEREND:event_closeButtonActionPerformed
    dispose();
  }//GEN-LAST:event_closeButtonActionPerformed
   
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton closeButton;
  private javax.swing.JLabel componentsLabel;
  private javax.swing.JList componentsList;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JLabel nodeLabel;
  private javax.swing.JTextField nodeTextField;
  // End of variables declaration//GEN-END:variables
  
}
