/*
 * InstallBundleDialog.java
 *
 * Created on 10. kvten 2004, 22:42
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.BundleInfo;
import SOFA.SOFAnode.TR.ComponentInfo;
import SOFA.SOFAnode.TR.Impl.ComponentInfoImpl;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class CreateUserBundleDialog extends javax.swing.JDialog
{
  private RMIAdminInterface admin;
  private DefaultListModel content;
  private SortedSet components;
  private boolean isOK;

  public static boolean showDialog(Component frameComp, RMIAdminInterface admin, String defaultBundleName, ComponentInfo[] defaultComponents)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    CreateUserBundleDialog dialog = new CreateUserBundleDialog(frame, true, admin, defaultBundleName, defaultComponents);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form CreateUserBundleDialog */
  public CreateUserBundleDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin, String defaultBundleName, ComponentInfo[] defaultComponents)
  {
    super(parent, modal);
    this.admin = admin;
    isOK = false;
    content = new DefaultListModel();
    components = new TreeSet();
    initComponents();
    
    bundleNameTextField.setText(defaultBundleName);
    if (defaultComponents != null)
    {
      for (int i = 0; i < defaultComponents.length; i++) components.add(defaultComponents[i].getName() + "[" + defaultComponents[i].getImplementationVersion() + "]");
      reloadContent();
    }
  }

  public boolean isOK()
  {
    return isOK;
  }
  
  private void reloadContent()
  {
    content.clear();
    content.ensureCapacity(components.size());
    Iterator it = components.iterator();
    while (it.hasNext()) content.addElement(it.next());
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel4 = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    bundleNameLabel = new javax.swing.JLabel();
    bundleNameTextField = new javax.swing.JTextField();
    componentsLabel = new javax.swing.JLabel();
    jScrollPane1 = new javax.swing.JScrollPane();
    componentsList = new javax.swing.JList();
    jPanel6 = new javax.swing.JPanel();
    subcomponentsCheckBox = new javax.swing.JCheckBox();
    jPanel2 = new javax.swing.JPanel();
    addComponentsButton = new javax.swing.JButton();
    removeComponentsButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    createUserBundleButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Create User Bundle");
    jPanel4.setLayout(new java.awt.BorderLayout());

    jPanel4.setMinimumSize(new java.awt.Dimension(400, 93));
    jPanel4.setPreferredSize(new java.awt.Dimension(400, 300));
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 10, 1, 10)));
    jPanel1.setMinimumSize(new java.awt.Dimension(26, 23));
    jPanel1.setPreferredSize(new java.awt.Dimension(26, 23));
    jPanel5.setLayout(new java.awt.GridLayout(3, 0));

    bundleNameLabel.setText("Bundle Name:");
    jPanel5.add(bundleNameLabel);

    bundleNameTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    bundleNameTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(bundleNameTextField);

    componentsLabel.setText("Components:");
    jPanel5.add(componentsLabel);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    componentsList.setModel(content);
    jScrollPane1.setViewportView(componentsList);

    jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

    jPanel6.setLayout(new java.awt.GridLayout());

    subcomponentsCheckBox.setText("Include Subcomponents");
    jPanel6.add(subcomponentsCheckBox);

    jPanel1.add(jPanel6, java.awt.BorderLayout.SOUTH);

    jPanel4.add(jPanel1, java.awt.BorderLayout.CENTER);

    addComponentsButton.setText("Add Components from TR");
    addComponentsButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        addComponentsButtonActionPerformed(evt);
      }
    });

    jPanel2.add(addComponentsButton);

    removeComponentsButton.setText("Remove Selected Components");
    removeComponentsButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        removeComponentsButtonActionPerformed(evt);
      }
    });

    jPanel2.add(removeComponentsButton);

    jPanel4.add(jPanel2, java.awt.BorderLayout.NORTH);

    createUserBundleButton.setText("Create User Bundle");
    createUserBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createUserBundleButtonActionPerformed(evt);
      }
    });

    jPanel3.add(createUserBundleButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    jPanel4.add(jPanel3, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void removeComponentsButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_removeComponentsButtonActionPerformed
  {//GEN-HEADEREND:event_removeComponentsButtonActionPerformed
    Object[] selected = componentsList.getSelectedValues();
    for (int i = 0; i < selected.length; i++)
    {
      if (selected[i] instanceof String) components.remove((String)selected[i]);
    }
    reloadContent();
  }//GEN-LAST:event_removeComponentsButtonActionPerformed

  private void addComponentsButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_addComponentsButtonActionPerformed
  {//GEN-HEADEREND:event_addComponentsButtonActionPerformed
    ComponentInfo[] componentInfos = null;
    try
    {
      componentInfos = admin.componentsInTRList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    String[] compNames = new String[componentInfos.length];
    int i;
    for (i = 0; i < componentInfos.length; i++) compNames[i] = componentInfos[i].getName() + "[" + componentInfos[i].getImplementationVersion() + "]";
    
    Arrays.sort(compNames);
    
    Object[] result = (Object [])ListDialog.showDialog(this, this, "Components in TR:", "Choose Components from TR to create User Bundle", (Object[])compNames, null, null, true, true);
    if (result != null) for (i = 0; i < result.length; i++) components.add((String)result[i]);

    reloadContent();    
  }//GEN-LAST:event_addComponentsButtonActionPerformed

  private void createUserBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createUserBundleButtonActionPerformed
  {//GEN-HEADEREND:event_createUserBundleButtonActionPerformed
    String bundleName = bundleNameTextField.getText();
    boolean subcomponents = subcomponentsCheckBox.isSelected();

    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromBundleName(bundleName);
    }
    catch (BundleInfo.InvalidBundleNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    if (bundleInfo.isComponent())
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\nName of User Bundle expected", "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    ComponentInfo[] componentInfos = new ComponentInfo[components.size()];
    int i = 0;
    Iterator it = components.iterator();
    while (it.hasNext())
    {
      String compName = (String)it.next();
      int leftBracket = compName.lastIndexOf('[');
      int rightBracket = compName.lastIndexOf(']');
      componentInfos[i++] = new ComponentInfoImpl(compName.substring(0, leftBracket), compName.substring(leftBracket + 1, rightBracket));
    }
    
    try
    {
      admin.createUserBundle(bundleName, componentInfos, subcomponents);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    
    JOptionPane.showMessageDialog(this, "User Bundle '" + bundleName + "' successfully created");
    
    isOK = true;
    dispose();
  }//GEN-LAST:event_createUserBundleButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton addComponentsButton;
  private javax.swing.JLabel bundleNameLabel;
  private javax.swing.JTextField bundleNameTextField;
  private javax.swing.JButton cancelButton;
  private javax.swing.JLabel componentsLabel;
  private javax.swing.JList componentsList;
  private javax.swing.JButton createUserBundleButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JPanel jPanel6;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JButton removeComponentsButton;
  private javax.swing.JCheckBox subcomponentsCheckBox;
  // End of variables declaration//GEN-END:variables
  
}
