/*
 * DeleteTriggersOfContractDialog.java
 *
 * Created on 20. kvten 2004, 14:50
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class DeleteTriggersOfContractDialog extends javax.swing.JDialog
{
  private RMIAdminInterface admin;
  private boolean isOK;
  
  public static boolean showDialog(Component frameComp, RMIAdminInterface admin, String defaultContractID)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    DeleteTriggersOfContractDialog dialog = new DeleteTriggersOfContractDialog(frame, true, admin, defaultContractID);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form DeleteTriggersOfContractDialog */
  public DeleteTriggersOfContractDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin, String defaultContractID)
  {
    super(parent, modal);
    this.admin = admin;
    isOK = false;
    initComponents();
    
    contractIDTextField.setText(defaultContractID);
  }
  
  public boolean isOK()
  {
    return isOK;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel4 = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    contractIDLabel = new javax.swing.JLabel();
    contractIDTextField = new javax.swing.JTextField();
    jPanel2 = new javax.swing.JPanel();
    chooseContractButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    deleteTriggersOfContractButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Delete Triggers Of Contract");
    jPanel4.setLayout(new java.awt.BorderLayout());

    jPanel4.setMinimumSize(new java.awt.Dimension(400, 93));
    jPanel4.setPreferredSize(new java.awt.Dimension(400, 150));
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 10, 1, 10)));
    jPanel1.setMinimumSize(new java.awt.Dimension(26, 23));
    jPanel1.setPreferredSize(new java.awt.Dimension(26, 23));
    jPanel5.setLayout(new java.awt.GridLayout(2, 0));

    contractIDLabel.setText("Contract ID (name):");
    jPanel5.add(contractIDLabel);

    contractIDTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    contractIDTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(contractIDTextField);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    jPanel4.add(jPanel1, java.awt.BorderLayout.CENTER);

    chooseContractButton.setText("Choose Contract");
    chooseContractButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        chooseContractButtonActionPerformed(evt);
      }
    });

    jPanel2.add(chooseContractButton);

    jPanel4.add(jPanel2, java.awt.BorderLayout.NORTH);

    deleteTriggersOfContractButton.setText("Delete Triggers of Contract");
    deleteTriggersOfContractButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteTriggersOfContractButtonActionPerformed(evt);
      }
    });

    jPanel3.add(deleteTriggersOfContractButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    jPanel4.add(jPanel3, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void chooseContractButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_chooseContractButtonActionPerformed
  {//GEN-HEADEREND:event_chooseContractButtonActionPerformed
    ContractDesc[] contractDescs = null;
    try
    {
      contractDescs = admin.contractDescsList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    Arrays.sort(contractDescs);
    
    ContractDesc result = (ContractDesc)ListDialog.showDialog(this, this, "Contracts:", "Choose Contract to Delete Triggers From", contractDescs, null, null, false, true);
    if (result != null) contractIDTextField.setText(result.name);
    
  }//GEN-LAST:event_chooseContractButtonActionPerformed

  private void deleteTriggersOfContractButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteTriggersOfContractButtonActionPerformed
  {//GEN-HEADEREND:event_deleteTriggersOfContractButtonActionPerformed
    String contractID = contractIDTextField.getText();

    if (contractID.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "Empty Contract ID", "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    try
    {
      admin.deleteTriggersOfContract(contractID);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    
    JOptionPane.showMessageDialog(this, "Triggers of Contract '" + contractID + "' successfully deleted");
    
    isOK = true;
    dispose();
  }//GEN-LAST:event_deleteTriggersOfContractButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton cancelButton;
  private javax.swing.JButton chooseContractButton;
  private javax.swing.JLabel contractIDLabel;
  private javax.swing.JTextField contractIDTextField;
  private javax.swing.JButton deleteTriggersOfContractButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  // End of variables declaration//GEN-END:variables
  
}
