/*
 * InputTriggersPanel.java
 *
 * Created on 17. kvten 2004, 20:37
 */

package SOFA.SOFAnet.Browser;

import javax.swing.*;
import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.InputTrigger;
import java.rmi.RemoteException;
import java.util.Arrays;

/**
 *
 * @author  Ladislav Sobr
 */
public class InputTriggersPanel extends javax.swing.JPanel
{
  private RMIAdminInterface admin;
  private DefaultListModel content;
  
  
  /** Creates new form InputTriggersPanel */
  public InputTriggersPanel(RMIAdminInterface admin)
  {
    this.admin = admin;
    content = new DefaultListModel();
    initComponents();
  }
  
  private void reload()
  {
    content.clear();
    
    InputTriggerDesc[] inputTriggerDescs = null;
    try
    {
      inputTriggerDescs = admin.inputTriggerDescsList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    Arrays.sort(inputTriggerDescs);
    
    content.ensureCapacity(inputTriggerDescs.length);
    for (int i = 0; i < inputTriggerDescs.length; i++) content.addElement(inputTriggerDescs[i]);
  }
  
  private String getSelectedInputTriggerName()
  {
    String inputTriggerName = "";

    int index = contentList.getSelectedIndex();
    if (index != -1) inputTriggerName = ((InputTriggerDesc)content.getElementAt(index)).name;
    return inputTriggerName;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel2 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    editButton = new javax.swing.JButton();
    addButton = new javax.swing.JButton();
    deleteButton = new javax.swing.JButton();
    jPanel1 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    refreshButton = new javax.swing.JButton();
    generateTriggersOfContractButton = new javax.swing.JButton();
    deleteTriggersOfContractButton = new javax.swing.JButton();
    jScrollPane1 = new javax.swing.JScrollPane();
    contentList = new javax.swing.JList();

    setLayout(new java.awt.BorderLayout());

    addComponentListener(new java.awt.event.ComponentAdapter()
    {
      public void componentShown(java.awt.event.ComponentEvent evt)
      {
        formComponentShown(evt);
      }
    });

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel2.setPreferredSize(new java.awt.Dimension(200, 204));
    jPanel4.setLayout(new java.awt.GridLayout(3, 0));

    jPanel4.setBorder(new javax.swing.border.TitledBorder("Input Trigger Specific"));
    editButton.setText("Edit Input Tigger");
    editButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        editButtonActionPerformed(evt);
      }
    });

    jPanel4.add(editButton);

    addButton.setText("Add New InputTrigger");
    addButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        addButtonActionPerformed(evt);
      }
    });

    jPanel4.add(addButton);

    deleteButton.setText("Delete Input Trigger");
    deleteButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteButtonActionPerformed(evt);
      }
    });

    jPanel4.add(deleteButton);

    jPanel2.add(jPanel4, java.awt.BorderLayout.NORTH);

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.TitledBorder("General"));
    jPanel3.setLayout(new java.awt.GridLayout(3, 0));

    refreshButton.setText("Refresh");
    refreshButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        refreshButtonActionPerformed(evt);
      }
    });

    jPanel3.add(refreshButton);

    generateTriggersOfContractButton.setText("Generate Triggers of Contract");
    generateTriggersOfContractButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        generateTriggersOfContractButtonActionPerformed(evt);
      }
    });

    jPanel3.add(generateTriggersOfContractButton);

    deleteTriggersOfContractButton.setText("Delete Triggers of Contract");
    deleteTriggersOfContractButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteTriggersOfContractButtonActionPerformed(evt);
      }
    });

    jPanel3.add(deleteTriggersOfContractButton);

    jPanel1.add(jPanel3, java.awt.BorderLayout.NORTH);

    jPanel2.add(jPanel1, java.awt.BorderLayout.CENTER);

    add(jPanel2, java.awt.BorderLayout.EAST);

    contentList.setModel(content);
    contentList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    contentList.setVisibleRowCount(-1);
    contentList.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseClicked(java.awt.event.MouseEvent evt)
      {
        contentListMouseClicked(evt);
      }
    });

    jScrollPane1.setViewportView(contentList);

    add(jScrollPane1, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents

  private void deleteTriggersOfContractButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteTriggersOfContractButtonActionPerformed
  {//GEN-HEADEREND:event_deleteTriggersOfContractButtonActionPerformed
    if (DeleteTriggersOfContractDialog.showDialog(this, admin, "")) reload();
  }//GEN-LAST:event_deleteTriggersOfContractButtonActionPerformed

  private void generateTriggersOfContractButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_generateTriggersOfContractButtonActionPerformed
  {//GEN-HEADEREND:event_generateTriggersOfContractButtonActionPerformed
    if (GenerateTriggersOfContractDialog.showDialog(this, admin, "")) reload();
  }//GEN-LAST:event_generateTriggersOfContractButtonActionPerformed

  private void refreshButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_refreshButtonActionPerformed
  {//GEN-HEADEREND:event_refreshButtonActionPerformed
    reload();
  }//GEN-LAST:event_refreshButtonActionPerformed

  private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteButtonActionPerformed
  {//GEN-HEADEREND:event_deleteButtonActionPerformed
    String inputTriggerName = getSelectedInputTriggerName();
    
    if (inputTriggerName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "No Input Trigger selected", "Warning", JOptionPane.WARNING_MESSAGE);
      return;
    }
    else
    {
      if (JOptionPane.showConfirmDialog(this, "Do you really want to delete Input Trigger '" + inputTriggerName + "'?") != JOptionPane.YES_OPTION) return;
    }
    
    try
    {
      admin.updateInputTrigger(inputTriggerName, null);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    reload();
  }//GEN-LAST:event_deleteButtonActionPerformed

  private void addButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_addButtonActionPerformed
  {//GEN-HEADEREND:event_addButtonActionPerformed
    String inputTriggerName = JOptionPane.showInputDialog(this, "Name of New Input Trigger:", "New Input Trigger", JOptionPane.INFORMATION_MESSAGE);
    if (inputTriggerName != null)
    {
      InputTrigger inputTrigger = new InputTrigger();
      
      try
      {
        admin.updateInputTrigger(inputTriggerName, inputTrigger);
      }
      catch (RemoteException e)
      {
        JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      catch (RMIAdminException e)
      {
        JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      
      reload();
    }
  }//GEN-LAST:event_addButtonActionPerformed

  private void editButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_editButtonActionPerformed
  {//GEN-HEADEREND:event_editButtonActionPerformed
    String inputTriggerName = getSelectedInputTriggerName();
    
    if (inputTriggerName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "No Input Trigger selected", "Warning", JOptionPane.WARNING_MESSAGE);
      return;
    }
    
    InputTrigger inputTrigger = null;
    try
    {
      inputTrigger = admin.getInputTrigger(inputTriggerName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    if (inputTrigger == null)
    {
      JOptionPane.showMessageDialog(this, "Selected Input Trigger doesn't exist on the node anymore", "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    if (InputTriggerEditDialog.showDialog(this, inputTrigger, "Input Trigger Editor"))
    {
      try
      {
        admin.updateInputTrigger(inputTriggerName, inputTrigger);
      }
      catch (RemoteException e)
      {
        JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      catch (RMIAdminException e)
      {
        JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      
      reload();
    }    
  }//GEN-LAST:event_editButtonActionPerformed

  private void contentListMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_contentListMouseClicked
  {//GEN-HEADEREND:event_contentListMouseClicked
    if (evt.getClickCount() == 2)
    {
      editButton.doClick(); //emulate button click
    }
  }//GEN-LAST:event_contentListMouseClicked

  private void formComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_formComponentShown
  {//GEN-HEADEREND:event_formComponentShown
    reload();
  }//GEN-LAST:event_formComponentShown
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton addButton;
  private javax.swing.JList contentList;
  private javax.swing.JButton deleteButton;
  private javax.swing.JButton deleteTriggersOfContractButton;
  private javax.swing.JButton editButton;
  private javax.swing.JButton generateTriggersOfContractButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JButton refreshButton;
  // End of variables declaration//GEN-END:variables
  
}
