/*
 * LicenceEditorDialog.java
 *
 * Created on 12. kvten 2004, 15:12
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Repository.Licence;
import java.util.Date;
import java.text.DateFormat;
import java.text.ParseException;
import javax.swing.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class LicenceEditDialog extends javax.swing.JDialog
{
  private Licence licence;
  private boolean edit;
  private boolean isOK;

  public static boolean showDialog(Component frameComp, Licence licence, boolean edit, String title)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    LicenceEditDialog dialog = new LicenceEditDialog(frame, true, licence, edit, title);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form LicenceEditorDialog */
  public LicenceEditDialog(java.awt.Frame parent, boolean modal, Licence licence, boolean edit, String title)
  {
    super(parent, modal);
    this.licence = licence;
    this.edit = edit;
    isOK = false;
    
    initComponents();
    setTitle(title);
    
    if (edit)
    {
      copiesTextField.setEditable(true);
      validFromTextField.setEditable(true);
      validToTextField.setEditable(true);
      licenceTextTextArea.setEditable(true);
      
      if (licence.getType() == Licence.TYPE_PHYSICAL) physicalRadioButton.setSelected(true);
      else activeRadioButton.setSelected(true);
      
      if (licence.withCopies()) copiesTextField.setText(Integer.toString(licence.getNumberOfCopies()));
      else copiesTextField.setText("");
      
      Date validFrom = licence.getValidFrom();
      Date validTo = licence.getValidTo();
      DateFormat dateFormat = DateFormat.getDateTimeInstance(DateFormat.MEDIUM, DateFormat.MEDIUM);

      if (validFrom != null) validFromTextField.setText(dateFormat.format(validFrom));
      else validFromTextField.setText("");
      
      if (validTo != null) validToTextField.setText(dateFormat.format(validTo));
      else validToTextField.setText("");
      
      licenceTextTextArea.setText(licence.getText());
    }
    else
    {
      copiesTextField.setEditable(false);
      validFromTextField.setEditable(false);
      validToTextField.setEditable(false);
      licenceTextTextArea.setEditable(false);
      
      if (licence.getType() == Licence.TYPE_PHYSICAL) physicalRadioButton.setSelected(true);
      else activeRadioButton.setSelected(true);
      
      if (licence.withCopies()) copiesTextField.setText(Integer.toString(licence.getNumberOfCopies()));
      else copiesTextField.setText("without copies");
      
      Date validFrom = licence.getValidFrom();
      Date validTo = licence.getValidTo();
      DateFormat dateFormat = DateFormat.getDateTimeInstance(DateFormat.MEDIUM, DateFormat.MEDIUM);

      if (validFrom != null) validFromTextField.setText(dateFormat.format(validFrom));
      else validFromTextField.setText("no limitation");
      
      if (validTo != null) validToTextField.setText(dateFormat.format(validTo));
      else validToTextField.setText("no limitation");
      
      licenceTextTextArea.setText(licence.getText());
    }
  }
  
  public boolean isOK()
  {
    return isOK;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    typeButtonGroup = new javax.swing.ButtonGroup();
    jPanel2 = new javax.swing.JPanel();
    typeLabel = new javax.swing.JLabel();
    jPanel1 = new javax.swing.JPanel();
    physicalRadioButton = new javax.swing.JRadioButton();
    activeRadioButton = new javax.swing.JRadioButton();
    copiesLabel = new javax.swing.JLabel();
    copiesTextField = new javax.swing.JTextField();
    validFromLabel = new javax.swing.JLabel();
    validFromTextField = new javax.swing.JTextField();
    validToLabel = new javax.swing.JLabel();
    validToTextField = new javax.swing.JTextField();
    textLabel = new javax.swing.JLabel();
    jScrollPane1 = new javax.swing.JScrollPane();
    licenceTextTextArea = new javax.swing.JTextArea();
    jPanel3 = new javax.swing.JPanel();
    OKButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    jPanel2.setLayout(new java.awt.GridLayout(5, 0));

    jPanel2.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 1, 10)));
    typeLabel.setText("Type of Licence:");
    jPanel2.add(typeLabel);

    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.X_AXIS));

    physicalRadioButton.setSelected(true);
    physicalRadioButton.setText("Physical");
    typeButtonGroup.add(physicalRadioButton);
    physicalRadioButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        typeRadioButtonActionPerformed(evt);
      }
    });

    jPanel1.add(physicalRadioButton);

    activeRadioButton.setText("Active");
    typeButtonGroup.add(activeRadioButton);
    activeRadioButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        typeRadioButtonActionPerformed(evt);
      }
    });

    jPanel1.add(activeRadioButton);

    jPanel2.add(jPanel1);

    copiesLabel.setText("Number of Copies:");
    jPanel2.add(copiesLabel);

    jPanel2.add(copiesTextField);

    validFromLabel.setText("Valid From:");
    jPanel2.add(validFromLabel);

    jPanel2.add(validFromTextField);

    validToLabel.setText("Valid To:");
    jPanel2.add(validToLabel);

    jPanel2.add(validToTextField);

    textLabel.setText("Text of Licence:");
    jPanel2.add(textLabel);

    getContentPane().add(jPanel2, java.awt.BorderLayout.NORTH);

    jScrollPane1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 10, 1, 10)));
    jScrollPane1.setMinimumSize(new java.awt.Dimension(400, 100));
    jScrollPane1.setPreferredSize(new java.awt.Dimension(400, 200));
    licenceTextTextArea.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
    jScrollPane1.setViewportView(licenceTextTextArea);

    getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

    OKButton.setText("OK");
    OKButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        OKButtonActionPerformed(evt);
      }
    });

    jPanel3.add(OKButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    getContentPane().add(jPanel3, java.awt.BorderLayout.SOUTH);

    pack();
  }//GEN-END:initComponents

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed

  private void OKButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_OKButtonActionPerformed
  {//GEN-HEADEREND:event_OKButtonActionPerformed
    if (edit)
    {
      try
      {
        int type = Licence.TYPE_PHYSICAL;

        if (activeRadioButton.isSelected()) type = Licence.TYPE_ACTIVE;

        int copies = Licence.WITHOUT_COPIES;
        String copiesText = copiesTextField.getText().trim().toLowerCase();
        if (copiesText.length() != 0 && copiesText.compareTo("without copies") != 0)
        {
          copies = Integer.parseInt(copiesText);
          if (copies < 0) throw new NumberFormatException("Negative 'Number of Copies' is not allowed");
        }
        
        DateFormat dateFormat = DateFormat.getInstance();
        Date validFrom = null;
        String validFromText = validFromTextField.getText().trim().toLowerCase();
        if (validFromText.length() != 0 && validFromText.compareTo("no limitation") != 0) validFrom = dateFormat.parse(validFromText);

        Date validTo = null;
        String validToText = validToTextField.getText().trim().toLowerCase();
        if (validToText.length() != 0 && validToText.compareTo("no limitation") != 0) validTo = dateFormat.parse(validToText);

        String text = licenceTextTextArea.getText();

        licence.setType(type);
        licence.setNumberOfCopies(copies);
        licence.setValidFrom(validFrom);
        licence.setValidTo(validTo);
        licence.setText(text);
      }
      catch (NumberFormatException e)
      {
        JOptionPane.showMessageDialog(this, "Error occured while parsing 'Number of Copies':\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      catch (ParseException e)
      {
        JOptionPane.showMessageDialog(this, "Error occured while parsing 'Valid From' or 'Valid To':\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      
    }
  
    isOK = true;
    dispose();    
  }//GEN-LAST:event_OKButtonActionPerformed

  private void typeRadioButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_typeRadioButtonActionPerformed
  {//GEN-HEADEREND:event_typeRadioButtonActionPerformed
    if (!edit)
    {
      if (physicalRadioButton.isSelected() && licence.getType() == Licence.TYPE_ACTIVE) activeRadioButton.setSelected(true);
      if (activeRadioButton.isSelected() && licence.getType() == Licence.TYPE_PHYSICAL) physicalRadioButton.setSelected(true);
    }
  }//GEN-LAST:event_typeRadioButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton OKButton;
  private javax.swing.JRadioButton activeRadioButton;
  private javax.swing.JButton cancelButton;
  private javax.swing.JLabel copiesLabel;
  private javax.swing.JTextField copiesTextField;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JTextArea licenceTextTextArea;
  private javax.swing.JRadioButton physicalRadioButton;
  private javax.swing.JLabel textLabel;
  private javax.swing.ButtonGroup typeButtonGroup;
  private javax.swing.JLabel typeLabel;
  private javax.swing.JLabel validFromLabel;
  private javax.swing.JTextField validFromTextField;
  private javax.swing.JLabel validToLabel;
  private javax.swing.JTextField validToTextField;
  // End of variables declaration//GEN-END:variables
  
}
