/*
 * LocalInfosPanel.java
 *
 * Created on 17. kvten 2004, 14:09
 */

package SOFA.SOFAnet.Browser;

import javax.swing.*;
import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.LocalInfo;
import SOFA.SOFAnet.Repository.BundleContent;
import java.rmi.RemoteException;
import java.util.Arrays;

/**
 *
 * @author  Ladislav Sobr
 */
public class LocalInfosPanel extends javax.swing.JPanel
{
  private RMIAdminInterface admin;
  private DefaultListModel content;
  
  /** Creates new form LocalInfosPanel */
  public LocalInfosPanel(RMIAdminInterface admin)
  {
    this.admin = admin;
    content = new DefaultListModel();
    initComponents();
  }

  private void reload()
  {
    content.clear();
    
    LocalInfoDesc[] localInfoDescs = null;
    try
    {
      localInfoDescs = admin.localInfoDescsList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    Arrays.sort(localInfoDescs);
    
    content.ensureCapacity(localInfoDescs.length);
    for (int i = 0; i < localInfoDescs.length; i++) content.addElement(localInfoDescs[i]);
  }
  
  private String getSelectedBundleName()
  {
    String bundleName = "";

    int index = contentList.getSelectedIndex();
    if (index != -1) bundleName = ((LocalInfoDesc)content.getElementAt(index)).bundleName;
    return bundleName;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel3 = new javax.swing.JPanel();
    installedCheckBox = new javax.swing.JCheckBox();
    shareManagerCheckBox = new javax.swing.JCheckBox();
    shareClientCheckBox = new javax.swing.JCheckBox();
    jPanel2 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    showButton = new javax.swing.JButton();
    installButton = new javax.swing.JButton();
    uninstallButton = new javax.swing.JButton();
    createBinaryBundleButton = new javax.swing.JButton();
    shareButton = new javax.swing.JButton();
    unshareBundleButton = new javax.swing.JButton();
    stopShareClientButton = new javax.swing.JButton();
    makeBundleInSharingPresentButton = new javax.swing.JButton();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    refreshButton = new javax.swing.JButton();
    install2Button = new javax.swing.JButton();
    share2Button = new javax.swing.JButton();
    acquireSharedBundleButton = new javax.swing.JButton();
    searchBundleButton = new javax.swing.JButton();
    createUserBundleButton = new javax.swing.JButton();
    createComponentBundleButton = new javax.swing.JButton();
    jScrollPane1 = new javax.swing.JScrollPane();
    contentList = new javax.swing.JList();

    setLayout(new java.awt.BorderLayout());

    addComponentListener(new java.awt.event.ComponentAdapter()
    {
      public void componentShown(java.awt.event.ComponentEvent evt)
      {
        formComponentShown(evt);
      }
    });

    jPanel3.setLayout(new java.awt.GridLayout(1, 0));

    jPanel3.setBorder(new javax.swing.border.TitledBorder("Bundle State Info"));
    installedCheckBox.setText("Installed");
    installedCheckBox.setBorderPaintedFlat(true);
    installedCheckBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        CheckBoxNoChangeAction(evt);
      }
    });

    jPanel3.add(installedCheckBox);

    shareManagerCheckBox.setText("Share Manager");
    shareManagerCheckBox.setBorderPaintedFlat(true);
    shareManagerCheckBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        CheckBoxNoChangeAction(evt);
      }
    });

    jPanel3.add(shareManagerCheckBox);

    shareClientCheckBox.setText("Share Client");
    shareClientCheckBox.setBorderPaintedFlat(true);
    shareClientCheckBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        CheckBoxNoChangeAction(evt);
      }
    });

    jPanel3.add(shareClientCheckBox);

    add(jPanel3, java.awt.BorderLayout.SOUTH);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel2.setPreferredSize(new java.awt.Dimension(200, 404));
    jPanel4.setLayout(new java.awt.GridLayout(8, 0));

    jPanel4.setBorder(new javax.swing.border.TitledBorder("Local Info Specific"));
    showButton.setText("Show Local Info");
    showButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        showButtonActionPerformed(evt);
      }
    });

    jPanel4.add(showButton);

    installButton.setText("Install Bundle");
    installButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        installButtonActionPerformed(evt);
      }
    });

    jPanel4.add(installButton);

    uninstallButton.setText("Uninstall Bundle");
    uninstallButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        uninstallButtonActionPerformed(evt);
      }
    });

    jPanel4.add(uninstallButton);

    createBinaryBundleButton.setText("Create Binary Bundle");
    createBinaryBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createBinaryBundleButtonActionPerformed(evt);
      }
    });

    jPanel4.add(createBinaryBundleButton);

    shareButton.setText("Share Bundle");
    shareButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        shareButtonActionPerformed(evt);
      }
    });

    jPanel4.add(shareButton);

    unshareBundleButton.setText("Unshare Bundle");
    unshareBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        unshareBundleButtonActionPerformed(evt);
      }
    });

    jPanel4.add(unshareBundleButton);

    stopShareClientButton.setText("Stop Share Client");
    stopShareClientButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        stopShareClientButtonActionPerformed(evt);
      }
    });

    jPanel4.add(stopShareClientButton);

    makeBundleInSharingPresentButton.setText("Make Bundle In Sharing Present");
    makeBundleInSharingPresentButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        makeBundleInSharingPresentButtonActionPerformed(evt);
      }
    });

    jPanel4.add(makeBundleInSharingPresentButton);

    jPanel2.add(jPanel4, java.awt.BorderLayout.NORTH);

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.TitledBorder("General"));
    jPanel5.setLayout(new java.awt.GridLayout(7, 0));

    refreshButton.setText("Refresh");
    refreshButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        refreshButtonActionPerformed(evt);
      }
    });

    jPanel5.add(refreshButton);

    install2Button.setText("Install Bundle");
    install2Button.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        install2ButtonActionPerformed(evt);
      }
    });

    jPanel5.add(install2Button);

    share2Button.setText("Share Bundle");
    share2Button.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        share2ButtonActionPerformed(evt);
      }
    });

    jPanel5.add(share2Button);

    acquireSharedBundleButton.setText("Acquire Shared Bundle");
    acquireSharedBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        acquireSharedBundleButtonActionPerformed(evt);
      }
    });

    jPanel5.add(acquireSharedBundleButton);

    searchBundleButton.setText("Search Bundle");
    searchBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        searchBundleButtonActionPerformed(evt);
      }
    });

    jPanel5.add(searchBundleButton);

    createUserBundleButton.setText("Create User Bundle");
    createUserBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createUserBundleButtonActionPerformed(evt);
      }
    });

    jPanel5.add(createUserBundleButton);

    createComponentBundleButton.setText("Create Component Bundle");
    createComponentBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createComponentBundleButtonActionPerformed(evt);
      }
    });

    jPanel5.add(createComponentBundleButton);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    jPanel2.add(jPanel1, java.awt.BorderLayout.CENTER);

    add(jPanel2, java.awt.BorderLayout.EAST);

    contentList.setModel(content);
    contentList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    contentList.setVisibleRowCount(-1);
    contentList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
    {
      public void valueChanged(javax.swing.event.ListSelectionEvent evt)
      {
        contentListValueChanged(evt);
      }
    });
    contentList.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseClicked(java.awt.event.MouseEvent evt)
      {
        contentListMouseClicked(evt);
      }
    });

    jScrollPane1.setViewportView(contentList);

    add(jScrollPane1, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents

  private void makeBundleInSharingPresentButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_makeBundleInSharingPresentButtonActionPerformed
  {//GEN-HEADEREND:event_makeBundleInSharingPresentButtonActionPerformed
    String bundleName = "";
    boolean isShareManager = true;
    
    int index = contentList.getSelectedIndex();
    if (index != -1)
    {
      LocalInfoDesc localInfoDesc = (LocalInfoDesc)content.getElementAt(index);
      
      if (!localInfoDesc.isInSharing())
      {
        JOptionPane.showMessageDialog(this, "Selected bundle has neither Share Manager nor Share Client active", "Warning", JOptionPane.WARNING_MESSAGE);
        return;
      }
      
      bundleName = localInfoDesc.bundleName;
      isShareManager = localInfoDesc.isShareManager();
    }

    if (MakeBundleInSharingPresentDialog.showDialog(this, admin, bundleName, isShareManager)) reload();
  }//GEN-LAST:event_makeBundleInSharingPresentButtonActionPerformed

  private void contentListMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_contentListMouseClicked
  {//GEN-HEADEREND:event_contentListMouseClicked
    if (evt.getClickCount() == 2)
    {
      showButton.doClick(); //emulate button click
    }
  }//GEN-LAST:event_contentListMouseClicked

  private void stopShareClientButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_stopShareClientButtonActionPerformed
  {//GEN-HEADEREND:event_stopShareClientButtonActionPerformed
    if (StopShareClientDialog.showDialog(this, admin, getSelectedBundleName())) reload();
  }//GEN-LAST:event_stopShareClientButtonActionPerformed

  private void unshareBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_unshareBundleButtonActionPerformed
  {//GEN-HEADEREND:event_unshareBundleButtonActionPerformed
    if (UnshareBundleDialog.showDialog(this, admin, getSelectedBundleName())) reload();
  }//GEN-LAST:event_unshareBundleButtonActionPerformed

  private void shareButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_shareButtonActionPerformed
  {//GEN-HEADEREND:event_shareButtonActionPerformed
    if (ShareBundleDialog.showDialog(this, admin, getSelectedBundleName())) reload();
  }//GEN-LAST:event_shareButtonActionPerformed

  private void createComponentBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createComponentBundleButtonActionPerformed
  {//GEN-HEADEREND:event_createComponentBundleButtonActionPerformed
    if (CreateComponentBundleDialog.showDialog(this, admin, "")) reload();
  }//GEN-LAST:event_createComponentBundleButtonActionPerformed

  private void createUserBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createUserBundleButtonActionPerformed
  {//GEN-HEADEREND:event_createUserBundleButtonActionPerformed
    if (CreateUserBundleDialog.showDialog(this, admin, "", null)) reload();
  }//GEN-LAST:event_createUserBundleButtonActionPerformed

  private void createBinaryBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createBinaryBundleButtonActionPerformed
  {//GEN-HEADEREND:event_createBinaryBundleButtonActionPerformed
    if (CreateBinaryBundleDialog.showDialog(this, admin, getSelectedBundleName())) reload();
  }//GEN-LAST:event_createBinaryBundleButtonActionPerformed

  private void uninstallButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_uninstallButtonActionPerformed
  {//GEN-HEADEREND:event_uninstallButtonActionPerformed
    if (UninstallBundleDialog.showDialog(this, admin, getSelectedBundleName())) reload();
  }//GEN-LAST:event_uninstallButtonActionPerformed

  private void installButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_installButtonActionPerformed
  {//GEN-HEADEREND:event_installButtonActionPerformed
    if (InstallBundleDialog.showDialog(this, admin, getSelectedBundleName())) reload();
  }//GEN-LAST:event_installButtonActionPerformed

  private void showButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_showButtonActionPerformed
  {//GEN-HEADEREND:event_showButtonActionPerformed
    String bundleName = getSelectedBundleName();
    
    if (bundleName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "No Local Info selected", "Warning", JOptionPane.WARNING_MESSAGE);
      return;
    }
    
    LocalInfo localInfo = null;
    BundleContent bundleContent = null;
    try
    {
      localInfo = admin.getLocalInfo(bundleName);
      if (localInfo.isInstalled()) bundleContent = admin.getInstalledBundleContent(bundleName);
      else if (localInfo.isInSharing()) bundleContent = admin.getSharedBundleContent(bundleName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    if (localInfo == null)
    {
      JOptionPane.showMessageDialog(this, "Selected Local Info doesn't exist on the node anymore", "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    LocalInfoDialog.showDialog(this, localInfo, bundleContent);
  }//GEN-LAST:event_showButtonActionPerformed

  private void searchBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_searchBundleButtonActionPerformed
  {//GEN-HEADEREND:event_searchBundleButtonActionPerformed
    SearchDialog.showDialog(this, admin);
    reload();
  }//GEN-LAST:event_searchBundleButtonActionPerformed

  private void acquireSharedBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_acquireSharedBundleButtonActionPerformed
  {//GEN-HEADEREND:event_acquireSharedBundleButtonActionPerformed
    if (AcquireSharedBundleDialog.showDialog(this, admin, "", "")) reload();
  }//GEN-LAST:event_acquireSharedBundleButtonActionPerformed

  private void share2ButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_share2ButtonActionPerformed
  {//GEN-HEADEREND:event_share2ButtonActionPerformed
    if (ShareBundleDialog.showDialog(this, admin, "")) reload();
  }//GEN-LAST:event_share2ButtonActionPerformed

  private void install2ButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_install2ButtonActionPerformed
  {//GEN-HEADEREND:event_install2ButtonActionPerformed
    if (InstallBundleDialog.showDialog(this, admin, "")) reload();
  }//GEN-LAST:event_install2ButtonActionPerformed

  private void refreshButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_refreshButtonActionPerformed
  {//GEN-HEADEREND:event_refreshButtonActionPerformed
    reload();
  }//GEN-LAST:event_refreshButtonActionPerformed

  private void formComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_formComponentShown
  {//GEN-HEADEREND:event_formComponentShown
    reload();
  }//GEN-LAST:event_formComponentShown

  private void contentListValueChanged(javax.swing.event.ListSelectionEvent evt)//GEN-FIRST:event_contentListValueChanged
  {//GEN-HEADEREND:event_contentListValueChanged
    int index = contentList.getSelectedIndex();
    LocalInfoDesc localInfoDesc = null;
    if (index != -1) localInfoDesc = (LocalInfoDesc)content.getElementAt(index);
    
    if (localInfoDesc != null)
    {
      installedCheckBox.setSelected(localInfoDesc.isInstalled());
      shareManagerCheckBox.setSelected(localInfoDesc.isShareManager());
      shareClientCheckBox.setSelected(localInfoDesc.isShareClient());
    }
    else
    {
      installedCheckBox.setSelected(false);
      shareManagerCheckBox.setSelected(false);
      shareClientCheckBox.setSelected(false);
    }
  }//GEN-LAST:event_contentListValueChanged

  private void CheckBoxNoChangeAction(java.awt.event.ActionEvent evt)//GEN-FIRST:event_CheckBoxNoChangeAction
  {//GEN-HEADEREND:event_CheckBoxNoChangeAction
    JCheckBox checkBox = (JCheckBox)evt.getSource();
    checkBox.setSelected(!checkBox.isSelected());
  }//GEN-LAST:event_CheckBoxNoChangeAction
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton acquireSharedBundleButton;
  private javax.swing.JList contentList;
  private javax.swing.JButton createBinaryBundleButton;
  private javax.swing.JButton createComponentBundleButton;
  private javax.swing.JButton createUserBundleButton;
  private javax.swing.JButton install2Button;
  private javax.swing.JButton installButton;
  private javax.swing.JCheckBox installedCheckBox;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JButton makeBundleInSharingPresentButton;
  private javax.swing.JButton refreshButton;
  private javax.swing.JButton searchBundleButton;
  private javax.swing.JButton share2Button;
  private javax.swing.JButton shareButton;
  private javax.swing.JCheckBox shareClientCheckBox;
  private javax.swing.JCheckBox shareManagerCheckBox;
  private javax.swing.JButton showButton;
  private javax.swing.JButton stopShareClientButton;
  private javax.swing.JButton uninstallButton;
  private javax.swing.JButton unshareBundleButton;
  // End of variables declaration//GEN-END:variables
  
}
