/*
 * MakeBundleInSharingPresentDialog.java
 *
 * Created on 10. kvten 2004, 22:42
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.BundleInfo;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class MakeBundleInSharingPresentDialog extends javax.swing.JDialog
{
  private RMIAdminInterface admin;
  private boolean isOK;
  
  public static boolean showDialog(Component frameComp, RMIAdminInterface admin, String defaultBundleName, boolean isShareManager)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    MakeBundleInSharingPresentDialog dialog = new MakeBundleInSharingPresentDialog(frame, true, admin, defaultBundleName, isShareManager);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form MakeBundleInSharingPresentDialog */
  public MakeBundleInSharingPresentDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin, String defaultBundleName, boolean isShareManager)
  {
    super(parent, modal);
    this.admin = admin;
    isOK = false;
    initComponents();
    
    bundleNameTextField.setText(defaultBundleName);
    if (isShareManager) shareManagerRadioButton.setSelected(true);
    else shareClientRadioButton.setSelected(true);
  }
  
  public boolean isOK()
  {
    return isOK;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    buttonGroup = new javax.swing.ButtonGroup();
    jPanel4 = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    bundleNameLabel = new javax.swing.JLabel();
    bundleNameTextField = new javax.swing.JTextField();
    shareManagerRadioButton = new javax.swing.JRadioButton();
    shareClientRadioButton = new javax.swing.JRadioButton();
    jPanel2 = new javax.swing.JPanel();
    chooseShareManagerButton = new javax.swing.JButton();
    chooseShareClientButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    makeBundlePresentButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Make Bundle In Sharing Present");
    jPanel4.setLayout(new java.awt.BorderLayout());

    jPanel4.setMinimumSize(new java.awt.Dimension(400, 93));
    jPanel4.setPreferredSize(new java.awt.Dimension(400, 180));
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 10, 1, 10)));
    jPanel1.setMinimumSize(new java.awt.Dimension(26, 23));
    jPanel1.setPreferredSize(new java.awt.Dimension(26, 23));
    jPanel5.setLayout(new java.awt.GridLayout(4, 0));

    bundleNameLabel.setText("Bundle Name:");
    jPanel5.add(bundleNameLabel);

    bundleNameTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    bundleNameTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(bundleNameTextField);

    shareManagerRadioButton.setSelected(true);
    shareManagerRadioButton.setText("Share Manager");
    buttonGroup.add(shareManagerRadioButton);
    jPanel5.add(shareManagerRadioButton);

    shareClientRadioButton.setText("Share Client");
    buttonGroup.add(shareClientRadioButton);
    jPanel5.add(shareClientRadioButton);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    jPanel4.add(jPanel1, java.awt.BorderLayout.CENTER);

    chooseShareManagerButton.setText("Choose Share Manager");
    chooseShareManagerButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        chooseShareManagerButtonActionPerformed(evt);
      }
    });

    jPanel2.add(chooseShareManagerButton);

    chooseShareClientButton.setText("Choose Share Client");
    chooseShareClientButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        chooseShareClientButtonActionPerformed(evt);
      }
    });

    jPanel2.add(chooseShareClientButton);

    jPanel4.add(jPanel2, java.awt.BorderLayout.NORTH);

    makeBundlePresentButton.setText("Make Bundle Present");
    makeBundlePresentButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        makeBundlePresentButtonActionPerformed(evt);
      }
    });

    jPanel3.add(makeBundlePresentButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    jPanel4.add(jPanel3, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void chooseShareClientButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_chooseShareClientButtonActionPerformed
  {//GEN-HEADEREND:event_chooseShareClientButtonActionPerformed
    LocalInfoDesc[] localInfoDescs = null;
    try
    {
      localInfoDescs = admin.localInfoDescsList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    int size = 0;
    int i;
    for (i = 0; i < localInfoDescs.length; i++)
    {
      if (localInfoDescs[i].isShareClient()) size++;
    }
    
    LocalInfoDesc[] shareClients = new LocalInfoDesc[size];
    int j = 0;
    for (i = 0; i < localInfoDescs.length; i++)
    {
      if (localInfoDescs[i].isShareClient())
      {
        shareClients[j++] = localInfoDescs[i];
      }
    }

    Arrays.sort(shareClients);
    
    LocalInfoDesc result = (LocalInfoDesc)ListDialog.showDialog(this, this, "Bundles in Share Client Mode:", "Choose Share Client", shareClients, null, null, false, true);
    if (result != null)
    {
      bundleNameTextField.setText(result.bundleName);
      shareClientRadioButton.setSelected(true);
    }    
  }//GEN-LAST:event_chooseShareClientButtonActionPerformed

  private void chooseShareManagerButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_chooseShareManagerButtonActionPerformed
  {//GEN-HEADEREND:event_chooseShareManagerButtonActionPerformed
    LocalInfoDesc[] localInfoDescs = null;
    try
    {
      localInfoDescs = admin.localInfoDescsList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    int size = 0;
    int i;
    for (i = 0; i < localInfoDescs.length; i++)
    {
      if (localInfoDescs[i].isShareManager()) size++;
    }
    
    LocalInfoDesc[] shareManagers = new LocalInfoDesc[size];
    int j = 0;
    for (i = 0; i < localInfoDescs.length; i++)
    {
      if (localInfoDescs[i].isShareManager())
      {
        shareManagers[j++] = localInfoDescs[i];
      }
    }

    Arrays.sort(shareManagers);
    
    LocalInfoDesc result = (LocalInfoDesc)ListDialog.showDialog(this, this, "Bundles in Share Manager Mode:", "Choose Share Manager", shareManagers, null, null, false, true);
    if (result != null)
    {
      bundleNameTextField.setText(result.bundleName);
      shareManagerRadioButton.setSelected(true);
    }
  }//GEN-LAST:event_chooseShareManagerButtonActionPerformed

  private void makeBundlePresentButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_makeBundlePresentButtonActionPerformed
  {//GEN-HEADEREND:event_makeBundlePresentButtonActionPerformed
    String bundleName = bundleNameTextField.getText();
    boolean isShareManager = shareManagerRadioButton.isSelected();

    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromBundleName(bundleName);
    }
    catch (BundleInfo.InvalidBundleNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    try
    {
      if (isShareManager) admin.makeShareClientsReturnBundle(bundleName);
      else admin.acquireSharedBundle(bundleName, null, false);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    
    JOptionPane.showMessageDialog(this, "Bundle '" + bundleName + "' successfully made present");
    
    isOK = true;
    dispose();
  }//GEN-LAST:event_makeBundlePresentButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel bundleNameLabel;
  private javax.swing.JTextField bundleNameTextField;
  private javax.swing.ButtonGroup buttonGroup;
  private javax.swing.JButton cancelButton;
  private javax.swing.JButton chooseShareClientButton;
  private javax.swing.JButton chooseShareManagerButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JButton makeBundlePresentButton;
  private javax.swing.JRadioButton shareClientRadioButton;
  private javax.swing.JRadioButton shareManagerRadioButton;
  // End of variables declaration//GEN-END:variables
  
}
