/*
 * NodeNameLicListEditDialog.java
 *
 * Created on 12. kvten 2004, 22:35
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Repository.NodeNameLicList;
import java.util.*;
import javax.swing.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class NodeNameLicListEditDialog extends javax.swing.JDialog
{
  private boolean isOK;
  private NodeNameLicList nodeNameLicList;
  private DefaultListModel content;
  
  public static boolean showDialog(Component frameComp, NodeNameLicList nodeNameLicList, String title)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    NodeNameLicListEditDialog dialog = new NodeNameLicListEditDialog(frame, true, nodeNameLicList, title);
    dialog.setVisible(true);
    return dialog.isOK();
    
  }
  /** Creates new form NodeNameLicListEditDialog */
  public NodeNameLicListEditDialog(java.awt.Frame parent, boolean modal, NodeNameLicList nodeNameLicList, String title)
  {
    super(parent, modal);
    this.nodeNameLicList = nodeNameLicList;
    
    isOK = false;
    content = new DefaultListModel();
    
    content.ensureCapacity(nodeNameLicList.getList().size());
    Iterator it = nodeNameLicList.getList().iterator();
    while (it.hasNext()) content.addElement(((NodeNameLicList.NodeLicPair)it.next()).clone());
    
    initComponents();
    setLocationRelativeTo(parent);
    setTitle(title);
    
    jLabel.setText("Node Name - Licence List");
  }
  
  public boolean isOK()
  {
    return isOK;
  }
  
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jScrollPane1 = new javax.swing.JScrollPane();
    jList = new javax.swing.JList();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    setButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();
    jPanel2 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    addButton = new javax.swing.JButton();
    deleteSelectedButton = new javax.swing.JButton();
    moveUpButton = new javax.swing.JButton();
    moveDownButton = new javax.swing.JButton();
    jPanel4 = new javax.swing.JPanel();
    jLabel = new javax.swing.JLabel();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    jScrollPane1.setMinimumSize(new java.awt.Dimension(260, 132));
    jList.setModel(content);
    jScrollPane1.setViewportView(jList);

    getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setMinimumSize(new java.awt.Dimension(250, 35));
    jPanel1.setPreferredSize(new java.awt.Dimension(250, 35));
    setButton.setText("Set");
    setButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        setButtonActionPerformed(evt);
      }
    });

    jPanel5.add(setButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel5.add(cancelButton);

    jPanel1.add(jPanel5, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel3.setLayout(new java.awt.GridLayout(4, 0));

    jPanel3.setBorder(new javax.swing.border.TitledBorder("Edit"));
    addButton.setText("Add");
    addButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        addButtonActionPerformed(evt);
      }
    });

    jPanel3.add(addButton);

    deleteSelectedButton.setText("Delete Selected");
    deleteSelectedButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteSelectedButtonActionPerformed(evt);
      }
    });

    jPanel3.add(deleteSelectedButton);

    moveUpButton.setText("Move Up");
    moveUpButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        moveUpButtonActionPerformed(evt);
      }
    });

    jPanel3.add(moveUpButton);

    moveDownButton.setText("Move Down");
    moveDownButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        moveDownButtonActionPerformed(evt);
      }
    });

    jPanel3.add(moveDownButton);

    jPanel2.add(jPanel3, java.awt.BorderLayout.NORTH);

    getContentPane().add(jPanel2, java.awt.BorderLayout.EAST);

    jPanel4.setLayout(new java.awt.GridLayout(1, 0));

    jPanel4.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(3, 1, 1, 1)));
    jPanel4.setMinimumSize(new java.awt.Dimension(350, 19));
    jPanel4.setPreferredSize(new java.awt.Dimension(350, 19));
    jLabel.setText("String List:");
    jPanel4.add(jLabel);

    getContentPane().add(jPanel4, java.awt.BorderLayout.NORTH);

    pack();
  }//GEN-END:initComponents

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed

  private void setButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_setButtonActionPerformed
  {//GEN-HEADEREND:event_setButtonActionPerformed
    nodeNameLicList.getList().clear();
    Enumeration en = content.elements();
    while (en.hasMoreElements()) nodeNameLicList.add((NodeNameLicList.NodeLicPair)en.nextElement());
    isOK = true;
    dispose();
  }//GEN-LAST:event_setButtonActionPerformed

  private void moveDownButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_moveDownButtonActionPerformed
  {//GEN-HEADEREND:event_moveDownButtonActionPerformed
    int i = jList.getSelectedIndex();
    if (i == -1 || i >= content.size() - 1) return;
    
    Object o1 = content.getElementAt(i);
    Object o2 = content.getElementAt(i + 1);
    content.setElementAt(o2, i);
    content.setElementAt(o1, i + 1);
    jList.setSelectedIndex(i + 1);
  }//GEN-LAST:event_moveDownButtonActionPerformed

  private void moveUpButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_moveUpButtonActionPerformed
  {//GEN-HEADEREND:event_moveUpButtonActionPerformed
    int i = jList.getSelectedIndex();
    if (i == -1 || i == 0) return;
    
    Object o1 = content.getElementAt(i);
    Object o2 = content.getElementAt(i - 1);
    content.setElementAt(o2, i);
    content.setElementAt(o1, i - 1);
    jList.setSelectedIndex(i - 1);
  }//GEN-LAST:event_moveUpButtonActionPerformed

  private void deleteSelectedButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteSelectedButtonActionPerformed
  {//GEN-HEADEREND:event_deleteSelectedButtonActionPerformed
    Object[] selected = jList.getSelectedValues();
    for (int i = 0; i < selected.length; i++)
    {
      content.removeElement(selected[i]);
    }
  }//GEN-LAST:event_deleteSelectedButtonActionPerformed

  private void addButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_addButtonActionPerformed
  {//GEN-HEADEREND:event_addButtonActionPerformed
    NodeNameLicList.NodeLicPair nodeLicPair = NewNodeNameLicDialog.showDialog(this);
    if (nodeLicPair != null) content.addElement(nodeLicPair);
  }//GEN-LAST:event_addButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton addButton;
  private javax.swing.JButton cancelButton;
  private javax.swing.JButton deleteSelectedButton;
  private javax.swing.JLabel jLabel;
  private javax.swing.JList jList;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JButton moveDownButton;
  private javax.swing.JButton moveUpButton;
  private javax.swing.JButton setButton;
  // End of variables declaration//GEN-END:variables
  
}
