/*
 * OperationsPanel.java
 *
 * Created on 10. kvten 2004, 17:17
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import javax.swing.*;

import SOFA.SOFAnet.Search.RMI.RMISearchConfiguration;
import java.awt.Frame;
import java.rmi.RemoteException;

/**
 *
 * @author  Ladislav Sobr
 */
public class OperationsPanel extends javax.swing.JPanel
{
  private RMIAdminInterface admin;
  
  /** Creates new form OperationsPanel */
  public OperationsPanel(RMIAdminInterface admin)
  {
    this.admin = admin;
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel1 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    installBundleButton = new javax.swing.JButton();
    uninstallBundleButton = new javax.swing.JButton();
    createBinaryBundleButton = new javax.swing.JButton();
    deleteBinaryBundleButton = new javax.swing.JButton();
    createUserBundleButton = new javax.swing.JButton();
    createComponentBundleButton = new javax.swing.JButton();
    jPanel2 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    testPushBundleButton = new javax.swing.JButton();
    testPullBundleButton = new javax.swing.JButton();
    pushBundleButton = new javax.swing.JButton();
    pullBundleButton = new javax.swing.JButton();
    createBundleOfferButton = new javax.swing.JButton();
    testPushBundleOfferButton = new javax.swing.JButton();
    pushBundleOfferButton = new javax.swing.JButton();
    generateTriggersOfContractButton = new javax.swing.JButton();
    deleteTriggersOfContractButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    jPanel6 = new javax.swing.JPanel();
    shareBundleButton = new javax.swing.JButton();
    unshareBundleButton = new javax.swing.JButton();
    acquireSharedBundleButton = new javax.swing.JButton();
    stopShareClientButton = new javax.swing.JButton();
    makeBundleInSharingPresentButton = new javax.swing.JButton();
    searchBundleButton = new javax.swing.JButton();
    editSearchNetConfigurationButton = new javax.swing.JButton();
    applySearchNetConfiguration = new javax.swing.JButton();

    setLayout(new java.awt.GridLayout(1, 0));

    setPreferredSize(new java.awt.Dimension(700, 500));
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.TitledBorder("Local"));
    jPanel4.setLayout(new java.awt.GridLayout(6, 0));

    installBundleButton.setText("Install Bundle");
    installBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        installBundleButtonActionPerformed(evt);
      }
    });

    jPanel4.add(installBundleButton);

    uninstallBundleButton.setText("Uninstall Bundle");
    uninstallBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        uninstallBundleButtonActionPerformed(evt);
      }
    });

    jPanel4.add(uninstallBundleButton);

    createBinaryBundleButton.setText("Create Binary Bundle");
    createBinaryBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createBinaryBundleButtonActionPerformed(evt);
      }
    });

    jPanel4.add(createBinaryBundleButton);

    deleteBinaryBundleButton.setText("Delete Binary Bundle");
    deleteBinaryBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteBinaryBundleButtonActionPerformed(evt);
      }
    });

    jPanel4.add(deleteBinaryBundleButton);

    createUserBundleButton.setText("Create User Bundle");
    createUserBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createUserBundleButtonActionPerformed(evt);
      }
    });

    jPanel4.add(createUserBundleButton);

    createComponentBundleButton.setText("Create Component Bundle");
    createComponentBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createComponentBundleButtonActionPerformed(evt);
      }
    });

    jPanel4.add(createComponentBundleButton);

    jPanel1.add(jPanel4, java.awt.BorderLayout.NORTH);

    add(jPanel1);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel2.setBorder(new javax.swing.border.TitledBorder("Network"));
    jPanel5.setLayout(new java.awt.GridLayout(9, 0));

    testPushBundleButton.setText("Test Push Bundle");
    testPushBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        testPushBundleButtonActionPerformed(evt);
      }
    });

    jPanel5.add(testPushBundleButton);

    testPullBundleButton.setText("Test Pull Bundle");
    testPullBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        testPullBundleButtonActionPerformed(evt);
      }
    });

    jPanel5.add(testPullBundleButton);

    pushBundleButton.setText("Push Bundle");
    pushBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        pushBundleButtonActionPerformed(evt);
      }
    });

    jPanel5.add(pushBundleButton);

    pullBundleButton.setText("Pull Bundle");
    pullBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        pullBundleButtonActionPerformed(evt);
      }
    });

    jPanel5.add(pullBundleButton);

    createBundleOfferButton.setText("Create Bundle Offer");
    createBundleOfferButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createBundleOfferButtonActionPerformed(evt);
      }
    });

    jPanel5.add(createBundleOfferButton);

    testPushBundleOfferButton.setText("Test Push Bundle Offer");
    testPushBundleOfferButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        testPushBundleOfferButtonActionPerformed(evt);
      }
    });

    jPanel5.add(testPushBundleOfferButton);

    pushBundleOfferButton.setText("Push Bundle Offer");
    pushBundleOfferButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        pushBundleOfferButtonActionPerformed(evt);
      }
    });

    jPanel5.add(pushBundleOfferButton);

    generateTriggersOfContractButton.setText("Generate Triggers of Contract");
    generateTriggersOfContractButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        generateTriggersOfContractButtonActionPerformed(evt);
      }
    });

    jPanel5.add(generateTriggersOfContractButton);

    deleteTriggersOfContractButton.setText("Delete Triggers of Contract");
    deleteTriggersOfContractButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteTriggersOfContractButtonActionPerformed(evt);
      }
    });

    jPanel5.add(deleteTriggersOfContractButton);

    jPanel2.add(jPanel5, java.awt.BorderLayout.NORTH);

    add(jPanel2);

    jPanel3.setLayout(new java.awt.BorderLayout());

    jPanel3.setBorder(new javax.swing.border.TitledBorder("Sharing & Searching"));
    jPanel6.setLayout(new java.awt.GridLayout(8, 0));

    shareBundleButton.setText("Share Bundle");
    shareBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        shareBundleButtonActionPerformed(evt);
      }
    });

    jPanel6.add(shareBundleButton);

    unshareBundleButton.setText("Unshare Bundle");
    unshareBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        unshareBundleButtonActionPerformed(evt);
      }
    });

    jPanel6.add(unshareBundleButton);

    acquireSharedBundleButton.setText("Acquire Shared Bundle");
    acquireSharedBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        acquireSharedBundleButtonActionPerformed(evt);
      }
    });

    jPanel6.add(acquireSharedBundleButton);

    stopShareClientButton.setText("Stop Share Client");
    stopShareClientButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        stopShareClientButtonActionPerformed(evt);
      }
    });

    jPanel6.add(stopShareClientButton);

    makeBundleInSharingPresentButton.setText("Make Bundle In Sharing Present");
    makeBundleInSharingPresentButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        makeBundleInSharingPresentButtonActionPerformed(evt);
      }
    });

    jPanel6.add(makeBundleInSharingPresentButton);

    searchBundleButton.setText("Search Bundle");
    searchBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        searchBundleButtonActionPerformed(evt);
      }
    });

    jPanel6.add(searchBundleButton);

    editSearchNetConfigurationButton.setText("Edit SearchNet Configuration");
    editSearchNetConfigurationButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        editSearchNetConfigurationButtonActionPerformed(evt);
      }
    });

    jPanel6.add(editSearchNetConfigurationButton);

    applySearchNetConfiguration.setText("Apply SearchNet Configuration");
    applySearchNetConfiguration.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        applySearchNetConfigurationActionPerformed(evt);
      }
    });

    jPanel6.add(applySearchNetConfiguration);

    jPanel3.add(jPanel6, java.awt.BorderLayout.NORTH);

    add(jPanel3);

  }//GEN-END:initComponents

  private void makeBundleInSharingPresentButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_makeBundleInSharingPresentButtonActionPerformed
  {//GEN-HEADEREND:event_makeBundleInSharingPresentButtonActionPerformed
    MakeBundleInSharingPresentDialog.showDialog(this, admin, "", true);
  }//GEN-LAST:event_makeBundleInSharingPresentButtonActionPerformed

  private void applySearchNetConfigurationActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_applySearchNetConfigurationActionPerformed
  {//GEN-HEADEREND:event_applySearchNetConfigurationActionPerformed
    try
    {
      admin.applyRMISearchConfiguration();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    JOptionPane.showMessageDialog(this, "SearchNet conenctions created using actual configuration of SearchNet");
  }//GEN-LAST:event_applySearchNetConfigurationActionPerformed

  private void editSearchNetConfigurationButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_editSearchNetConfigurationButtonActionPerformed
  {//GEN-HEADEREND:event_editSearchNetConfigurationButtonActionPerformed
    RMISearchConfiguration configuration = null;
    try
    {
      configuration = admin.getRMISearchConfiguration();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    Frame frame = JOptionPane.getFrameForComponent(this);
    RMISearchConfigurationEditDialog dialog = new RMISearchConfigurationEditDialog(frame, true, configuration);
    dialog.setLocationRelativeTo(this);
    dialog.setVisible(true);
    
    if (dialog.isOK())
    {
      try
      {
        admin.setRMISearchConfiguration(configuration);
        if (dialog.apply()) admin.applyRMISearchConfiguration();
      }
      catch (RemoteException e)
      {
        JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
    }    
  }//GEN-LAST:event_editSearchNetConfigurationButtonActionPerformed

  private void deleteTriggersOfContractButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteTriggersOfContractButtonActionPerformed
  {//GEN-HEADEREND:event_deleteTriggersOfContractButtonActionPerformed
    DeleteTriggersOfContractDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_deleteTriggersOfContractButtonActionPerformed

  private void generateTriggersOfContractButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_generateTriggersOfContractButtonActionPerformed
  {//GEN-HEADEREND:event_generateTriggersOfContractButtonActionPerformed
    GenerateTriggersOfContractDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_generateTriggersOfContractButtonActionPerformed

  private void searchBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_searchBundleButtonActionPerformed
  {//GEN-HEADEREND:event_searchBundleButtonActionPerformed
    SearchDialog.showDialog(this, admin);
  }//GEN-LAST:event_searchBundleButtonActionPerformed

  private void stopShareClientButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_stopShareClientButtonActionPerformed
  {//GEN-HEADEREND:event_stopShareClientButtonActionPerformed
    StopShareClientDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_stopShareClientButtonActionPerformed

  private void acquireSharedBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_acquireSharedBundleButtonActionPerformed
  {//GEN-HEADEREND:event_acquireSharedBundleButtonActionPerformed
    AcquireSharedBundleDialog.showDialog(this, admin, "", "");
  }//GEN-LAST:event_acquireSharedBundleButtonActionPerformed

  private void unshareBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_unshareBundleButtonActionPerformed
  {//GEN-HEADEREND:event_unshareBundleButtonActionPerformed
    UnshareBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_unshareBundleButtonActionPerformed

  private void shareBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_shareBundleButtonActionPerformed
  {//GEN-HEADEREND:event_shareBundleButtonActionPerformed
    ShareBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_shareBundleButtonActionPerformed

  private void pushBundleOfferButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_pushBundleOfferButtonActionPerformed
  {//GEN-HEADEREND:event_pushBundleOfferButtonActionPerformed
    PushBundleOfferDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_pushBundleOfferButtonActionPerformed

  private void testPushBundleOfferButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_testPushBundleOfferButtonActionPerformed
  {//GEN-HEADEREND:event_testPushBundleOfferButtonActionPerformed
    TestPushBundleOfferDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_testPushBundleOfferButtonActionPerformed

  private void createBundleOfferButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createBundleOfferButtonActionPerformed
  {//GEN-HEADEREND:event_createBundleOfferButtonActionPerformed
    CreateBundleOfferDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_createBundleOfferButtonActionPerformed

  private void pullBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_pullBundleButtonActionPerformed
  {//GEN-HEADEREND:event_pullBundleButtonActionPerformed
    PullBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_pullBundleButtonActionPerformed

  private void pushBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_pushBundleButtonActionPerformed
  {//GEN-HEADEREND:event_pushBundleButtonActionPerformed
    PushBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_pushBundleButtonActionPerformed

  private void testPullBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_testPullBundleButtonActionPerformed
  {//GEN-HEADEREND:event_testPullBundleButtonActionPerformed
    TestPullBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_testPullBundleButtonActionPerformed

  private void testPushBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_testPushBundleButtonActionPerformed
  {//GEN-HEADEREND:event_testPushBundleButtonActionPerformed
    TestPushBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_testPushBundleButtonActionPerformed

  private void createComponentBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createComponentBundleButtonActionPerformed
  {//GEN-HEADEREND:event_createComponentBundleButtonActionPerformed
    CreateComponentBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_createComponentBundleButtonActionPerformed

  private void createUserBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createUserBundleButtonActionPerformed
  {//GEN-HEADEREND:event_createUserBundleButtonActionPerformed
    CreateUserBundleDialog.showDialog(this, admin, "", null);
  }//GEN-LAST:event_createUserBundleButtonActionPerformed

  private void deleteBinaryBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteBinaryBundleButtonActionPerformed
  {//GEN-HEADEREND:event_deleteBinaryBundleButtonActionPerformed
    DeleteBinaryBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_deleteBinaryBundleButtonActionPerformed

  private void createBinaryBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createBinaryBundleButtonActionPerformed
  {//GEN-HEADEREND:event_createBinaryBundleButtonActionPerformed
    CreateBinaryBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_createBinaryBundleButtonActionPerformed

  private void uninstallBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_uninstallBundleButtonActionPerformed
  {//GEN-HEADEREND:event_uninstallBundleButtonActionPerformed
    UninstallBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_uninstallBundleButtonActionPerformed

  private void installBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_installBundleButtonActionPerformed
  {//GEN-HEADEREND:event_installBundleButtonActionPerformed
    InstallBundleDialog.showDialog(this, admin, "");
  }//GEN-LAST:event_installBundleButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton acquireSharedBundleButton;
  private javax.swing.JButton applySearchNetConfiguration;
  private javax.swing.JButton createBinaryBundleButton;
  private javax.swing.JButton createBundleOfferButton;
  private javax.swing.JButton createComponentBundleButton;
  private javax.swing.JButton createUserBundleButton;
  private javax.swing.JButton deleteBinaryBundleButton;
  private javax.swing.JButton deleteTriggersOfContractButton;
  private javax.swing.JButton editSearchNetConfigurationButton;
  private javax.swing.JButton generateTriggersOfContractButton;
  private javax.swing.JButton installBundleButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JPanel jPanel6;
  private javax.swing.JButton makeBundleInSharingPresentButton;
  private javax.swing.JButton pullBundleButton;
  private javax.swing.JButton pushBundleButton;
  private javax.swing.JButton pushBundleOfferButton;
  private javax.swing.JButton searchBundleButton;
  private javax.swing.JButton shareBundleButton;
  private javax.swing.JButton stopShareClientButton;
  private javax.swing.JButton testPullBundleButton;
  private javax.swing.JButton testPushBundleButton;
  private javax.swing.JButton testPushBundleOfferButton;
  private javax.swing.JButton uninstallBundleButton;
  private javax.swing.JButton unshareBundleButton;
  // End of variables declaration//GEN-END:variables
  
}
