/*
 * InstallBundleDialog.java
 *
 * Created on 10. kvten 2004, 22:42
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.BundleInfo;
import SOFA.SOFAnet.Repository.NodeInfo;
import SOFA.SOFAnet.Repository.Licence;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class PushBundleOfferDialog extends javax.swing.JDialog
{
  private RMIAdminInterface admin;
  private boolean isOK;
  
  public static boolean showDialog(Component frameComp, RMIAdminInterface admin, String defaultBundleName)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    PushBundleOfferDialog dialog = new PushBundleOfferDialog(frame, true, admin, defaultBundleName);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form PushBundleOfferDialog */
  public PushBundleOfferDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin, String defaultBundleName)
  {
    super(parent, modal);
    this.admin = admin;
    isOK = false;
    initComponents();
    
    bundleNameTextField.setText(defaultBundleName);
  }
  
  public boolean isOK()
  {
    return isOK;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel4 = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    bundleNameLabel = new javax.swing.JLabel();
    bundleNameTextField = new javax.swing.JTextField();
    nodeNameLabel = new javax.swing.JLabel();
    nodeNameTextField = new javax.swing.JTextField();
    jPanel2 = new javax.swing.JPanel();
    chooseBundleOfferButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    pushBundleOfferButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Push Bundle Offer");
    jPanel4.setLayout(new java.awt.BorderLayout());

    jPanel4.setMinimumSize(new java.awt.Dimension(400, 93));
    jPanel4.setPreferredSize(new java.awt.Dimension(400, 170));
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 10, 1, 10)));
    jPanel1.setMinimumSize(new java.awt.Dimension(26, 23));
    jPanel1.setPreferredSize(new java.awt.Dimension(26, 23));
    jPanel5.setLayout(new java.awt.GridLayout(4, 0));

    bundleNameLabel.setText("Bundle Offer Name:");
    jPanel5.add(bundleNameLabel);

    bundleNameTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    bundleNameTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(bundleNameTextField);

    nodeNameLabel.setText("Node name:");
    jPanel5.add(nodeNameLabel);

    nodeNameTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    nodeNameTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(nodeNameTextField);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    jPanel4.add(jPanel1, java.awt.BorderLayout.CENTER);

    chooseBundleOfferButton.setText("Choose Bundle Offer");
    chooseBundleOfferButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        chooseBundleOfferButtonActionPerformed(evt);
      }
    });

    jPanel2.add(chooseBundleOfferButton);

    jPanel4.add(jPanel2, java.awt.BorderLayout.NORTH);

    pushBundleOfferButton.setText("Push Bundle Offer");
    pushBundleOfferButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        pushBundleOfferButtonActionPerformed(evt);
      }
    });

    jPanel3.add(pushBundleOfferButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    jPanel4.add(jPanel3, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void chooseBundleOfferButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_chooseBundleOfferButtonActionPerformed
  {//GEN-HEADEREND:event_chooseBundleOfferButtonActionPerformed
    String[] bundles = null;
    try
    {
      bundles = admin.bundleOffersList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    Arrays.sort(bundles);
    
    String result = ListDialog.showDialog(this, this, "Bundle Offers:", "Choose Bundle Offer to Test Push", bundles, null, null, false, true);
    if (result.length() != 0) bundleNameTextField.setText(result);
    
  }//GEN-LAST:event_chooseBundleOfferButtonActionPerformed

  private void pushBundleOfferButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_pushBundleOfferButtonActionPerformed
  {//GEN-HEADEREND:event_pushBundleOfferButtonActionPerformed
    String bundleName = bundleNameTextField.getText();
    String nodeName = nodeNameTextField.getText();

    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromBundleName(bundleName);
    }
    catch (BundleInfo.InvalidBundleNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    NodeInfo nodeInfo = new NodeInfo();
    try
    {
      nodeInfo.setNodeName(nodeName);
    }
    catch (NodeInfo.InvalidNodeNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of SOFA node:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    try
    {
      admin.pushBundleOffer(bundleName, nodeName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    
    JOptionPane.showMessageDialog(this, "Bundle offer '" + bundleName + "' has been scheduled to push to node '" + nodeName + "'");
    
    isOK = true;
    dispose();
  }//GEN-LAST:event_pushBundleOfferButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel bundleNameLabel;
  private javax.swing.JTextField bundleNameTextField;
  private javax.swing.JButton cancelButton;
  private javax.swing.JButton chooseBundleOfferButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JLabel nodeNameLabel;
  private javax.swing.JTextField nodeNameTextField;
  private javax.swing.JButton pushBundleOfferButton;
  // End of variables declaration//GEN-END:variables
  
}
