/*
 * InstallBundleDialog.java
 *
 * Created on 10. kvten 2004, 22:42
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.BundleInfo;
import SOFA.SOFAnet.Repository.Licence;
import SOFA.SOFAnet.Repository.NodeNameFilter;
import SOFA.SOFAnet.Repository.ShareGroups;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class ShareBundleDialog extends javax.swing.JDialog
{
  private RMIAdminInterface admin;
  private NodeNameFilter nodeFilter;
  private ShareGroups shareGroups;
  private boolean isOK;
  
  public static boolean showDialog(Component frameComp, RMIAdminInterface admin, String defaultBundleName)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    ShareBundleDialog dialog = new ShareBundleDialog(frame, true, admin, defaultBundleName);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form ShareBundleDialog */
  public ShareBundleDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin, String defaultBundleName)
  {
    super(parent, modal);
    this.admin = admin;
    isOK = false;
    nodeFilter = new NodeNameFilter();
    shareGroups = new ShareGroups();
    initComponents();
    
    bundleNameTextField.setText(defaultBundleName);
  }
  
  public boolean isOK()
  {
    return isOK;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel4 = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    bundleNameLabel = new javax.swing.JLabel();
    bundleNameTextField = new javax.swing.JTextField();
    numberOfLicencesLabel = new javax.swing.JLabel();
    numberOfLicencesTextField = new javax.swing.JTextField();
    jPanel6 = new javax.swing.JPanel();
    nodeFilterCheckBox = new javax.swing.JCheckBox();
    nodeFilterButton = new javax.swing.JButton();
    jPanel7 = new javax.swing.JPanel();
    shareGroupsCheckBox = new javax.swing.JCheckBox();
    shareGroupsButton = new javax.swing.JButton();
    equalityCheckBox = new javax.swing.JCheckBox();
    reshareCheckBox = new javax.swing.JCheckBox();
    jPanel2 = new javax.swing.JPanel();
    chooseBinaryBundleButton = new javax.swing.JButton();
    chooseInstalledBundleButton = new javax.swing.JButton();
    showLicenceButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    shareButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Share Bundle");
    jPanel4.setLayout(new java.awt.BorderLayout());

    jPanel4.setMinimumSize(new java.awt.Dimension(400, 93));
    jPanel4.setPreferredSize(new java.awt.Dimension(600, 280));
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 10, 1, 10)));
    jPanel1.setMinimumSize(new java.awt.Dimension(26, 23));
    jPanel1.setPreferredSize(new java.awt.Dimension(26, 23));
    jPanel5.setLayout(new java.awt.GridLayout(8, 0));

    bundleNameLabel.setText("Bundle Name:");
    jPanel5.add(bundleNameLabel);

    bundleNameTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    bundleNameTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(bundleNameTextField);

    numberOfLicencesLabel.setText("Number of Licences (use '*' or 'all' or leave empty for ''all'/'no licences'):");
    jPanel5.add(numberOfLicencesLabel);

    numberOfLicencesTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    numberOfLicencesTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(numberOfLicencesTextField);

    jPanel6.setLayout(new javax.swing.BoxLayout(jPanel6, javax.swing.BoxLayout.X_AXIS));

    nodeFilterCheckBox.setText("Node Filter");
    nodeFilterCheckBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        nodeFilterCheckBoxActionPerformed(evt);
      }
    });

    jPanel6.add(nodeFilterCheckBox);

    nodeFilterButton.setText("Edit Node Filter");
    nodeFilterButton.setEnabled(false);
    nodeFilterButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        nodeFilterButtonActionPerformed(evt);
      }
    });

    jPanel6.add(nodeFilterButton);

    jPanel5.add(jPanel6);

    jPanel7.setLayout(new javax.swing.BoxLayout(jPanel7, javax.swing.BoxLayout.X_AXIS));

    shareGroupsCheckBox.setText("Share Groups");
    shareGroupsCheckBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        shareGroupsCheckBoxActionPerformed(evt);
      }
    });

    jPanel7.add(shareGroupsCheckBox);

    shareGroupsButton.setText("Edit Share Groups");
    shareGroupsButton.setEnabled(false);
    shareGroupsButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        shareGroupsButtonActionPerformed(evt);
      }
    });

    jPanel7.add(shareGroupsButton);

    jPanel5.add(jPanel7);

    equalityCheckBox.setSelected(true);
    equalityCheckBox.setText("Equality of Manager and Clients");
    jPanel5.add(equalityCheckBox);

    reshareCheckBox.setText("Reshare");
    jPanel5.add(reshareCheckBox);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    jPanel4.add(jPanel1, java.awt.BorderLayout.CENTER);

    chooseBinaryBundleButton.setText("Choose Binary Bundle");
    chooseBinaryBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        chooseBinaryBundleButtonActionPerformed(evt);
      }
    });

    jPanel2.add(chooseBinaryBundleButton);

    chooseInstalledBundleButton.setText("Choose Installed Bundle");
    chooseInstalledBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        chooseInstalledBundleButtonActionPerformed(evt);
      }
    });

    jPanel2.add(chooseInstalledBundleButton);

    showLicenceButton.setText("Show Licence of Selected Bundle");
    showLicenceButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        showLicenceButtonActionPerformed(evt);
      }
    });

    jPanel2.add(showLicenceButton);

    jPanel4.add(jPanel2, java.awt.BorderLayout.NORTH);

    shareButton.setText("Share Bundle");
    shareButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        shareButtonActionPerformed(evt);
      }
    });

    jPanel3.add(shareButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    jPanel4.add(jPanel3, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void shareGroupsButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_shareGroupsButtonActionPerformed
  {//GEN-HEADEREND:event_shareGroupsButtonActionPerformed
    StringListEditDialog.showDialog(this, shareGroups.getList(), "Share Group", "Share Groups Editor");
  }//GEN-LAST:event_shareGroupsButtonActionPerformed

  private void nodeFilterButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_nodeFilterButtonActionPerformed
  {//GEN-HEADEREND:event_nodeFilterButtonActionPerformed
    StringListEditDialog.showDialog(this, nodeFilter.getPatterns(), "Node Name Pattern", "Node Filter Editor");
  }//GEN-LAST:event_nodeFilterButtonActionPerformed

  private void shareGroupsCheckBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_shareGroupsCheckBoxActionPerformed
  {//GEN-HEADEREND:event_shareGroupsCheckBoxActionPerformed
    shareGroupsButton.setEnabled(shareGroupsCheckBox.isSelected());
  }//GEN-LAST:event_shareGroupsCheckBoxActionPerformed

  private void nodeFilterCheckBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_nodeFilterCheckBoxActionPerformed
  {//GEN-HEADEREND:event_nodeFilterCheckBoxActionPerformed
    nodeFilterButton.setEnabled(nodeFilterCheckBox.isSelected());
  }//GEN-LAST:event_nodeFilterCheckBoxActionPerformed

  private void showLicenceButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_showLicenceButtonActionPerformed
  {//GEN-HEADEREND:event_showLicenceButtonActionPerformed
    String bundleName = bundleNameTextField.getText();
    
    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromBundleName(bundleName);
    }
    catch (BundleInfo.InvalidBundleNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    Licence licence = null;    
    try
    {
      licence = admin.getLicence(bundleName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    if (licence != null)
    {
      LicenceEditDialog.showDialog(this, licence, false, "Licence File of '" + bundleName + "'");
    }
    else
    {
      JOptionPane.showMessageDialog(this, "Bundle '" + bundleName + "' is not limited by licence", "No Licence File Present", JOptionPane.INFORMATION_MESSAGE);
    }
  }//GEN-LAST:event_showLicenceButtonActionPerformed

  private void chooseInstalledBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_chooseInstalledBundleButtonActionPerformed
  {//GEN-HEADEREND:event_chooseInstalledBundleButtonActionPerformed
    LocalInfoDesc[] localInfoDescs = null;
    try
    {
      localInfoDescs = admin.localInfoDescsList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    int size = 0;
    int i;
    for (i = 0; i < localInfoDescs.length; i++)
    {
      if (localInfoDescs[i].isInstalled()) size++;
    }
    
    LocalInfoDesc[] installed = new LocalInfoDesc[size];
    int j = 0;
    for (i = 0; i < localInfoDescs.length; i++)
    {
      if (localInfoDescs[i].isInstalled())
      {
        installed[j++] = localInfoDescs[i];
      }
    }

    Arrays.sort(installed);
    
    LocalInfoDesc result = (LocalInfoDesc)ListDialog.showDialog(this, this, "Installed Bundles:", "Choose Installed Bundle to Share", installed, null, null, false, true);
    if (result != null) bundleNameTextField.setText(result.bundleName);    
  }//GEN-LAST:event_chooseInstalledBundleButtonActionPerformed

  private void chooseBinaryBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_chooseBinaryBundleButtonActionPerformed
  {//GEN-HEADEREND:event_chooseBinaryBundleButtonActionPerformed
    String[] bundles = null;
    try
    {
      bundles = admin.binBundlesList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    Arrays.sort(bundles);
    
    String result = ListDialog.showDialog(this, this, "Binary Bundles:", "Choose Binary Bundle to Install", bundles, null, null, false, true);
    if (result.length() != 0) bundleNameTextField.setText(result);
    
  }//GEN-LAST:event_chooseBinaryBundleButtonActionPerformed

  private void shareButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_shareButtonActionPerformed
  {//GEN-HEADEREND:event_shareButtonActionPerformed
    String bundleName = bundleNameTextField.getText();
    String numberOfLicencesText = numberOfLicencesTextField.getText().trim().toLowerCase();
    boolean equality = equalityCheckBox.isSelected();
    boolean reshare = reshareCheckBox.isSelected();

    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromBundleName(bundleName);
    }
    catch (BundleInfo.InvalidBundleNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    int numberOfLicences = Licence.ALL_LICENCES;
    if (numberOfLicencesText.length() != 0 && numberOfLicencesText.compareTo("*") != 0 && numberOfLicencesText.compareTo("all") != 0)
    {
      try
      {
        numberOfLicences = Integer.parseInt(numberOfLicencesText);
        if (numberOfLicences < 0) throw new NumberFormatException("Negative 'Number of Licences' is not allowed");
      }
      catch (NumberFormatException e)
      {
        JOptionPane.showMessageDialog(this, "Error occured while parsing 'Number of Licences':\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
    }

    if (!nodeFilterCheckBox.isSelected()) nodeFilter = null;
    if (!shareGroupsCheckBox.isSelected()) shareGroups = null;
    
    try
    {
      admin.shareBundle(bundleName, numberOfLicences, shareGroups, nodeFilter, equality, reshare);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    
    JOptionPane.showMessageDialog(this, "Bundle '" + bundleName + "' successfully shared");
    
    isOK = true;
    dispose();
  }//GEN-LAST:event_shareButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel bundleNameLabel;
  private javax.swing.JTextField bundleNameTextField;
  private javax.swing.JButton cancelButton;
  private javax.swing.JButton chooseBinaryBundleButton;
  private javax.swing.JButton chooseInstalledBundleButton;
  private javax.swing.JCheckBox equalityCheckBox;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JPanel jPanel6;
  private javax.swing.JPanel jPanel7;
  private javax.swing.JButton nodeFilterButton;
  private javax.swing.JCheckBox nodeFilterCheckBox;
  private javax.swing.JLabel numberOfLicencesLabel;
  private javax.swing.JTextField numberOfLicencesTextField;
  private javax.swing.JCheckBox reshareCheckBox;
  private javax.swing.JButton shareButton;
  private javax.swing.JButton shareGroupsButton;
  private javax.swing.JCheckBox shareGroupsCheckBox;
  private javax.swing.JButton showLicenceButton;
  // End of variables declaration//GEN-END:variables
  
}
