/*
 * InstallBundleDialog.java
 *
 * Created on 10. kvten 2004, 22:42
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.BundleInfo;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class StopShareClientDialog extends javax.swing.JDialog
{
  private RMIAdminInterface admin;
  private boolean isOK;
  
  public static boolean showDialog(Component frameComp, RMIAdminInterface admin, String defaultBundleName)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    StopShareClientDialog dialog = new StopShareClientDialog(frame, true, admin, defaultBundleName);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form StopShareClientDialog */
  public StopShareClientDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin, String defaultBundleName)
  {
    super(parent, modal);
    this.admin = admin;
    isOK = false;
    initComponents();
    
    bundleNameTextField.setText(defaultBundleName);
  }
  
  public boolean isOK()
  {
    return isOK;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel4 = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    bundleNameLabel = new javax.swing.JLabel();
    bundleNameTextField = new javax.swing.JTextField();
    returnLicenceCheckBox = new javax.swing.JCheckBox();
    forcelCheckBox = new javax.swing.JCheckBox();
    jPanel2 = new javax.swing.JPanel();
    chooseShareClientButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    stopShareClientButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Stop Share Client");
    jPanel4.setLayout(new java.awt.BorderLayout());

    jPanel4.setMinimumSize(new java.awt.Dimension(400, 93));
    jPanel4.setPreferredSize(new java.awt.Dimension(400, 170));
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 10, 1, 10)));
    jPanel1.setMinimumSize(new java.awt.Dimension(26, 23));
    jPanel1.setPreferredSize(new java.awt.Dimension(26, 23));
    jPanel5.setLayout(new java.awt.GridLayout(4, 0));

    bundleNameLabel.setText("Bundle Name:");
    jPanel5.add(bundleNameLabel);

    bundleNameTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    bundleNameTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(bundleNameTextField);

    returnLicenceCheckBox.setSelected(true);
    returnLicenceCheckBox.setText("Return Licence to Share Manager (if needed)");
    jPanel5.add(returnLicenceCheckBox);

    forcelCheckBox.setText("Force (stop Share Client even if licence cannot be returned to Share Manager)");
    jPanel5.add(forcelCheckBox);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    jPanel4.add(jPanel1, java.awt.BorderLayout.CENTER);

    chooseShareClientButton.setText("Choose Share Client");
    chooseShareClientButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        chooseShareClientButtonActionPerformed(evt);
      }
    });

    jPanel2.add(chooseShareClientButton);

    jPanel4.add(jPanel2, java.awt.BorderLayout.NORTH);

    stopShareClientButton.setText("Stop Share Client");
    stopShareClientButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        stopShareClientButtonActionPerformed(evt);
      }
    });

    jPanel3.add(stopShareClientButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    jPanel4.add(jPanel3, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void chooseShareClientButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_chooseShareClientButtonActionPerformed
  {//GEN-HEADEREND:event_chooseShareClientButtonActionPerformed
    LocalInfoDesc[] localInfoDescs = null;
    try
    {
      localInfoDescs = admin.localInfoDescsList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    int size = 0;
    int i;
    for (i = 0; i < localInfoDescs.length; i++)
    {
      if (localInfoDescs[i].isShareClient()) size++;
    }
    
    LocalInfoDesc[] shareClients = new LocalInfoDesc[size];
    int j = 0;
    for (i = 0; i < localInfoDescs.length; i++)
    {
      if (localInfoDescs[i].isShareClient())
      {
        shareClients[j++] = localInfoDescs[i];
      }
    }

    Arrays.sort(shareClients);
    
    LocalInfoDesc result = (LocalInfoDesc)ListDialog.showDialog(this, this, "Bundles in Share Client Mode:", "Choose Share Client to Install", shareClients, null, null, false, true);
    if (result != null) bundleNameTextField.setText(result.bundleName);
    
  }//GEN-LAST:event_chooseShareClientButtonActionPerformed

  private void stopShareClientButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_stopShareClientButtonActionPerformed
  {//GEN-HEADEREND:event_stopShareClientButtonActionPerformed
    String bundleName = bundleNameTextField.getText();
    boolean returnLicence = returnLicenceCheckBox.isSelected();
    boolean force = forcelCheckBox.isSelected();

    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromBundleName(bundleName);
    }
    catch (BundleInfo.InvalidBundleNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    try
    {
      admin.stopShareClientOfBundle(bundleName, returnLicence, force);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    
    JOptionPane.showMessageDialog(this, "Share client of bundle '" + bundleName + "' successfully stopped");
    
    isOK = true;
    dispose();
  }//GEN-LAST:event_stopShareClientButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel bundleNameLabel;
  private javax.swing.JTextField bundleNameTextField;
  private javax.swing.JButton cancelButton;
  private javax.swing.JButton chooseShareClientButton;
  private javax.swing.JCheckBox forcelCheckBox;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JCheckBox returnLicenceCheckBox;
  private javax.swing.JButton stopShareClientButton;
  // End of variables declaration//GEN-END:variables
  
}
