/*
 * InstallBundleDialog.java
 *
 * Created on 10. kvten 2004, 22:42
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.BundleInfo;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class UninstallBundleDialog extends javax.swing.JDialog
{
  private RMIAdminInterface admin;
  private boolean isOK;
  
  public static boolean showDialog(Component frameComp, RMIAdminInterface admin, String defaultBundleName)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    UninstallBundleDialog dialog = new UninstallBundleDialog(frame, true, admin, defaultBundleName);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form UninstallBundleDialog */
  public UninstallBundleDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin, String defaultBundleName)
  {
    super(parent, modal);
    this.admin = admin;
    isOK = false;
    initComponents();
    
    bundleNameTextField.setText(defaultBundleName);
  }
  
  public boolean isOK()
  {
    return isOK;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel4 = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    bundleNameLabel = new javax.swing.JLabel();
    bundleNameTextField = new javax.swing.JTextField();
    deleteComponentsCheckBox = new javax.swing.JCheckBox();
    includingInterfacesCheckBox = new javax.swing.JCheckBox();
    forceCheckBox = new javax.swing.JCheckBox();
    jPanel2 = new javax.swing.JPanel();
    chooseInstalledBundleButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    uninstallButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Uninstall Bundle");
    jPanel4.setLayout(new java.awt.BorderLayout());

    jPanel4.setMinimumSize(new java.awt.Dimension(400, 93));
    jPanel4.setPreferredSize(new java.awt.Dimension(400, 190));
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 10, 1, 10)));
    jPanel1.setMinimumSize(new java.awt.Dimension(26, 23));
    jPanel1.setPreferredSize(new java.awt.Dimension(26, 23));
    jPanel5.setLayout(new java.awt.GridLayout(5, 0));

    bundleNameLabel.setText("Bundle Name:");
    jPanel5.add(bundleNameLabel);

    bundleNameTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    bundleNameTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(bundleNameTextField);

    deleteComponentsCheckBox.setSelected(true);
    deleteComponentsCheckBox.setText("Delete Components from TR");
    deleteComponentsCheckBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteComponentsCheckBoxActionPerformed(evt);
      }
    });

    jPanel5.add(deleteComponentsCheckBox);

    includingInterfacesCheckBox.setText("Including Interfaces");
    jPanel5.add(includingInterfacesCheckBox);

    forceCheckBox.setText("Force");
    jPanel5.add(forceCheckBox);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    jPanel4.add(jPanel1, java.awt.BorderLayout.CENTER);

    chooseInstalledBundleButton.setText("Choose Installed Bundle");
    chooseInstalledBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        chooseInstalledBundleButtonActionPerformed(evt);
      }
    });

    jPanel2.add(chooseInstalledBundleButton);

    jPanel4.add(jPanel2, java.awt.BorderLayout.NORTH);

    uninstallButton.setText("Uninstall Bundle");
    uninstallButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        uninstallButtonActionPerformed(evt);
      }
    });

    jPanel3.add(uninstallButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    jPanel4.add(jPanel3, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void deleteComponentsCheckBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteComponentsCheckBoxActionPerformed
  {//GEN-HEADEREND:event_deleteComponentsCheckBoxActionPerformed
    includingInterfacesCheckBox.setEnabled(deleteComponentsCheckBox.isSelected());
  }//GEN-LAST:event_deleteComponentsCheckBoxActionPerformed

  private void chooseInstalledBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_chooseInstalledBundleButtonActionPerformed
  {//GEN-HEADEREND:event_chooseInstalledBundleButtonActionPerformed
    LocalInfoDesc[] localInfoDescs = null;
    try
    {
      localInfoDescs = admin.localInfoDescsList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    int size = 0;
    int i;
    for (i = 0; i < localInfoDescs.length; i++)
    {
      if (localInfoDescs[i].isInstalled()) size++;
    }
    
    LocalInfoDesc[] shareClients = new LocalInfoDesc[size];
    int j = 0;
    for (i = 0; i < localInfoDescs.length; i++)
    {
      if (localInfoDescs[i].isInstalled())
      {
        shareClients[j++] = localInfoDescs[i];
      }
    }

    Arrays.sort(shareClients);
    
    LocalInfoDesc result = (LocalInfoDesc)ListDialog.showDialog(this, this, "Installed Bundles:", "Choose Installed Bundle to Uninstall", shareClients, null, null, false, true);
    if (result != null) bundleNameTextField.setText(result.bundleName);
    
  }//GEN-LAST:event_chooseInstalledBundleButtonActionPerformed

  private void uninstallButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_uninstallButtonActionPerformed
  {//GEN-HEADEREND:event_uninstallButtonActionPerformed
    String bundleName = bundleNameTextField.getText();
    boolean deleteComponents = deleteComponentsCheckBox.isSelected();
    boolean includingInterfaces = includingInterfacesCheckBox.isSelected();
    boolean force = forceCheckBox.isSelected();

    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromBundleName(bundleName);
    }
    catch (BundleInfo.InvalidBundleNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    try
    {
      admin.uninstallBundle(bundleName, deleteComponents, includingInterfaces, force);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    
    JOptionPane.showMessageDialog(this, "Bundle '" + bundleName + "' successfully uninstalled");
    
    isOK = true;
    dispose();
  }//GEN-LAST:event_uninstallButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel bundleNameLabel;
  private javax.swing.JTextField bundleNameTextField;
  private javax.swing.JButton cancelButton;
  private javax.swing.JButton chooseInstalledBundleButton;
  private javax.swing.JCheckBox deleteComponentsCheckBox;
  private javax.swing.JCheckBox forceCheckBox;
  private javax.swing.JCheckBox includingInterfacesCheckBox;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JButton uninstallButton;
  // End of variables declaration//GEN-END:variables
  
}
