/*
 * RMILocalServer.java
 *
 * Created on 3. kvten 2004, 16:27
 */

package SOFA.SOFAnet.Local.RMI;

import java.rmi.server.UnicastRemoteObject;
import java.rmi.server.ServerNotActiveException;
import java.rmi.RemoteException;
import SOFA.SOFAnet.Core.LocalOps;
import SOFA.SOFAnet.Core.CoreException;

/**
 * RMI server that implemets "Local interface" - RMILocalInterface - for SOFA runtime
 *
 * @author  Ladislav Sobr
 */
public class RMILocalServer extends UnicastRemoteObject implements RMILocalInterface
{
  private LocalOps localOps;
  
  /** Creates a new instance of RMILocalServer */
  public RMILocalServer(LocalOps localOps) throws RemoteException
  {
    this.localOps = localOps;
  }
  
  public int acquireComponent(String componentFullName) throws RemoteException
  {
    return localOps.acquireComponent(componentFullName);
  }
  
  public int releaseComponent(String componentFullName) throws RemoteException
  {
    return localOps.releaseComponent(componentFullName);
  }
  
  public int obtainMissingComponent(String componentFullName) throws RMILocalException, RemoteException
  {
    try
    {
      return localOps.obtainMissingComponent(componentFullName);
    }
    catch (CoreException e)
    {
      throw new RMILocalException(e.getMessage(), e);
    }
  }
}
