/*
 * StorageItem.java
 *
 * Created on 22. listopad 2003, 19:43
 */

package SOFA.SOFAnet.Repository;

import java.lang.*;
import java.io.*;

/**
 * Interface of storage item.
 *
 * @author  Ladislav Sobr
 */
public interface StorageItem
{
  /** Loads item from storage */
  void loadFromStorage();

  /** Saves item to storage */
  void saveToStorage();
  
  /** Returns true if the item is loaded in memory */
  boolean isLoaded();
  
  /** Sets the "loaded flag" of the item */
  void setLoaded(boolean loaded);
  
  /** Returns name of item */
  String getName();
  
  /** Deletes item from storage */
  void deleteFromStorage();
  
  /** Returns true if the item is to be deleted from storage */
  boolean toBeDeleted();
}
