/*
 * SearchReply.java
 *
 * Created on 28. duben 2004, 15:19
 */

package SOFA.SOFAnet.Search;

import java.util.List;
import java.io.Serializable;

/**
 * The reply to search request.
 * The reply consist of search request ID and reply items.
 *
 * @author  Ladislav Sobr
 */
public class SearchReply implements Serializable
{
  private SearchRequestID requestID;         //identification of request that this reply belongs to
  private List replies;                      //list of replies

  /** Creates a new instance of SearchReply */
  public SearchReply()
  {
  }

  public SearchReply(SearchRequestID requestID, List replies)
  {
    this.requestID = requestID;
    this.replies = replies;
  }

  public SearchRequestID getRequestID()
  {
    return requestID;
  }
  
  public List getReplies()
  {
    return replies;
  }
  
  public void setRequestID(SearchRequestID requestID)
  {
    this.requestID = requestID;
  }
  
  public void setReplies(List replies)
  {
    this.replies = replies;
  }
  
}
