/*
 * SearchRequestID.java
 *
 * Created on 28. duben 2004, 15:50
 */

package SOFA.SOFAnet.Search;

import java.io.Serializable;

/**
 * Identification of search request.
 * It consists of name of source node and randomly generated unique identifier.
 *
 * @author  Ladislav Sobr
 */
public class SearchRequestID implements Serializable
{
  private int requestMark;         //identification of request that this reply belongs to
  private String sourceNode;       //requesting node
  
  /** Creates a new instance of SearchRequestID */
  public SearchRequestID()
  {
  }
  
  public SearchRequestID(int requestMark, String sourceNode)
  {
    this.requestMark = requestMark;
    this.sourceNode = sourceNode;
  }
  
  public int getRequestMark()
  {
    return requestMark;
  }

  public String getSourceNode()
  {
    return sourceNode;
  }
  
  public void setRequestMark(int requestMark)
  {
    this.requestMark = requestMark;
  }
  
  public void setSourceNode(String sourceNode)
  {
    this.sourceNode = sourceNode;
  }
  
  public boolean equals(Object o)
  {
    if (this == o) return true;
    if (o instanceof SearchRequestID)
    {
      SearchRequestID anotherSearchRequestID = (SearchRequestID)o;
      if (requestMark != anotherSearchRequestID.requestMark) return false;
      if (sourceNode == null)
      {
        if (anotherSearchRequestID.sourceNode == null) return true;
        else return false;
      }
      else
      {
        if (anotherSearchRequestID.sourceNode == null) return false;
        return sourceNode.compareTo(anotherSearchRequestID.sourceNode) == 0;
      }
    }
    else return false;
  }
}
