/*
 * TRInterface.java
 *
 * Created on 19. bezen 2004, 16:28
 */

package SOFA.SOFAnet.TR;

import SOFA.SOFAnode.InOut.Bundle;
import SOFA.SOFAnode.TR.ComponentInfo;
import SOFA.SOFAnode.TR.TRException;

/**
 * Interface of Template Repository (TR).
 *
 * @author  Ladislav Sobr
 */
public interface TRInterface
{
  /** Stores components from the bundle in the TR. */
  void storeBundle(Bundle bundle) throws TRException;
  
  /** Creates bundle of components from TR */
  Bundle getBundle(ComponentInfo[] descs, ComponentInfo[] comps, boolean inferiors) throws TRException;
  
  /** Returns true if TR contains specified component (disregarding presence of real implementation of component*/
  boolean contains(ComponentInfo descr);

  /** Returns true if TR contains specified component including implementation files */
  boolean containsComponent(ComponentInfo comp, boolean inferiors);

  /** Returns list of components in TR */
  Bundle list();
  
  /** Deletes components from tr */
  void deleteComponents(ComponentInfo[] comps, boolean interfaces, boolean inferiors) throws TRException;

  /** Stores components from the bundle in the TR. */
  void storeMemoryBundle(byte[] memoryBundle) throws TRException;

  /** Creates bundle of components from TR */
  byte[] getMemoryBundle(ComponentInfo[] descs, ComponentInfo[] comps, boolean inferiors) throws TRException;
}
