/*
 * Test.java
 *
 * Created on 22. listopad 2003, 22:22
 */

package SOFA.SOFAnet;

import java.io.*;
import java.util.*;
import SOFA.SOFAnode.TR.Impl.*;
import SOFA.SOFAnode.TR.*;
import SOFA.Util.VMProperties;
import java.rmi.*;

import SOFA.SOFAnet.Repository.*;

import SOFA.SOFAnet.TR.*;
import SOFA.SOFAnet.TR.Local.*;

import SOFA.SOFAnet.Core.*;
import SOFA.SOFAnet.Transport.*;
import SOFA.SOFAnet.Transport.RMI.*;

import java.rmi.Naming;
import java.net.MalformedURLException;

import SOFA.SOFAnet.NetNode;
import SOFA.SOFAnet.Local.RMI.*;

/**
 *
 * @author  Ladislav Sobr
 */
public class Test
{
  
  /** Creates a new instance of Test */
  public Test()
  {
  }
  
  /**
   * @param args the command line arguments
   */
  public static void main(String[] args)
  {
    try
    {
      if (args.length == 0 || args[0].length() == 0)
      {
        //klient
        System.setProperty(VMProperties.NODE_NAME, "safir:1099");
        System.setProperty("java.security.policy", "X:/SOFACVS/sofa/templates/conf/.java.policy");
        System.setProperty("java.rmi.server.codebase", "file:///X:/SOFACVS/sofa/src");

        System.setProperty("sofa.net.searchtimeout", "20000");
        
        NetNode instance = new NetNode(
                                         new File("x:/tmp/TRdir"),
                                         new File("x:/tmp/info"),
                                         new File("x:/tmp/info/bin_bundles"),
                                         new File("x:/tmp/info/share_client_cache")
                                         );
        instance.start();
        
        String bundleName = "my-bundle[1]";
        /*
        try
        {
          if (instance.localOps.isBundleInstalled(bundleName)) instance.localOps.uninstallBundle(bundleName, false, false);
          instance.shareOps.stopShareClientOfBundle(bundleName, true, false);
        }
        catch (CoreException e)
        {
          e.printStackTrace();
        }
        */
        /*
        RMILocalInterface localServer = null;
        try
        {
          localServer = (RMILocalInterface)Naming.lookup("rmi://safir:1099/SOFAnet/RMILocalServer");
        }
        catch (Exception e)
        {
          e.printStackTrace();
        }    
        
    
        String componentFullName = "::CUNI::SOFA::demos::logdemo::Logger[0.0.1]";
        try
        {
          localServer.obtainMissingComponent(componentFullName);
        }
        catch (RMILocalException e)
        {
          e.printStackTrace();
        }
        */
      }
      else
      if (args[0].toLowerCase().compareTo("s") == 0)
      {
        //server
        System.setProperty(VMProperties.NODE_NAME, "safir:2000");
        System.setProperty("java.security.policy", "X:/SOFACVS/sofa/templates/conf/.java.policy");
        System.setProperty("java.rmi.server.codebase", "file:///X:/SOFACVS/sofa/src");

        NetNode instance = new NetNode(
                                         new File("x:/tmp/TRdir_server"),
                                         new File("x:/tmp/info_server"),
                                         new File("x:/tmp/info_server/bin_bundles"),
                                         new File("x:/tmp/info_server/share_client_cache")
                                         );
        Reporter.setShowDetailedExceptions(true);
        
        instance.start();
        
//        instance.shareOps.shareBundle("my-bundle[1]", 10, null, null, true, true);
/*        
        RMILocalInterface localServer = null;
        try
        {
          localServer = (RMILocalInterface)Naming.lookup("rmi://safir:2000/SOFAnet/RMILocalServer");
        }
        catch (Exception e)
        {
          e.printStackTrace();
        }    
        
    
        String componentFullName = "::CUNI::SOFA::demos::logdemo::Logger[0.0.1]";
        try
        {
          localServer.obtainMissingComponent(componentFullName);
        }
        catch (RMILocalException e)
        {
          e.printStackTrace();
        }
*/        
      }
      else
      if (args[0].toLowerCase().compareTo("c") == 0)
      {
        //klient2
        System.setProperty(VMProperties.NODE_NAME, "safir:2001");
        System.setProperty("java.security.policy", "X:/SOFACVS/sofa/templates/conf/.java.policy");
        System.setProperty("java.rmi.server.codebase", "file:///X:/SOFACVS/sofa/src");

        System.setProperty("sofa.net.searchtimeout", "20000");
        
        NetNode instance = new NetNode(
                                         new File("x:/tmp/TRdir2"),
                                         new File("x:/tmp/info2"),
                                         new File("x:/tmp/info2/bin_bundles"),
                                         new File("x:/tmp/info2/share_client_cache")
                                         );
        instance.start();

        String bundleName = "my-bundle[1]";
        /*
        try
        {
          if (instance.localOps.isBundleInstalled(bundleName)) instance.localOps.uninstallBundle(bundleName, false, false);
          instance.shareOps.stopShareClientOfBundle(bundleName, true, false);
        }
        catch (CoreException e)
        {
          e.printStackTrace();
        }
        */
/*        
        RMILocalInterface localServer = null;
        try
        {
          localServer = (RMILocalInterface)Naming.lookup("rmi://safir:2001/SOFAnet/RMILocalServer");
        }
        catch (Exception e)
        {
          e.printStackTrace();
        }    
        
    
        String componentFullName = "::CUNI::SOFA::demos::logdemo::Logger[0.0.1]";
        try
        {
          localServer.obtainMissingComponent(componentFullName);
        }
        catch (RMILocalException e)
        {
          e.printStackTrace();
        }
*/        
        
      }
      else
      if (args[0].toLowerCase().compareTo("c2") == 0)
      {
        RMILocalInterface localServer = null;
        try
        {
          localServer = (RMILocalInterface)Naming.lookup("rmi://safir:2000/SOFAnet/RMILocalServer");
        }
        catch (Exception e)
        {
          e.printStackTrace();
        }    
        
    
        String componentFullName = "::CUNI::SOFA::demos::logdemo::Logger[0.0.1]";
        try
        {
          if (false) localServer.obtainMissingComponent(componentFullName);
          localServer.acquireComponent(componentFullName);
          //localServer.releaseComponent(componentFullName);
          //localServer.releaseComponent(componentFullName);
        }
        catch (RMILocalException e)
        {
          e.printStackTrace();
        }
        
      }
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
          
    /*
    try
    {
    
      if (args.length == 0 || args[0].toLowerCase().compareTo("s") != 0)
      {
        //klient
        System.setProperty(VMProperties.NODE_NAME, "safir:1099");
        System.setProperty("java.security.policy", "X:/SOFACVS/sofa/templates/conf/.java.policy");

        Repository rep = new Repository(new File("x:/tmp/info"), new File("x:/tmp/bin_bundles"),
                                        new File("x:/tmp/share_client_cache"));
        TRInterface tr = null;
        try
        {
          tr = new TRWrapper("x:/tmp/TRdir");
        }
        catch (Exception e)
        {
          e.printStackTrace();
        }

        RMITransportClient rmiTransportClient = new RMITransportClient();

        LocalOps localOps = new LocalOps();
        ShareOps shareOps = new ShareOps();
        NetOps netOps = new NetOps();

        localOps.setRepository(rep);
        localOps.setTRInterface(tr);
        localOps.setNetOps(netOps);

        shareOps.setRepository(rep);

        netOps.setRepository(rep);
        netOps.setLocalOps(localOps);
        netOps.setShareOps(shareOps);
        netOps.setTransportInterface(rmiTransportClient);

        rmiTransportClient.setNetOps(netOps);

        String bundleName;
        String nodeName = "safir:2000";
        boolean result = false;
        try
        {
          bundleName = "::CUNI::SOFA::demos::protodemo::Logger[0.0.1]";
//          result = netOps.testPull(bundleName, nodeName);
//          result = netOps.testPush(bundleName, nodeName, true);
//          netOps.pushBundle(bundleName, nodeName, 1);
          bundleName = "my-bundle[1]";
//          netOps.synchroPullBundle(bundleName, nodeName);
          netOps.pullBundle(bundleName, nodeName, "");
        }
        catch (CoreException e)
        {
          e.printStackTrace();
        }

      }
      else
      {
        //server
        System.setProperty(VMProperties.NODE_NAME, "safir:2000");
        System.setProperty("java.security.policy", "X:/SOFACVS/sofa/templates/conf/.java.policy");
        System.setProperty("java.rmi.server.codebase", "file:///X:/SOFACVS/sofa/src");


        Repository rep = new Repository(new File("x:/tmp/info_server"), new File("x:/tmp/bin_bundles_server"),
                                        new File("x:/tmp/share_client_cache_server"));
        TRInterface tr = null;
        try
        {
          tr = new TRWrapper("x:/tmp/TRdir_server");
        }
        catch (Exception e)
        {
          e.printStackTrace();
        }

        RMITransportClient rmiTransportClient = new RMITransportClient();

        LocalOps localOps = new LocalOps();
        ShareOps shareOps = new ShareOps();
        NetOps netOps = new NetOps();

        localOps.setRepository(rep);
        localOps.setTRInterface(tr);
        localOps.setNetOps(netOps);

        shareOps.setRepository(rep);

        netOps.setRepository(rep);
        netOps.setLocalOps(localOps);
        netOps.setShareOps(shareOps);
        netOps.setTransportInterface(rmiTransportClient);

        rmiTransportClient.setNetOps(netOps);

        try
        {
          RMITransportServer rmiTransportServer = new RMITransportServer(netOps, shareOps);
          Naming.rebind("//localhost:2000/SOFAnetRMITransportServer", rmiTransportServer);
        }
        catch (RemoteException e)
        {
          e.printStackTrace();
        }
        catch (MalformedURLException e)
        {
          e.printStackTrace();
        }

      }
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
    
    */
    /*
     
    Repository rep = new Repository(new File("x:/tmp/info"), new File("x:/tmp/bin_bundles"));
    TRInterface tr = null;
    try
    {
      tr = new TRWrapper("x:/tmp/TRdir");
     
//      ComponentInfo[] ca = new ComponentInfo[1];
//      ca[0] = new ComponentInfoImpl("::CUNI::SOFA::demos::logdemo::logdemo", "0.0.1");
//      tr.deleteComponents(ca, true, true);
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
     
    LocalOps localOps = new LocalOps();
    localOps.setRepository(rep);
    localOps.setTRInterface(tr);
     
    ShareOps shareOps = new ShareOps();
    shareOps.setRepository(rep);
     
    String bundleName;
    try
    {
      bundleName = "::CUNI::SOFA::demos::protodemo::Logger[0.0.1]";
      shareOps.shareBundle(bundleName, 3, null, true);
      shareOps.shareBundle(bundleName, 4, null, true);
      shareOps.shareBundle(bundleName, 3, null, true);
      shareOps.shareBundle(bundleName, Licence.ALL_LICENCES, null, true);
      shareOps.shareBundle(bundleName, 3, null, true);
      shareOps.stopSharingBundle(bundleName, false);
    }
    catch(CoreException e)
    {
      e.printStackTrace();
    }
     
     */
    
    /*
    ComponentInfoImpl component, component2;
    component = new ComponentInfoImpl("::CUNI::SOFA::demos::protodemo::Logger", "0.0.1");
    try
    {
      bundleName = localOps.createSingleComponentBundle(component);
      localOps.createBinaryBundle(bundleName, true);
      localOps.uninstallBundle(bundleName, true, false);
      localOps.installBundle(bundleName, false);
    }
    catch(localOps.BundleOpException e)
    {
      e.printStackTrace();
    }
     
    component = new ComponentInfoImpl("::CUNI::SOFA::demos::logdemo::logdemo", "0.0.1");
    try
    {
      bundleName = localOps.createCompleteComponentBundle(component);
      localOps.createBinaryBundle(bundleName, true);
      localOps.uninstallBundle(bundleName, true, false);
      localOps.installBundle(bundleName, false);
    }
    catch(localOps.BundleOpException e)
    {
      e.printStackTrace();
    }
     
    component = new ComponentInfoImpl("::CUNI::SOFA::demos::logdemo::logdemo", "0.0.1");
    component2 = new ComponentInfoImpl("::CUNI::SOFA::demos::logdemo::Logger", "0.0.2");
    ComponentInfo[] comps = new ComponentInfo[2];
    comps[0] = component;
    comps[1] = component2;
     
    try
    {
      bundleName = "my-bundle[1]";
      localOps.createUserBundle(bundleName, comps, true);
      localOps.createBinaryBundle(bundleName, true);
      localOps.uninstallBundle(bundleName, true, false);
      localOps.installBundle(bundleName, false);
    }
    catch(localOps.BundleOpException e)
    {
      e.printStackTrace();
    }
     */
    
/*
    OutputTriggers outputTriggers = rep.getOutputTriggers();
 
    List l;
    BundleNameFilter bundleFilter = new BundleNameFilter();
    l = bundleFilter.getPatterns();
    l.add("::CUNI::SOFA::xxx[0.1.0]");
    l.add("nas-balicek-0.0.1");
    l.add("*[>0.0.0]*");
    NodeNameFilter nodeFilter = new NodeNameFilter();
    l = nodeFilter.getPatterns();
    l.add("sofa://safir:2000");
    l.add("195.113.27.80/10");
 
 
 
    Calendar cal = Calendar.getNetNode();
    cal.roll(Calendar.DAY_OF_MONTH, 5);
    Date validTo = cal.getTime();
    outputTriggers.addOutputTrigger("my_oe", false, "popisek", true, bundleFilter, nodeFilter, null, validTo, "ccccc", "rrrrrr");
    outputTriggers.addOutputTrigger("my_oe", true, "popisek", true, bundleFilter, nodeFilter, null, validTo, "ccccc", "rrrrrr");
    outputTriggers.addOutputTrigger("", true, "popisek", true, bundleFilter, nodeFilter, null, validTo, null, null);
    outputTriggers.addOutputTrigger("", true, "popisek", true, bundleFilter, nodeFilter, null, validTo, "ccccc", "rrrrrr");
 
    InputTriggers inputTriggers = rep.getInputTriggers();
 
    OutputTrigger outputTrigger = new OutputTrigger("", null);
    outputTrigger.setBundleFilter(bundleFilter);
    outputTrigger.setValidFrom(validTo);
    outputTrigger.setDescription("jjjjjjjjjeeeee");
    NodeNameLicList nodeLicList = new NodeNameLicList();
    nodeLicList.add("sofa://safir", -1);
    nodeLicList.add("safir", -2);
    nodeLicList.add("192.168.1.0", 4);
    NodeNameList nodeNameList = new NodeNameList();
    nodeNameList.add("sofa://safir:2000");
    nodeNameList.add("195.113.27.80");
 
 
    inputTriggers.addInputTrigger("my_ie", false, InputTrigger.TYPE_ALL, "hulahula", true, bundleFilter, nodeFilter, null, validTo, "sdsd", "ruleeeeeee", InputTrigger.ACTION_INSTALL | InputTrigger.ACTION_DELETE, -1, null, null, null);
    inputTriggers.addInputTrigger("my_ie", true, InputTrigger.TYPE_ALL, "hulahula", true, bundleFilter, nodeFilter, null, validTo, "sdsd", "ruleeeeeee", InputTrigger.ACTION_INSTALL | InputTrigger.ACTION_DELETE, -1, null, null, null);
    inputTriggers.addInputTrigger("", true, InputTrigger.TYPE_ALL, "hulahula", true, bundleFilter, nodeFilter, null, validTo, "sdsd", "ruleeeeeee", InputTrigger.ACTION_SHARE | InputTrigger.ACTION_ALLOW_PULL, -2, outputTrigger, null, null);
    inputTriggers.addInputTrigger("", true, InputTrigger.TYPE_ALL, "hulahula", true, bundleFilter, nodeFilter, null, validTo, "sdsd", "ruleeeeeee", InputTrigger.ACTION_SHARE | InputTrigger.ACTION_PUSH | InputTrigger.ACTION_PUSH_OFFER, 3, null, nodeLicList, nodeNameList);
 
 
 
    NodeInfo ni = new NodeInfo();
    boolean b2;
    try
    {
      ni.setNodeName("sofa://safir:2000");
      b2 = ni.matchPattern("safir.kolej.mff.cuni.cz");
      b2 = ni.matchPattern("sofa://cuni.cz");
      ni.setNodeName("sofa://www.lupa.cz:2000");
      b2 = ni.matchPattern("195.113.27.80/10");
      b2 = ni.matchPattern("safir.kolej.mff.cuni.cz");
      b2 = ni.matchPattern("sofa://cz");
    }
    catch (Exception e)
    {
      System.out.println(e.getMessage());
    }
 
    InstalledBundles installedBundleContents = rep.getInstalledBundles();
 
    ComponentInfoImpl [] cs = new ComponentInfoImpl[3];
 
    cs[0] = ComponentInfoImpl.fromString("::CUNI::SOFA::xxx[0.1.0]");
    cs[1] = ComponentInfoImpl.fromString("::CUNI::SOFA::yyy[0.0.1]");
    cs[2] = ComponentInfoImpl.fromString("::CUNI::bubu::haf::z[2.0.0]");
    InstalledBundle installedBundleContent = installedBundleContents.addInstalledBundle("::CUNI::SOFA::xxx[0.1.0]", cs);
 */
    
/*
    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromFilename("-CUNI-SOFA-demos-cplayer-Main-0.0.1");
      bundleInfo.fromFilename("-CUNI-SOFA-demos-cplayer-Main-0.0.1-#");
      bundleInfo.fromFilename("nas-balicek-0.0.1");
      bundleInfo.fromBundleName("::CUNI::SOFA::demos::cplayer::Main[0.0.1]");
      bundleInfo.fromBundleName("::CUNI::SOFA::demos::cplayer::Main[0.0.1]#");
      bundleInfo.fromBundleName("nas-balicek[0.0.1]");
    }
    catch (Exception e)
    {
    }
 
    try
    {
      bundleInfo.fromFilename("-CUNI-SOFA-demos-cplayer-Main-0.0.1");
      boolean x;
      x = bundleInfo.matchPattern("*[*]*");
      x = bundleInfo.matchPattern("::CUNI::*[*]*");
      x = bundleInfo.matchPattern("::CUNI::SO*[*]*");
      x = bundleInfo.matchPattern("::?::SOFA[*]*");
      x = bundleInfo.matchPattern("balicek[*]*");
      x = bundleInfo.matchPattern("*[0.0.1]*");
      x = bundleInfo.matchPattern("*[03]*");
      x = bundleInfo.matchPattern("*[>0.0.0]*");
      x = bundleInfo.matchPattern("*[<=1.1.1]*");
      x = bundleInfo.matchPattern("*[*]*");
      x = bundleInfo.matchPattern("*[*]#");
      x = bundleInfo.matchPattern("*[*]");
    }
    catch (Exception e)
    {
    }
 */
  }
  
}
