/*
 * IOParams.java
 *
 * Created on 31. bezen 2004, 16:24
 */

package SOFA.SOFAnet.Transport;

import SOFA.SOFAnet.Repository.Licence;
import java.util.*;

/**
 * The object of this class serves as input/output parameters of the transport layer.
 * @author  Ladislav Sobr
 */
public class IOParams
{
  final static public int PRIORITY_DISTRIBUTION = 0;
  final static public int PRIORITY_LOW = 0;
  final static public int PRIORITY_INTERACTIVE = 1;
  final static public int PRIORITY_HIGH = 1;
  final static public int PRIORITY_BLOCKING = 2;
  final static public int PRIORITY_CRITICAL = 2;
  
  public static class OtherNode
  {
    public String nodeName;
    public Licence licence;     //can be null
    public int errCode;
    
    public OtherNode()
    {
      nodeName = "";
      errCode = 0;
    }
  }

  private String bundleName;
  private BundleData bundleData;  //can be null
  private boolean offer;
  private boolean address;
  private boolean licenceOnly;
  private int priority;
  private String sourceNodeName;
  private String addressNodeName;
  private String contractID;

  private String nodeName;
  private Licence licence;        //can be null
  private int errCode;
  
  private List otherNodes;
  
  
  /** Creates a new instance of IOParams */
  public IOParams()
  {
  }
  

  public String getBundleName()
  {
    return bundleName;
  }
  
  public String getNodeName()
  {
    return nodeName;
  }
  
  public BundleData getBundleData()
  {
    return bundleData;
  }
  
  public boolean isOffer()
  {
    return offer;
  }
  
  public boolean isAddress()
  {
    return address;
  }
  
  public boolean isLicenceOnly()
  {
    return licenceOnly;
  }
  
  public int getPriority()
  {
    return priority;
  }
  
  public Licence getLicence()
  {
    return licence;
  }
  
  public int getErrCode()
  {
    return errCode;
  }
  
  public List getOtherNodes()
  {
    return otherNodes;
  }
  
  public String getSourceNodeName()
  {
    return sourceNodeName;
  }
  
  public String getAddressNodeName()
  {
    return addressNodeName;
  }
  
  public String getContractID()
  {
    return contractID;
  }
  
  public void setBundleName(String bundleName)
  {
    this.bundleName = bundleName;
  }
  
  public void setNodeName(String nodeName)
  {
    this.nodeName = nodeName;
  }
  
  public void setBundleData(BundleData bundleData)
  {
    this.bundleData = bundleData;
  }
  
  public void setOffer(boolean offer)
  {
    this.offer = offer;
  }
  
  public void setAddress(boolean address)
  {
    this.address = address;
  }
  
  public void setLicenceOnly(boolean licenceOnly)
  {
    this.licenceOnly = licenceOnly;
  }
  
  public void setPriority(int priority)
  {
    this.priority = priority;
  }
  
  public void setLicence(Licence licence)
  {
    this.licence = licence;
  }
  
  public void setErrCode(int errCode)
  {
    this.errCode = errCode;
  }
  
  public void setSourceNodeName(String sourceNodeName)
  {
    this.sourceNodeName = sourceNodeName;
  }
  
  public void setAddressNodeName(String addressNodeName)
  {
    this.addressNodeName = addressNodeName;
  }
  
  public void setContractID(String contractID)
  {
    this.contractID = contractID;
  }
  
  public void setOtherNodes(List otherNodes)
  {
    this.otherNodes = otherNodes;
  }
  
  public void addOtherNode(OtherNode otherNode)
  {
    otherNodes.add(otherNode);
  }
}
