/**
 * InOut2InOutCRole.java is a part of the SOFA project.
 * This file was created by pepan on 18.4.2003.
 */
package SOFA.SOFAnode.InOut.Connector;

import SOFA.Connector.LinkException;
import SOFA.Connector.Reference;
import SOFA.Connector.RoleBaseImpl;
import SOFA.Connector.TaggedProfile;
import SOFA.SOFAnode.InOut.Bundle;
import SOFA.SOFAnode.InOut.InOut2InOut;
import SOFA.SOFAnode.InOut.InOutException;
import SOFA.SOFAnode.TR.ComponentInfo;

/**
 *
 * @author Petr Panuska
 */
public class InOut2InOutCRole extends RoleBaseImpl implements InOut2InOut {
  protected CNInOut2InOut target;

  public void link (Object target) throws LinkException {
    try {
      if (target instanceof Reference) {
        Reference ref = (Reference) target;
        setSOFAReference(ref);
        TaggedProfile[] profiles = ref.profiles;
        for (int i = 0; i < profiles.length; i++) {
          if (profiles[i].tag.equals("LOCAL")) {
            this.target = (CNInOut2InOut) ((SOFA.Connector.ECG.Profiles.LocalProfile) profiles[i]).link;
            return;
          } else if (profiles[i].tag.equals("RMI")) {
            this.target = new InOut2InOutRMIStub(((SOFA.Connector.ECG.Profiles.RMIProfile) profiles[i]).URL);
            return;
          }
        }
      } else {
        this.target = (CNInOut2InOut) target;
      }
    } catch (Exception e) {
      throw new LinkException("Can't link InOut2InOutCRole. ", e);
    }
  }

  public Bundle pullBundle (ComponentInfo[] descs, ComponentInfo[] comps, boolean inferiors) throws InOutException {
    return target.pullBundle(descs, comps, inferiors);
  }

  public void pushBundle (Bundle bundle) throws InOutException {
    target.pushBundle(bundle);
  }
}
