/**
 * InOut2InOutRMIStub.java is a part of the SOFA project.
 * This file was created by pepan on 18.4.2003.
 */
package SOFA.SOFAnode.InOut.Connector;

import java.io.IOException;
import java.rmi.RemoteException;

import SOFA.Connector.ConnectorTransportException;
import SOFA.SOFAnode.InOut.Bundle;
import SOFA.SOFAnode.InOut.InOutException;
import SOFA.SOFAnode.TR.ComponentInfo;
import SOFA.SOFAnode.TR.Impl.BundleImpl;

/**
 *
 * @author Petr Panuska
 */
public class InOut2InOutRMIStub implements CNInOut2InOut {

  protected CNInOut2InOutRemote target;

  public InOut2InOutRMIStub (String url) throws RemoteException {
    try {
      target = (CNInOut2InOutRemote) java.rmi.Naming.lookup(url);
    } catch (java.net.MalformedURLException e) {
      throw new RemoteException("Can't create CNInOut2InOutRemote.\n" + url + "\n", e);
    } catch (java.rmi.NotBoundException e) {
      throw new RemoteException("Can't create CNInOut2InOutRemote.\n" + url + "\n", e);
    }
  }

  public Bundle pullBundle (ComponentInfo[] descs, ComponentInfo[] comps, boolean inferiors) throws InOutException {
    try {
      byte[] s = target.pullBundle(descs, comps, inferiors);
      BundleImpl bundle = new BundleImpl();
      bundle._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(s));
      return bundle;
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'InOut2InOutRMIStub.pullBundle'.", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException exception in the 'InOut2InOutRMIStub.pullBundle'.", e);
    }
  }

  public void pushBundle (Bundle bundle) throws InOutException {
    byte[] ret = null;
    try {
      cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      ((BundleImpl) bundle)._write(os);
      ret = os.toByteArray();
      target.pushBundle(ret);
    } catch (IOException e) {
      throw new ConnectorTransportException("Can't serialize in the 'InOut2InOutRMIStub.pushBundle'.", e);
    }
  }

}
