/* $Id: CompArray.java,v 1.2 2004/05/20 14:23:51 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
import java.rmi.RemoteException;

import SOFA.SOFAnode.Made.TIR.CDLRepository;
import SOFA.SOFAnode.Made.TIR.CDLType;
import SOFA.SOFAnode.Made.TIR.TIRExceptCreate;

class CompArray extends CompObjectIm implements CompType {
  public CompExprOper length;
  public CompType type;

  public CompArray(CompType t, CompExprOper e) {
    super(ObjectsKind.o_Array);
    type = t;
    length = e;
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    if (!CompExprOper.testPropInExpr(props, length.nameProp(rep)))
      throw new CDLExceptCheck("Unknown property");
    type.checkConsist(props,rep);
  }

  public CDLType toNormal(CDLRepository newRep) throws CDLExceptRemote, CDLExceptToNormal, CDLExceptLock {
    try {
      return newRep.create_array(length.toNormal(newRep), type.toNormal(newRep));
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptCreate e) {
      throw new CDLExceptToNormal("Can't get primitve type\n"+e.getMessage());
    } 
  }
}
