/* $Id: CompInterface.java,v 1.2 2004/05/20 14:23:51 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
import java.rmi.RemoteException;

import SOFA.SOFAnode.Made.TIR.AttributeDef;
import SOFA.SOFAnode.Made.TIR.CDLRepository;
import SOFA.SOFAnode.Made.TIR.CDLType;
import SOFA.SOFAnode.Made.TIR.ConstantDef;
import SOFA.SOFAnode.Made.TIR.Contained;
import SOFA.SOFAnode.Made.TIR.Container;
import SOFA.SOFAnode.Made.TIR.DefinitionKind;
import SOFA.SOFAnode.Made.TIR.EnumDef;
import SOFA.SOFAnode.Made.TIR.ExceptionDef;
import SOFA.SOFAnode.Made.TIR.ExprFixed;
import SOFA.SOFAnode.Made.TIR.ExprOperDef;
import SOFA.SOFAnode.Made.TIR.InterfaceDef;
import SOFA.SOFAnode.Made.TIR.OperationDef;
import SOFA.SOFAnode.Made.TIR.ProtocolDef;
import SOFA.SOFAnode.Made.TIR.ProtocolOperDef;
import SOFA.SOFAnode.Made.TIR.StructDef;
import SOFA.SOFAnode.Made.TIR.TIRExceptCalculate;
import SOFA.SOFAnode.Made.TIR.TIRExceptCreate;
import SOFA.SOFAnode.Made.TIR.TIRExceptLock;
import SOFA.SOFAnode.Made.TIR.TypedefDef;
import SOFA.SOFAnode.Made.TIR.UnionDef;

class CompInterface extends CompContainedContainerIm implements CompType {
  class NName {
    String iface;  // name if iface
    String name;
    boolean isOper;   // is operation? 
    public NName(String iface, String name, boolean isOper) {
      this.iface = iface;
      this.name = name;
      this.isOper = isOper;
    }
  }
  
  class Names extends List {
    public Names() { super(); }
    public boolean isIn(String iface, String name) {
      akt = first;
      for (int i=0;i<count;i++) {
        if (name.compareTo(((NName)akt.item).name)==0 && iface.compareTo(((NName)akt.item).iface)!=0)
          return true;
        toNext();
      }
      return false;
    }

    public void addName(String iface, String name, boolean isOper) {
      add(new NName(iface,name,isOper));
    }
  }
  
  boolean forwarddcl;
  boolean wasforwarddcl;
  List baseIfaces;
  CompProtOper protocol;
  Names names;  // all names (direct and inherited) in iface
  
  public CompInterface(ID id, CompContainer in, CompRepository inRep, boolean fwd) {
    super(ObjectsKind.o_Interface, id, in, inRep);
    forwarddcl = fwd;
    wasforwarddcl = false;
    baseIfaces = new List();
    protocol = null;
    names = new Names();
//    Debug.message("Vytvarim interface: "+id);
  }

  public boolean setBaseIfaces(List bi) throws CDLExceptLock, CDLExceptRemote {
    int i;
    bi.toFirst();
    for (int k=0;k<bi.size();k++) {
      CompReffer ref = (CompReffer) bi.aktual();
      if (ref.isNew) {
        CompContainer con = rep;
        ref.ref.sn.names.toFirst();
        for(i=0;i<ref.ref.sn.names.size();i++) {
          CompContained[] a = con.lookup((String) ref.ref.sn.names.aktual());
          if (a==null || a.length==0) 
            return false;
          if (a.length==1) {
            if (a[0].isContainer()) con = (CompContainer) a[0];
            else return false;
          } else {
            return false;
          }
          ref.ref.sn.names.toNext();
        }
        CompContained sec = con.lookup(ref.ref.name, ref.ref.version);
        if (sec!=null) {
          if (sec.objectKind() != ObjectsKind.o_Interface)
            return false;
          Names obj = ((CompInterface) sec).names;
          obj.toFirst();
          for (int j=0;j<obj.size();j++) {  
            if (names.isIn(((NName) obj.aktual()).iface, ((NName) obj.aktual()).name))
              return false;
              names.addName(((NName) obj.aktual()).iface,((NName) obj.aktual()).name,((NName) obj.aktual()).isOper);
            obj.toNext();
          }
/*          obj.toFirst();
          for (int j=0;j<obj.size();j++) {  // adding
            names.addName(((NName) obj.aktual()).iface,((NName) obj.aktual()).name,((NName) obj.aktual()).isOper);
            obj.toNext();
          } */
        // !!!
          CompReffer nb = new CompReffer();
          nb.what = sec.objectKind();
          nb.ref = new FullID(true);
          nb.ref.name = new String(ref.ref.name);
          nb.ref.version = new String(ref.ref.version);
          nb.ref.isin = IDKind.version;
          nb.isNew = true;
          ref.ref.sn.names.toFirst();
          for(int j=0;j<ref.ref.sn.names.size();j++) {
            nb.ref.sn.addScope(new String((String)ref.ref.sn.names.aktual()));
            ref.ref.sn.names.toNext();
          }
          baseIfaces.add(nb);
        // !!!  
        }
      } else {
        try {
          Container con = rep.cdlRepository;
          ref.ref.sn.names.toFirst();
          for(i=0;i<ref.ref.sn.names.size();i++) {
            Contained[] a = con.lookup_name((String) ref.ref.sn.names.aktual());
            if (a==null || a.length==0) 
              return false;
           if (a.length==1) {
              if (a[0] instanceof Container) con = (Container) a[0];
              else return false;
            } else {
              boolean found = false;
              for(int j=0;j<a.length;j++) {
                if (a[j].get_identification().version().compareTo(ref.ref.version)==0) {
                  if ( !(a[j] instanceof Container)) return false;
                  found = true;
                  con = (Container) a[j];
                  break;
                }
              }
              if (!found) return false;
            }
            ref.ref.sn.names.toNext();
          }
          Contained sec = con.lookup(ref.ref.name, ref.ref.version);
          if (sec!=null) {
            if (sec.get_def_kind().value() != DefinitionKind.dk_Interface)
              return false;
            int j;
            Contained[] obj = ((InterfaceDef) sec).contents(null);
            for (j=0;j<obj.length;j++) {  
              boolean isOper = false;
              if (names.isIn(ref.ref.name, obj[j].get_identification().name()))
                return false;
              if (obj[j].get_def_kind().value() == DefinitionKind.dk_Operation)
                isOper = true;
              names.addName(ref.ref.name, new String(obj[j].get_identification().name()),isOper);
            }
            // test base ifaces of this (base iface)
            if (!testSetBaseIfaces((InterfaceDef)sec))
              return false;
/*          for (j=0;j<obj.length;j++) {  // adding 
              boolean isOper = false;
              if (obj[j].get_def_kind().value() == DefinitionKind.dk_Operation)
                isOper = true;
              names.addName(ref.ref.name, new String(obj[j].get_identification().name()),isOper);
            } */

            // !!!
            CompReffer nb = new CompReffer();
            nb.what = sec.get_def_kind().value();
            nb.ref = new FullID(true);
            nb.ref.name = new String(ref.ref.name);
            nb.ref.version = new String(ref.ref.version);
            nb.ref.isin = IDKind.version;
            nb.isNew = false;
            ref.ref.sn.names.toFirst();
            for(int l=0;l<ref.ref.sn.names.size();l++) {
              nb.ref.sn.addScope(new String((String)ref.ref.sn.names.aktual()));
              ref.ref.sn.names.toNext();
            }
            baseIfaces.add(nb);
            // !!!

          }
        } catch (TIRExceptLock e) {
          throw new CDLExceptLock("Repository is locked.");
        } catch (RemoteException e) {
          throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
        }
      }

      bi.toNext();
    }
    return true;
  }

  private boolean testSetBaseIfaces(InterfaceDef iface) throws TIRExceptLock, RemoteException {
    InterfaceDef[] bbase = ((InterfaceDef) iface).base_interfaces();
    for (int i=0;i<bbase.length;i++) {
      Contained[] obj = ((InterfaceDef) bbase[i]).contents(null);
      for (int j=0;j<obj.length;j++) {
        boolean isOper = false;
        if (names.isIn(((InterfaceDef) bbase[i]).get_identification().name(),obj[j].get_identification().name()))
           return false;
        if (obj[j].get_def_kind().value() == DefinitionKind.dk_Operation)
          isOper = true;
        names.addName(((InterfaceDef) bbase[i]).get_identification().name(),new String(obj[j].get_identification().name()),isOper);
      }
      if (!testSetBaseIfaces(bbase[i]))
        return false;
    }
    return true;
  }

/*  private void setBaseIfaces(InterfaceDef iface) throws TIRExceptLock, RemoteException {
    InterfaceDef[] bbase = ((InterfaceDef) iface).base_interfaces();
    for (int i=0;i<bbase.length;i++) {
      Contained[] obj = ((InterfaceDef) bbase[i]).contents(null);
      for (int j=0;j<obj.length;j++) {
        boolean isOper = false;
        if (obj[j].get_def_kind().value() == DefinitionKind.dk_Operation)
          isOper = true;
        names.addName(((InterfaceDef) bbase[i]).get_identification().name(),new String(obj[j].get_identification().name()),isOper);
      }
      setBaseIfaces(bbase[i]);
    }
  }*/
  
  public boolean addObject(CompContained o) {
    ((CompContained) o).getIdent().version = id.version;
    // search in baseIfaces
    String nm = o.getIdent().name;
    if (names.isIn(id.name, nm))
      return false;
    boolean isOper = false;
    if (o.objectKind()==ObjectsKind.o_Operation)
      isOper = true;
    names.addName(id.name,nm,isOper);
    return super.addObject(o);
  }

  public boolean isOperationName(String name) {
    names.toFirst();
    for (int i=0;i<names.size();i++) {
      if ((((NName) names.aktual()).name.compareTo(name)==0) && (((NName) names.aktual()).isOper))
        return true;
      names.toNext();
    }
    return false;
  }

  /** return all (direct and inherit) operation's names */
  public EnumList operationNames() {
    EnumList ret = new EnumList();
    names.toFirst();
    for (int i=0;i<names.size();i++) {
      if (((NName) names.aktual()).isOper)
        ret.addName(((NName) names.aktual()).name);
      names.toNext();
    }
    return ret;
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    // test if it wasn't only fwd declaration
    if (forwarddcl)
      throw new CDLExceptCheck("Forward declaration of interface "+fullName()+" only.");
    if (props == null) {
      ; 
    } else {
      // test for properties
      CompContained[] cont = contents();
      for (int i=0;i<cont.length;i++) {
        cont[i].checkConsist(props, rep);
      }
    }

    if (rep.useProtocols) {
      if (protocol == null && contents().length!=0)
        throw new CDLExceptCheck("No protocol for interface "+fullName());
    }

  }

  public void addToNormal(Container obj, CDLRepository normRep, java.util.ArrayList delayed) throws CDLExceptToNormal, CDLExceptRemote, CDLExceptLock {
/*    
    System.out.println("***"+id.toString()+"***");
    if (wasforwarddcl) {
      delayed.add(this);
      delayed.add(obj);
      System.out.println("fwddcl");
    } else { */

    delayed.add(this);
    delayed.add(obj);
    return;
   /* 
    if (id.isin == IDKind.versiontag) {
      try {
        ((Contained)obj).tag(id.tag);
      } catch (RemoteException e) {
        throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
      } catch (TIRExceptLock e) {
        throw new CDLExceptLock("Repository is locked.");
      } catch (TIRExceptCreate ecr) {
        throw new CDLExceptToNormal("Can't set tag for "+ fullName());
      }
    }
    cont.toFirst();
    try {
      for (int i=0;i<cont.size(); i++) {
        CompContained akt = (CompContained) cont.aktual();
        switch (akt.objectKind()) {
        // *****************
        case ObjectsKind.o_Typedef:
          try {
            TypedefDef td = ((InterfaceDef) obj).create_typedef(akt.getIdent().id, ((CompTypedef) akt).type.toNormal(normRep));
            if (td == null) 
              throw new CDLExceptToNormal("Can't create typedef "+((CompContained)akt).fullName());
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create typedef "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Enum:
          try {
            EnumDef en = ((InterfaceDef) obj).create_enum(akt.getIdent().id);
            if (en == null) 
              throw new CDLExceptToNormal("Can't create enum "+((CompContained)akt).fullName());
            ((CompEnum) akt).addToNormal(en);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create enum "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Struct:
          try {
            StructDef str = ((InterfaceDef) obj).create_struct(akt.getIdent().id);
            if (str == null) 
              throw new CDLExceptToNormal("Can't create struct "+((CompContained)akt).fullName());
            ((CompStruct) akt).addToNormal(str, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create struct "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Union:
          try {
            UnionDef un = ((InterfaceDef) obj).create_union(akt.getIdent().id, ((CompUnion) akt).switch_type.toNormal(normRep));
            if (un == null) 
              throw new CDLExceptToNormal("Can't create union "+((CompContained)akt).fullName());
            ((CompUnion) akt).addToNormal(un, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create union "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Exception:
          try {
            ExceptionDef str = ((InterfaceDef) obj).create_exception(akt.getIdent().id);
            if (str == null) 
              throw new CDLExceptToNormal("Can't create exception "+((CompContained)akt).fullName());
            ((CompException) akt).addToNormal(str, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create exception "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Constant:
          try {
            ConstantDef cnst;
            if (((CompConstant) akt).type.objectKind() == ObjectsKind.o_Fixed) {
              ExprOperDef expr = ((CompExprOper) ((CompConstant)akt).expr).toNormal(normRep);
              ExprOperDef cexpr = null;
              try {
                cexpr = expr.calculate();
              } catch (TIRExceptCalculate e) {
                throw new CDLExceptToNormal("Bad expression in the constant "+((CompContained)akt).fullName());
              }
              ((CompFixed) ((CompConstant) akt).type).digits = new CompExprInteger(((ExprFixed) cexpr).digits());
              ((CompFixed) ((CompConstant) akt).type).scale = new CompExprInteger(((ExprFixed) cexpr).scale());
              cnst = ((InterfaceDef) obj).create_constant(akt.getIdent().id, ((CompConstant) akt).type.toNormal(normRep), expr);
            } else {
              cnst = ((InterfaceDef) obj).create_constant(akt.getIdent().id, ((CompConstant) akt).type.toNormal(normRep), ((CompExprOper) ((CompConstant)akt).expr).toNormal(normRep));
            }
            if (cnst == null) 
              throw new CDLExceptToNormal("Can't create constant "+((CompContained)akt).fullName());
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create constant "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Attribute:
          try {
            AttributeDef attr = ((InterfaceDef) obj).create_attribute(akt.getIdent().id, ((CompAttribute) akt).type.toNormal(normRep), ((CompAttribute)akt).mode);
            if (attr == null) 
              throw new CDLExceptToNormal("Can't create attribute "+((CompContained)akt).fullName());
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create attribute "+((CompContained)akt).fullName()+"\n"+
                                         ecr.getMessage());
          }
          break;
        // *****************
        case ObjectsKind.o_Operation:
          try {
            ExceptionDef[] raises = null;
            if (((CompOperation) akt).raises != null) {
              ((CompOperation) akt).raises.toFirst();
              raises = new ExceptionDef [((CompOperation) akt).raises.size()];
              for (int j=0;j<((CompOperation) akt).raises.size();j++) {
                raises[j] = (ExceptionDef) ((CompType) ((CompOperation) akt).raises.aktual()).toNormal(normRep);
                ((CompOperation) akt).raises.toNext();
              }
            } else {
              raises = new ExceptionDef [0];
            }
            OperationDef oper = ((InterfaceDef) obj).create_operation(akt.getIdent().id, ((CompOperation) akt).type.toNormal(normRep) , raises);
            if (oper == null) 
              throw new CDLExceptToNormal("Can't create operation "+((CompContained)akt).fullName());
            ((CompOperation) akt).addToNormal(oper, normRep);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create operation "+((CompContained)akt).fullName()+"\n"+
                                         ecr.getMessage());
          }
          break;
        default:
          throw new CDLExceptToNormal("Unexcepted kind of object"); 
        }
        cont.toNext();
      }
      if (protocol != null) {
        try {
          ProtocolDef newProt = ((InterfaceDef) obj).create_protocol();
          ProtocolOperDef p = CompProtOper.toNormalIface(protocol, newProt);
	  newProt.protocol(p);
	} catch (TIRExceptCreate ecr) {
	  throw new CDLExceptToNormal("Can't create protocol in "+ fullName()+"\n"+
                                         ecr.getMessage());
	}
      }
      
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptLock e) {
      throw new CDLExceptLock("Repository is locked.");
    } */


   /* } */
  }


  public void addToNormalDelayed(Container obj, CDLRepository normRep, java.util.ArrayList delayed) throws CDLExceptToNormal, CDLExceptRemote, CDLExceptLock {
    try {
      InterfaceDef[] base = null;
      if (baseIfaces != null) {
        baseIfaces.toFirst();
        base = new InterfaceDef [baseIfaces.size()];
        for (int j=0;j<baseIfaces.size();j++) {
          base[j] = (InterfaceDef) ((CompType) baseIfaces.aktual()).toNormal(normRep);
          baseIfaces.toNext();
        }
        //System.out.println(id.toString()+"***");
        //System.out.println(base.length);
        ((InterfaceDef) obj).setBaseInterfaces(base); 
      }
      
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptCreate ecr) {
      throw new CDLExceptToNormal("Can't create interface "+fullName());
    }
    
    if (id.isin == IDKind.versiontag) {
      try {
        ((Contained)obj).tag(id.tag);
      } catch (RemoteException e) {
        throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
      } catch (TIRExceptLock e) {
        throw new CDLExceptLock("Repository is locked.");
      } catch (TIRExceptCreate ecr) {
        throw new CDLExceptToNormal("Can't set tag for "+ fullName());
      }
    }
    cont.toFirst();
    try {
      for (int i=0;i<cont.size(); i++) {
        CompContained akt = (CompContained) cont.aktual();
        switch (akt.objectKind()) {
        // *****************
        case ObjectsKind.o_Typedef:
          try {
            TypedefDef td = ((InterfaceDef) obj).create_typedef(akt.getIdent().id, ((CompTypedef) akt).type.toNormal(normRep));
            if (td == null) 
              throw new CDLExceptToNormal("Can't create typedef "+((CompContained)akt).fullName());
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create typedef "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Enum:
          try {
            EnumDef en = ((InterfaceDef) obj).create_enum(akt.getIdent().id);
            if (en == null) 
              throw new CDLExceptToNormal("Can't create enum "+((CompContained)akt).fullName());
            ((CompEnum) akt).addToNormal(en);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create enum "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Struct:
          try {
            StructDef str = ((InterfaceDef) obj).create_struct(akt.getIdent().id);
            if (str == null) 
              throw new CDLExceptToNormal("Can't create struct "+((CompContained)akt).fullName());
            ((CompStruct) akt).addToNormal(str, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create struct "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Union:
          try {
            UnionDef un = ((InterfaceDef) obj).create_union(akt.getIdent().id, ((CompUnion) akt).switch_type.toNormal(normRep));
            if (un == null) 
              throw new CDLExceptToNormal("Can't create union "+((CompContained)akt).fullName());
            ((CompUnion) akt).addToNormal(un, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create union "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Exception:
          try {
            ExceptionDef str = ((InterfaceDef) obj).create_exception(akt.getIdent().id);
            if (str == null) 
              throw new CDLExceptToNormal("Can't create exception "+((CompContained)akt).fullName());
            ((CompException) akt).addToNormal(str, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create exception "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Constant:
          try {
            ConstantDef cnst;
            if (((CompConstant) akt).type.objectKind() == ObjectsKind.o_Fixed) {
              ExprOperDef expr = ((CompExprOper) ((CompConstant)akt).expr).toNormal(normRep);
              ExprOperDef cexpr = null;
              try {
                cexpr = expr.calculate();
              } catch (TIRExceptCalculate e) {
                throw new CDLExceptToNormal("Bad expression in the constant "+((CompContained)akt).fullName());
              }
              ((CompFixed) ((CompConstant) akt).type).digits = new CompExprInteger(((ExprFixed) cexpr).digits());
              ((CompFixed) ((CompConstant) akt).type).scale = new CompExprInteger(((ExprFixed) cexpr).scale());
              cnst = ((InterfaceDef) obj).create_constant(akt.getIdent().id, ((CompConstant) akt).type.toNormal(normRep), expr);
            } else {
              cnst = ((InterfaceDef) obj).create_constant(akt.getIdent().id, ((CompConstant) akt).type.toNormal(normRep), ((CompExprOper) ((CompConstant)akt).expr).toNormal(normRep));
            }
            if (cnst == null) 
              throw new CDLExceptToNormal("Can't create constant "+((CompContained)akt).fullName());
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create constant "+((CompContained)akt).fullName());
          }
          break;
        // *****************
        case ObjectsKind.o_Attribute:
          try {
            AttributeDef attr = ((InterfaceDef) obj).create_attribute(akt.getIdent().id, ((CompAttribute) akt).type.toNormal(normRep), ((CompAttribute)akt).mode);
            if (attr == null) 
              throw new CDLExceptToNormal("Can't create attribute "+((CompContained)akt).fullName());
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create attribute "+((CompContained)akt).fullName()+"\n"+
                                         ecr.getMessage());
          }
          break;
        // *****************
        case ObjectsKind.o_Operation:
          try {
            ExceptionDef[] raises = null;
            if (((CompOperation) akt).raises != null) {
              ((CompOperation) akt).raises.toFirst();
              raises = new ExceptionDef [((CompOperation) akt).raises.size()];
              for (int j=0;j<((CompOperation) akt).raises.size();j++) {
                raises[j] = (ExceptionDef) ((CompType) ((CompOperation) akt).raises.aktual()).toNormal(normRep);
                ((CompOperation) akt).raises.toNext();
              }
            } else {
              raises = new ExceptionDef [0];
            }
            OperationDef oper = ((InterfaceDef) obj).create_operation(akt.getIdent().id, ((CompOperation) akt).type.toNormal(normRep) , raises);
            if (oper == null) 
              throw new CDLExceptToNormal("Can't create operation "+((CompContained)akt).fullName());
            ((CompOperation) akt).addToNormal(oper, normRep);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create operation "+((CompContained)akt).fullName()+"\n"+
                                         ecr.getMessage());
          }
          break;
        default:
          throw new CDLExceptToNormal("Unexcepted kind of object"); 
        }
        cont.toNext();
      }
      if (protocol != null) {
        try {
          ProtocolDef newProt = ((InterfaceDef) obj).create_protocol();
          ProtocolOperDef p = CompProtOper.toNormalIface(protocol, newProt);
	  newProt.protocol(p);
	} catch (TIRExceptCreate ecr) {
	  throw new CDLExceptToNormal("Can't create protocol in "+ fullName()+"\n"+
                                         ecr.getMessage());
	}
      }
      
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptLock e) {
      throw new CDLExceptLock("Repository is locked.");
    }
  }

  /** from CompType */
  public CDLType toNormal(CDLRepository newRep) throws CDLExceptToNormal {
    // never call this
    throw new CDLExceptToNormal("It should never throw");
  }

  public String protocolToText() {
    if (protocol != null) {
      return protocol.toText();
    }
    return "-- no protocol --";
  }
}
