/* $Id: AbsoluteNameImpl.java,v 1.2 2004/05/20 14:23:52 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import SOFA.SOFAnode.Made.TIR.AbsoluteName;

public class AbsoluteNameImpl extends UnicastRemoteObject implements AbsoluteName {
  int count;
  String[] n;
  
  public AbsoluteNameImpl(String name) throws RemoteException {
    int i;
    count = 0;
    if (name.compareTo("")==0 || name.compareTo("::")==0) {
      n = new String [1];
      n[0] = "";
      return;
    }
    for (i=0;i<name.length();i++) {
      if (name.charAt(i)==':' && name.charAt(i+1)==':') 
        count++;
    }
    n = new String [count];
    int j = 0;
    for(i=0;i<count;i++) {
      StringBuffer str = new StringBuffer();
      while (name.charAt(j)==':')
        j++;
      while (j<name.length() && name.charAt(j)!=':') {
        str = str.append(name.charAt(j));
        j++;
      }
      n[i] = str.toString();
    }
    if (count == 0)
      n[0] = "";
    if ((count==1) && (n[0].compareTo("")==0))
      count = 0;
  }
 
  private AbsoluteNameImpl(String[] str) throws RemoteException {
    count = str.length-1;
    n = new String [count];
    for(int i=0;i<str.length-1;i++) {
      n[i] = new String(str[i]);
    }
  }

  /** This constructor is called from constructor of IdentificationImpl for creating lang_absolute_name. */
  AbsoluteNameImpl(String lang, AbsoluteNameImpl abs) throws RemoteException {
    count = abs.count + 1;
    n = new String[count];
    n[0] = new String(lang);
    for (int i=1;i<count;i++) {
      n[i] = new String(abs.n[i-1]);
    }
  }
 
  public AbsoluteName parent() throws RemoteException {
    if (count<=1) 
      return null;
    return (AbsoluteName) new AbsoluteNameImpl(n);
  }

  public String name() throws RemoteException {
    StringBuffer sb = new StringBuffer("");
    for (int i=0;i<count;i++) {
      sb = sb.append("::" + n[i]);
    }
    return sb.toString();
  }

  public String toString() {
    StringBuffer sb = new StringBuffer("");
    for (int i=0;i<count;i++) {
      sb = sb.append("::" + n[i]);
    }
    return sb.toString();
  }

  public int size() throws RemoteException {
    return count;
  }
  
  public String elementAt(int i) throws RemoteException {
    if (i>=0 && i<count)
      return n[i];
    else 
      return null;
  }

  public boolean isEqual(AbsoluteName an) throws RemoteException {
    if (count != an.size())
      return false;
    for (int i=0;i<count;i++) {
      if (n[i].compareTo(an.elementAt(i)) != 0)
        return false;
    }
    return true;
  }

  boolean isEqualL(AbsoluteNameImpl an) {
    if (count != an.count)
      return false;
    for (int i=0;i<count;i++) {
      if (n[i].compareTo(an.n[i]) != 0)
        return false;
    }
    return true;
  }
}
