/* $Id: BindTypeNormalImpl.java,v 1.2 2004/05/20 14:23:52 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import java.io.IOException;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import SOFA.SOFAnode.Made.TIR.BindTypeKind;
import SOFA.SOFAnode.Made.TIR.BindTypeNormal;
import SOFA.SOFAnode.Made.TIR.Container;
import SOFA.SOFAnode.Made.TIR.DefinitionKind;
import SOFA.SOFAnode.Made.TIR.Repository;
import SOFA.SOFAnode.Made.TIR.StateKind;
import SOFA.SOFAnode.Made.TIR.TIRExceptCommit;

public class BindTypeNormalImpl extends UnicastRemoteObject implements BindTypeNormal, TIRImplObject {
  DefinitionKindImpl defKindImpl;
  StateKindImpl stKindImpl;
  BindTypeKind btk;
  String nm;
  
  public BindTypeNormalImpl(String name) throws RemoteException {
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_BindType);
    stKindImpl = new StateKindImpl(StateKind.sk_work);
    btk = new BindTypeKindImpl(BindTypeKind.btk_normal);
    nm = name;
  }

  public BindTypeNormalImpl() throws RemoteException {
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_BindType);
    stKindImpl = new StateKindImpl(StateKind.sk_normal);
    btk = new BindTypeKindImpl(BindTypeKind.btk_normal);
    nm = null;
  }

/* from interface TIRObject */
  public DefinitionKind get_def_kind() throws RemoteException {
    return (DefinitionKind) defKindImpl;
  }

  /* from interface TIRObject */
  public StateKind get_state() throws RemoteException {
    return (StateKind) stKindImpl;
  }

  public BindTypeKind get_bt_kind() throws RemoteException {
    return btk;
  }

  public String name() throws RemoteException {
    return nm;
  }

  public void save(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      st.curOutFile.writeInt(btk.value());
      Storage.writeString(st.curOutFile, nm);
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't write in directory "+st.current+".");
    }   
  }

  public void load(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      nm = Storage.readString(st.curInFile);     
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't read in directory "+st.current+".");
    }
  }

  public void postLoad(RepositoryImpl r) throws RemoteException, TIRExceptStorage {}

  public boolean isNew() {
    return (stKindImpl.value()==StateKind.sk_work);
  }

  public void canCommit() throws RemoteException, TIRExceptCommit {;}

  public void doCommit(Container in, Repository rep) throws RemoteException {
    if (stKindImpl.value()==StateKind.sk_normal)
      return;
    if (isNew()) {  
      stKindImpl.toNormal();
    }
  }

  public void doAbort(long workId) throws RemoteException {}
}
