/* $Id: ParamModeImpl.java,v 1.2 2004/05/20 14:23:52 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import java.io.IOException;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import SOFA.SOFAnode.Made.TIR.Container;
import SOFA.SOFAnode.Made.TIR.ParamMode;
import SOFA.SOFAnode.Made.TIR.Repository;
import SOFA.SOFAnode.Made.TIR.TIRExceptCommit;

public class ParamModeImpl extends UnicastRemoteObject implements ParamMode, TIRImplObject {
  int m;
  
  public ParamModeImpl(int mode) throws RemoteException {
    m = mode;
  }

  public ParamModeImpl() throws RemoteException {
    m = 0;
  }

  public int value() throws RemoteException {
    return m;
  }

  /*from interface TIRImplObject */
  public void load(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      m = st.curInFile.readInt();
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't read in file "+st.currentFile+".");
    }
  }

  /*from interface TIRImplObject */
  public void save(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      st.curOutFile.writeInt(m);
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't write in file "+st.currentFile+".");
    }  
  }
  
  public void postLoad(RepositoryImpl r) throws RemoteException, TIRExceptStorage {
    ;
  }

  public boolean isNew() { return false;}
  public void canCommit() throws RemoteException, TIRExceptCommit {;}
  public void doCommit(Container in, Repository rep) throws RemoteException {;}
  public void doAbort(long workId) throws RemoteException {}
}
