/* $Id: RepositoryImpl.java,v 1.2 2004/05/20 14:23:52 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.rmi.RemoteException;

import SOFA.SOFAnode.Made.TIR.ArrayDef;
import SOFA.SOFAnode.Made.TIR.CDLType;
import SOFA.SOFAnode.Made.TIR.ConstantDef;
import SOFA.SOFAnode.Made.TIR.Contained;
import SOFA.SOFAnode.Made.TIR.Container;
import SOFA.SOFAnode.Made.TIR.DefinitionKind;
import SOFA.SOFAnode.Made.TIR.EnumDef;
import SOFA.SOFAnode.Made.TIR.ExprBinOperationDef;
import SOFA.SOFAnode.Made.TIR.ExprBoolean;
import SOFA.SOFAnode.Made.TIR.ExprChar;
import SOFA.SOFAnode.Made.TIR.ExprConstant;
import SOFA.SOFAnode.Made.TIR.ExprDefault;
import SOFA.SOFAnode.Made.TIR.ExprDouble;
import SOFA.SOFAnode.Made.TIR.ExprEnum;
import SOFA.SOFAnode.Made.TIR.ExprFixed;
import SOFA.SOFAnode.Made.TIR.ExprFloat;
import SOFA.SOFAnode.Made.TIR.ExprLong;
import SOFA.SOFAnode.Made.TIR.ExprLongDouble;
import SOFA.SOFAnode.Made.TIR.ExprLongLong;
import SOFA.SOFAnode.Made.TIR.ExprOctet;
import SOFA.SOFAnode.Made.TIR.ExprOperDef;
import SOFA.SOFAnode.Made.TIR.ExprProperty;
import SOFA.SOFAnode.Made.TIR.ExprShort;
import SOFA.SOFAnode.Made.TIR.ExprString;
import SOFA.SOFAnode.Made.TIR.ExprUnOperationDef;
import SOFA.SOFAnode.Made.TIR.ExprUnsigLong;
import SOFA.SOFAnode.Made.TIR.ExprUnsigLongLong;
import SOFA.SOFAnode.Made.TIR.ExprUnsigShort;
import SOFA.SOFAnode.Made.TIR.ExprWchar;
import SOFA.SOFAnode.Made.TIR.ExprWstring;
import SOFA.SOFAnode.Made.TIR.FixedDef;
import SOFA.SOFAnode.Made.TIR.Identification;
import SOFA.SOFAnode.Made.TIR.ManageProfiles;
import SOFA.SOFAnode.Made.TIR.ManageRepository;
import SOFA.SOFAnode.Made.TIR.PrimitiveDef;
import SOFA.SOFAnode.Made.TIR.ProfileDef;
import SOFA.SOFAnode.Made.TIR.ProviderDef;
import SOFA.SOFAnode.Made.TIR.Repository;
import SOFA.SOFAnode.Made.TIR.SequenceDef;
import SOFA.SOFAnode.Made.TIR.StateKind;
import SOFA.SOFAnode.Made.TIR.StringDef;
import SOFA.SOFAnode.Made.TIR.TIRExceptCreate;
import SOFA.SOFAnode.Made.TIR.TIRExceptLock;
import SOFA.SOFAnode.Made.TIR.TIRExceptSave;
import SOFA.SOFAnode.Made.TIR.TIRObject;
import SOFA.SOFAnode.Made.TIR.ValueGen;
import SOFA.SOFAnode.Made.TIR.WorkRepository;
import SOFA.SOFAnode.Made.TIR.WstringDef;

public class RepositoryImpl extends ContainerImpl implements Repository, ManageRepository, SRepository {
  DefinitionKindImpl defKindImpl;
  StateKindImpl stKindImpl;
  //int numOfItems;
  //LiItem firstChild;
  //LiItem lastChild;
  Lock lock;   // lock for lookup, contents -- lock when commit 
  Lock lockGetCreate;  // lock using for lockForCreate, if can lock 
  Lock lockCreate;     // no more create or lockForCreate 
  long lockFor;        // for which work object is lock for create
  Storage storage;
  PrimitiveDef[] primitives;

  String sofaNodeName;
  long uniq;   // akt unique number 

  LiItem firstWork;  // for active (not commited, not aborted) work repositories
  LiItem lastWork;
  int numOfWorks;

  ManageProfilesImpl mProfiles;
  Lock lockProfiles;   // lock for ManageProfiles

  // root == root directory of repository
  public RepositoryImpl(String root, String sofaNodeName) throws RemoteException, TIRExceptStorage {
    super();
    System.out.print("Starting repository...");
    lock = new Lock(false);
    lockGetCreate = new Lock(false);
    lockCreate = new Lock(false);
    File f = new File(root);
    if (!f.exists())
      throw new TIRExceptStorage(root+" doesn't exit.");
    if (!f.isDirectory())
      throw new TIRExceptStorage(root+" isn't directory.");
    File fc = new File(root);  
    storage = new Storage(f,fc);
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_Repository);
    stKindImpl = new StateKindImpl(StateKind.sk_normal);
    primitives = new PrimitiveDef [17];
    for(int i=0;i<17;i++) {
      primitives[i] = new PrimitiveDefImpl(i,StateKind.sk_normal);
    }
    mProfiles = new ManageProfilesImpl(this);
    load(storage);
    this.sofaNodeName = sofaNodeName;
    System.out.println("OK");
    lockFor = -1L;
    firstWork = lastWork = null;
    numOfWorks = 0;
    lockProfiles = new Lock(false);
  }

  public PrimitiveDef get_prim(int pkind) throws RemoteException {
    return primitives[pkind];
  }
  
  /* from interface TIRImplObject */
  public void load(Storage st) throws RemoteException, TIRExceptStorage {
    /*String[][] childs;
    try {
      childs = st.listOfChilds();
    } catch (TIRExceptStorage e) {
      // there is nothing in repository
      uniq = 0;
      return;
    }
    try {
    
      BufferedReader index = new BufferedReader(new FileReader(new File(st.current,st.indexFile).toString()));
      String un = index.readLine();
      uniq = Long.parseLong(un);
      index.close();
      File old = st.current;
      TIRImplObject m;
      IdentificationImpl idl;
      for(int i=0;i<childs.length;i++) {
        switch (Integer.parseInt(childs[i][1])) {
        case DefinitionKind.dk_Module: 
	  idl = dentificationImpl("::"+childs[i][2],"");
	  m = new ModuleDefImpl(idl,this,this,StateKind.sk_normal,-1L);
      	  st.current = new File(st.current,childs[i][0]);
      	  m.load(st);
	  addListItem((TIRObject) m);
	  st.current = old;
	  break; 

        case DefinitionKind.dk_Provider: 
	  idl = new IdentificationImpl("::"+childs[i][2],"");
	  m = new ProviderDefImpl(idl,this, this,StateKind.sk_normal,-1L);
      	  st.current = new File(st.current,childs[i][0]);
      	  m.load(st);
	  addListItem((TIRObject) m);
	  st.current = old;
	  break;
	
	case DefinitionKind.dk_Struct:
	  st.currentFile = new File(old,childs[i][0]);
	  st.curInFile = null;
	  m = new StructDefImpl(this,this);
	  m.load(st);
          addListItem((TIRObject) m);
	  st.currentFile = null;
	  break;
	case DefinitionKind.dk_Exception:
	  st.currentFile = new File(old,childs[i][0]);
	  st.curInFile = null;
	  m = new ExceptionDefImpl(this,this);
	  m.load(st);
          addListItem((TIRObject) m);
	  st.currentFile = null;
	  break;  
	case DefinitionKind.dk_Enum:
	  st.currentFile = new File(old,childs[i][0]);
	  st.curInFile = null;
	  m = new EnumDefImpl(this,this);
	  m.load(st);
          addListItem((TIRObject) m);
	  st.currentFile = null;
	  break;
        case DefinitionKind.dk_Union:
	  st.currentFile = new File(old,childs[i][0]);
	  st.curInFile = null;
	  m = new UnionDefImpl(this,this);
	  m.load(st);
          addListItem((TIRObject) m);
	  st.currentFile = null;
	  break;
        case DefinitionKind.dk_Constant:
	  st.currentFile = new File(old,childs[i][0]);
	  st.curInFile = null;
	  m = new ConstantDefImpl(this,this);
	  m.load(st);
          addListItem((TIRObject) m);
	  st.currentFile = null;
	  break;
        case DefinitionKind.dk_Typedef:
	  st.currentFile = new File(old,childs[i][0]);
	  st.curInFile = null;
	  m = new TypedefDefImpl(this,this);
	  m.load(st);
          addListItem((TIRObject) m);
	  st.currentFile = null;
	  break;
        case DefinitionKind.dk_Interface:
	  st.currentFile = new File(old,childs[i][0]);
	  st.curInFile = null;
	  m = new InterfaceDefImpl(this,this);
	  m.load(st);
          addListItem((TIRObject) m);
	  st.currentFile = null;
	  break;
        case DefinitionKind.dk_Frame:
	  st.currentFile = new File(old,childs[i][0]);
	  st.curInFile = null;
	  m = new FrameDefImpl(this,this);
	  m.load(st);
          addListItem((TIRObject) m);
	  st.currentFile = null;
	  break;
	default: 
	  throw new TIRExceptStorage("Unexpected kind of object in \""
	                              +st.current+st.current.separator+childs[i]+"\".");
        }
      }
      postLoad(this);
      st.current = new File(old,"profiles");
      mProfiles = new ManageProfilesImpl(this);
      mProfiles.load(st);
      st.current = old;
      st.currentFile=null;
    } catch (IOException e) {
      throw new TIRExceptStorage("Access error in \""+st.current+"\".");
    }*/
    try {
      File iname = new File(st.current, Storage.indexFile);
      if ( ! iname.exists()) {
        // first loading in new dir
        uniq = 0;
	addListItem(new CDLRepositoryImpl(this));
	return;
      }
      BufferedReader index = new BufferedReader(new FileReader(iname.toString()));
      String un = index.readLine();
      uniq = Long.parseLong(un);
      index.close();

      boolean ex = true;
      File old = st.current;
      st.current = new File(st.current, "cdl");
      if ( ! st.current.exists())
        ex = false;
      TIRImplObject m = new CDLRepositoryImpl(this);
      if (ex)
        m.load(st);
      addListItem((TIRObject) m);
      st.current = old;

      // !!! if new languages will be added to TIR, saving of concrete LangRepository must be added

      postLoad(this);
      st.current = new File(old,"profiles");
      mProfiles = new ManageProfilesImpl(this);
      mProfiles.load(st);
      st.current = old;
      st.currentFile=null;
    } catch (IOException e) {
      throw new TIRExceptStorage("Access error in \""+st.current+"\".");
    }
  }

  public void postLoad(RepositoryImpl r) throws RemoteException, TIRExceptStorage {
    LiItem akt = firstChild;
    for(int i=0;i<numOfItems;i++) {
      ((TIRImplObject) akt.obj).postLoad(r);
      akt = akt.next;
    }
  }
  
  /* from interface TIRImplObject */
  public void save(Storage st) throws RemoteException, TIRExceptStorage {
    try {
     /* String[][] childs = null;
      if (!st.current.exists()) { // first save of repository
        if (!st.current.mkdir())
          throw new TIRExceptStorage("Can't create directory "+st.current+".");
      } else {    // repository dir exists
        try {
          childs = st.listOfChilds();
        } catch (TIRExceptStorage e) { // dir without index.tir
          ;
        }
      }	
      File f = new File(st.current,st.indexFile);  // name of index file
      LiItem akt = firstChild;
      File old = st.current;
      BufferedWriter index = new BufferedWriter(new FileWriter(f.toString())); 
      String un = Long.toString(uniq);
      index.write(un,0,un.length()); index.newLine();
      index.write("CHILDS",0,6); index.newLine();
      for(int i=0;i<numOfItems;i++) {
        String[] achild;    // actual child info
        IdentificationImpl idl;   // actual child id
	File nfile;               // path to child's current path
        if ((achild=st.existsChild(childs,idl = (IdentificationImpl)((Contained)akt.obj).get_identification()))!=null) { // file (dir) exists
	  // saving info to index file
          index.write(achild[0],0,achild[0].length()); index.write("?",0,1);
          index.write(achild[1],0,achild[1].length()); index.write("?",0,1);
          index.write(achild[2],0,achild[2].length()); index.write("?",0,1);
          index.write(achild[3],0,achild[3].length()); index.newLine();
	  nfile = new File(old,achild[0]);
	  
        } else {  //file (dir) doesn't exist
	  String hlp;
          //if (idl.name().length() <= Storage.maxLenFileName)
	  //  nfile = new File(old,idl.name());    // file (dir) name same as id
	  //else
            nfile = File.createTempFile("tir","",old);
          nfile.delete();
	  // saving info to index file
	  index.write(hlp = nfile.getName(),0,hlp.length()); index.write("?",0,1);
	  index.write(hlp=Integer.toString(akt.obj.get_def_kind().value()),0,hlp.length());
	  index.write("?",0,1);
	  index.write(hlp = idl.name(),0,hlp.length()); index.write("?",0,1);
          index.write(hlp = idl.version(),0,hlp.length()); index.newLine();
        }
        if ((akt.obj.get_def_kind().value()==DefinitionKind.dk_Module) ||
	    (akt.obj.get_def_kind().value()==DefinitionKind.dk_Provider)) {
	  st.current = nfile;   // directory for module
	  if (!st.current.exists())  //create only if doesn't exist
            if (!st.current.mkdir())
	      throw new TIRExceptStorage("Can't create directory "+st.current+".");
	} else {
	  st.currentFile = nfile;  // file for all except module
          st.curOutFile = null;
        }

	((TIRImplObject) akt.obj).save(st);   // save akt object
        akt = akt.next;                       // go to the next object
        st.current = old;
        st.currentFile = null;
      } // -- end of for
      index.close();
      st.current = new File(old,"profiles");
      if (!st.current.exists())  //create only if doesn't exist
        if (!st.current.mkdir())
          throw new TIRExceptStorage("Can't create directory "+st.current+".");
      mProfiles.save(st);
      st.current = old;*/

      // saving unique number
      File f = new File(st.current,Storage.indexFile);  // name of index file
      BufferedWriter index = new BufferedWriter(new FileWriter(f.toString())); 
      String un = Long.toString(uniq);
      index.write(un,0,un.length()); index.newLine();
      index.close();

      // saving childs
      LiItem akt = firstChild;
      File old = st.current;
      for(int i=0;i<numOfItems;i++) {
        String lang = ((SIdentification) ((Contained) akt.obj).get_identification()).language();
	f = new File(old, lang);
	if ( ! f.exists()) {
          if (!f.mkdir())
            throw new TIRExceptStorage("Can't create directory "+f+".");
	}
	st.current = f;
        ((TIRImplObject) akt.obj).save(st);   // save akt object
        akt = akt.next;                       // go to the next object
      } // -- end of for
      
      st.current = new File(old,"profiles");
      if (!st.current.exists())  //create only if doesn't exist
        if (!st.current.mkdir())
          throw new TIRExceptStorage("Can't create directory "+st.current+".");
      mProfiles.save(st);
      st.current = old;
    } catch (IOException e) {
      throw new TIRExceptStorage("Access error in "+st.current+".");
    }
  }

  /* call from commit() method of work repository */
  void commitSave() throws RemoteException, TIRExceptSave {
    try {
      save(storage);
       lock.unlock();
    } catch (TIRExceptStorage e) {
      throw new TIRExceptSave("Error occured when saving repository.\nError: "+e.getMessage());
    }   
  }

  public void save() throws RemoteException, TIRExceptSave {
    try {
      lock.lock();
      save(storage);
      lock.unlock();
    } catch (TIRExceptStorage e) {
      throw new TIRExceptSave("Error occured when saving repository.\nError: "+e.getMessage());
    }
  }  
 
  public Contained[] contents(DefinitionKind type) throws RemoteException, TIRExceptLock {
    if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else 
      return super.contents(type);
  }    

  public Contained lookup(Identification id) throws RemoteException, TIRExceptLock {
    if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else  {
      Contained ret = null;
      LiItem akt = firstChild;
      for(int i=0;i<numOfItems;i++) {
        if (((SIdentification) ((Contained)akt.obj).get_identification()).language().compareTo(id.name())==0) {
          ret = (Contained) akt.obj;
	 break;
        } else {
          akt = akt.next;
        }
      }
      return ret;
    }
  }

  public Contained lookup(String name, String version) throws RemoteException, TIRExceptLock {
    if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else {
      Contained ret = null;
      LiItem akt = firstChild;
      for(int i=0;i<numOfItems;i++) {
        if (((SIdentification) ((Contained)akt.obj).get_identification()).language().compareTo(name)==0) {
          ret = (Contained) akt.obj;
	 break;
        } else {
          akt = akt.next;
        }
      }
      return ret;
    }
  }

  public Contained[] lookup_name(Identification id) throws RemoteException, TIRExceptLock {
    if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else 
      return super.lookup_name(id);
  }

  public Contained[] lookup_name(String id) throws RemoteException, TIRExceptLock {
    if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else 
      return super.lookup_name(id);
  }

  public Contained lookup_tag(String name, String tag) throws RemoteException, TIRExceptLock {
    if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else 
      return super.lookup_tag(name, tag);
  }

  public Contained[] lookup_branchtag(String name, String brtag) throws RemoteException, TIRExceptLock {
    if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else 
      return super.lookup_branchtag(name, brtag);
  }

  public Contained lookup_lastinbranch(String name, String brtag) throws RemoteException, TIRExceptLock {
    if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else 
      return super.lookup_lastinbranch(name, brtag);
  }

  public Contained lookup_lastfromversion(String name, String version) throws RemoteException, TIRExceptLock {
    if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else 
      return super.lookup_lastfromversion(name, version);
  }

  public Contained[] scontents(DefinitionKind type) throws RemoteException, TIRExceptLock {
  /*  if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else */
      return super.scontents(type);
  }

  public Contained slookup(Identification id) throws RemoteException, TIRExceptLock {
   /* if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else */
      Contained ret = null;
      LiItem akt = firstChild;
      for(int i=0;i<numOfItems;i++) {
        if (((SIdentification) ((Contained)akt.obj).get_identification()).language().compareTo(id.name())==0) {
          ret = (Contained) akt.obj;
	 break;
        } else {
          akt = akt.next;
        }
      }
      return ret;
  }

  public Contained slookup(String name, String version) throws RemoteException, TIRExceptLock {
    /*if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else */
      Contained ret = null;
      LiItem akt = firstChild;
      for(int i=0;i<numOfItems;i++) {
        if (((SIdentification) ((Contained)akt.obj).get_identification()).language().compareTo(name)==0) {
          ret = (Contained) akt.obj;
	 break;
        } else {
          akt = akt.next;
        }
      }
      return ret;
  }

  public Contained[] slookup_name(Identification id) throws RemoteException, TIRExceptLock {
    /*if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else */
      Contained[] ret = null;
      LiItem akt = firstChild;
      for(int i=0;i<numOfItems;i++) {
        if (((SIdentification) ((Contained)akt.obj).get_identification()).language().compareTo(id.name())==0) {
	  ret = new Contained [1];
          ret[0] = (Contained) akt.obj;
	 break;
        } else {
          akt = akt.next;
        }
      }
      return ret;
  }

  public Contained[] slookup_name(String name) throws RemoteException, TIRExceptLock {
   /* if (lock.isLocked())
      throw new TIRExceptLock("Repository is locked");
    else */
      Contained[] ret = null;
      LiItem akt = firstChild;
      for(int i=0;i<numOfItems;i++) {
        if (((SIdentification) ((Contained)akt.obj).get_identification()).language().compareTo(name)==0) {
	  ret = new Contained [1];
          ret[0] = (Contained) akt.obj;
	 break;
        } else {
          akt = akt.next;
        }
      }
      return ret;
  }
  
  /* from interface TIRObject */
  public DefinitionKind get_def_kind() throws RemoteException {
    return (DefinitionKind) defKindImpl;
  }

  /* from interface TIRObject */
  public StateKind get_state() throws RemoteException {
    return (StateKind) stKindImpl;
  }

  public DefinitionKind get_spec_def_kind(int kind) throws RemoteException {
    return new DefinitionKindImpl(kind);
  }
 
  /* from interface Repository */
  public Identification create_identification(String lang, String name, String version) throws RemoteException, TIRExceptCreate {
//    return (Identification) new IdentificationImpl(name, version);
    throw new TIRExceptCreate("You can call create method on work object only");
  }

  /* from interface Repository */
  public Identification create_nextversion(Identification id) throws RemoteException, TIRExceptCreate  {
    throw new TIRExceptCreate("You can call create method on work object only");
  }

/* from interface Repository */
  public Identification create_initialversion(String lang, String name) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }

  public Identification create_branch(Identification from, String branchTag) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }

  public PrimitiveDef get_primitive(int kind) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }  

  public StringDef    create_string(ExprOperDef bound) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public WstringDef   create_wstring(ExprOperDef bound) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public SequenceDef  create_sequence(ExprOperDef bound, CDLType element) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ArrayDef     create_array(ExprOperDef length, CDLType element) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public FixedDef     create_fixed(ExprOperDef digits, ExprOperDef scale) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }

  public ProviderDef  create_provider(Identification id) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }

  public ExprBoolean    create_exprboolean(boolean val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprShort    create_exprshort(short val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprOctet  create_exproctet(byte val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }

  public ExprLong     create_exprlong(int val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprLongLong create_exprlonglong(long val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprUnsigShort create_exprunsigshort(short val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprUnsigLong  create_exprunsiglong(int val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprUnsigLongLong create_exprunsiglonglong(long val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprFloat    create_exprfloat(float val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprDouble   create_exprdouble(double val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprLongDouble create_exprlongdouble(double val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprFixed    create_exprfixed(java.math.BigDecimal val, int digits, int scale) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprProperty create_exprproperty(String pr) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprEnum create_exprenum(EnumDef en, String enMember) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprDefault  create_exprdefault() throws  RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprChar    create_exprchar(char val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprWchar   create_exprwchar(char val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprString  create_exprstring(String val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprWstring create_exprwstring(String val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprConstant create_exprconstant(ConstantDef val) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprUnOperationDef create_exprunoperation(int kind, ExprOperDef op) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ExprBinOperationDef create_exprbinoperation(int kind, ExprOperDef op1, ExprOperDef op2) throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }
  public ValueGen  create_valuegen() throws RemoteException, TIRExceptCreate {
    throw new TIRExceptCreate("You can call create method on work object only");
  }

  synchronized public WorkRepository beginChanges(ProfileDef p) throws RemoteException, TIRExceptCreate, TIRExceptLock {
    WorkRepository wr = new WorkRepositoryImpl(this,p);
    addWork(wr);
    return wr;
  }

  public void addWork(WorkRepository wr) {
    LiItem item = new LiItem(wr);
    if (firstWork == null) {
      firstWork = lastWork = item;
    } else {
      LiItem akt = firstWork;
      while (akt.next != null) akt = akt.next;
      akt.next = item;
      item.prev = akt;
      lastWork = item;
    }
    numOfWorks++;
  }

  public void removeWork(long workId) {
    if (numOfWorks>0) {
      LiItem akt = firstWork;
      boolean found = false;
      for (int i=0;i<numOfWorks;i++) {
        if (((WorkRepositoryImpl)akt.obj).workId == workId) {
          found = true;
          break;
        }
        akt = akt.next;
      }  
      if (!found)
        return;
      if (numOfWorks==1) {
	firstWork = lastWork = null;
	numOfWorks = 0;
      } else {
        if (akt == firstWork) {
          firstWork = akt.next;
	  firstWork.prev = null;
	  akt.next = null;
	  //akt = firstWork;
	} else {
          if (lastWork == akt) {
	    lastWork = akt.prev;
	    lastWork.next = null;
	    akt.prev = null;
	    //akt = lastWork;
	  } else {
	    akt.prev.next = akt.next;
	    akt.next.prev = akt.prev;
	    //akt = akt.next;
	  }
	}
        numOfWorks--;
      }
    }
  }

  synchronized public long getUniqueNumber() {
    long a = uniq;
    uniq++;
    return a;
  }

  public boolean isNew() {
    return false;
  }
  
  public void canCommit() {;}

  public void doCommit(Container in, Repository rep) {;}
  public void doAbort(long workId) throws RemoteException {}

  public long isLockedForCreate() {
    if (lockCreate.isLocked())
      return lockFor;
    return -1L;  
  }

  public ManageRepository getManage() throws RemoteException {
    return (ManageRepository) this;
  }

  public WorkRepository[] getActiveWork() throws RemoteException {
    LiItem akt = firstWork;   
    WorkRepository[] ret = new WorkRepository [numOfWorks];
    for (int i=0;i<numOfWorks;i++) {
      ret[i] = (WorkRepository) akt.obj;
      akt = akt.next;
    }
    return ret;
  }

  public ManageProfiles getProfiles() throws RemoteException {
    return mProfiles;
  }
}
