/* $Id: StructDef.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.RemoteException;

/** Interface for the struct */
public interface StructDef extends Contained, Container, CDLType {
  /** members of this struct */
  public StructMember[] members() throws RemoteException, TIRExceptLock;  
  /** Create new member in this struct */
  public StructMember create_member(String name, CDLType type) throws RemoteException, TIRExceptCreate, TIRExceptLock ;
  /** Create new struct in this struct */
  public StructDef    create_struct(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new union in this struct */
  public UnionDef     create_union(Identification id, CDLType switch_type) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new enum in this struct */
  public EnumDef      create_enum(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
}
