/**
 * TR2InOutCRole.java is a part of the SOFA project.
 * This file was created by pepan on 19.3.2003.
 */
package SOFA.SOFAnode.TR.Connector;

import SOFA.Connector.LinkException;
import SOFA.Connector.RoleBaseImpl;
import SOFA.Connector.TaggedProfile;
import SOFA.SOFAnode.InOut.Bundle;
import SOFA.SOFAnode.TR.ComponentInfo;
import SOFA.SOFAnode.TR.TR2InOut;
import SOFA.SOFAnode.TR.TRException;

/**
 * @author Petr Panuska
 */
public class TR2InOutCRole extends RoleBaseImpl implements TR2InOut {
  protected CNTR2InOut target;

  public void link (Object target) throws SOFA.Connector.LinkException {
    try {
      if (target instanceof SOFA.Connector.Reference) {
        SOFA.Connector.Reference ref = (SOFA.Connector.Reference) target;
        setSOFAReference(ref);
        TaggedProfile[] profiles = ref.profiles;
        for (int i = 0; i < profiles.length; i++) {
          if (profiles[i].tag.equals("LOCAL")) {
            this.target = (CNTR2InOut) ((SOFA.Connector.ECG.Profiles.LocalProfile) profiles[i]).link;
            return;
          } else if (profiles[i].tag.equals("RMI")) {
            this.target = new TR2InOutRMIStub(((SOFA.Connector.ECG.Profiles.RMIProfile) profiles[i]).URL);
            return;
          }
        }
      } else {
        this.target = (CNTR2InOut) target;
      }
    } catch (Exception e) {
      throw new LinkException("Can't link TR2InOutCRole. ", e);
    }
  }

  public void storeBundle (Bundle bundle) throws TRException {
    target.storeBundle(bundle);
  }

  public Bundle getBundle (ComponentInfo[] descs, ComponentInfo[] comps, boolean inferiors) throws TRException {
    return target.getBundle(descs, comps, inferiors);
  }

  public Bundle list () throws TRException {
    return target.list();
  }

  public boolean contains (ComponentInfo descrs) {
    return target.contains(descrs);
  }
}
