/**
 * TR2InOutRMIStub.java is a part of the SOFA project.
 * This file was created by pepan on 19.3.2003.
 */
package SOFA.SOFAnode.TR.Connector;

import java.io.IOException;
import java.rmi.RemoteException;

import SOFA.Connector.ConnectorTransportException;
import SOFA.SOFAnode.InOut.Bundle;
import SOFA.SOFAnode.TR.ComponentInfo;
import SOFA.SOFAnode.TR.TRException;
import SOFA.SOFAnode.TR.Impl.BundleImpl;

/**
 * @author Petr Panuska
 */
public class TR2InOutRMIStub implements CNTR2InOut {

  private CNTR2InOutRemote target;

  public TR2InOutRMIStub (String url) throws java.rmi.RemoteException {
    try {
      target = (CNTR2InOutRemote) java.rmi.Naming.lookup(url);
    } catch (java.net.MalformedURLException e) {
      throw new java.rmi.RemoteException("Can't create CNTR2InOutRemote.\n" + url + "\n", e);
    } catch (java.rmi.NotBoundException e) {
      throw new java.rmi.RemoteException("Can't create CNTR2InOutRemote.\n" + url + "\n", e);
    }
  }

  public void storeBundle (Bundle bundle) throws TRException {
    byte[] ret = null;
    try {
      cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      ((BundleImpl) bundle)._write(os);
      ret = os.toByteArray();
      target.storeBundle(ret);
    } catch (IOException e) {
      throw new ConnectorTransportException("Can't serialize in the 'TR2InOutRMIStub.getBundle'.", e);
    }
  }

  public Bundle getBundle (ComponentInfo[] descs, ComponentInfo[] comps, boolean inferiors) throws TRException {
    try {
      byte[] s = target.getBundle(descs, comps, inferiors);
      BundleImpl bundle = new BundleImpl();
      bundle._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(s));
      return bundle;
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'TR2InOutRMIStub.getBundle'.", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException in the 'TR2InOutRMIStub.getBundle'.", e);
    }
  }

  public boolean contains (ComponentInfo descrs) {
    try {
      return target.contains(descrs);
    } catch (RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'TR2InOutRMIStub.contains'.", e);
    }
  }

  public Bundle list () {
    try {
      byte[] s = target.list();
      BundleImpl bundle = new BundleImpl();
      bundle._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(s));
      return bundle;
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'TR2InOutRMIStub.list'.", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException in the 'TR2InOutRMIStub.list'.", e);
    }
  }
}
