/* $Id: ConnectorProtocolGen.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Util.ConnectorProtocolGen;


/** An interface for generator of connector protocols. 
  * @author Petr Hnetynka
  */
public interface ConnectorProtocolGen {
  
  /** Generates protocol for connector with specified roles.
    * @param provideRoles  list of connector's provide roles
    * @param requireRoles  list of connector's require roles
    * @return  generated protocol
    * @throws CannotGenerateException  thrown if protocol cannot be generated
    */
  public String generate(RoleDescription[] provideRoles, RoleDescription[] requireRoles) throws CannotGenerateException;
  
}

