/*
 * $Id: CheckingException.java,v 1.2 2005/07/08 12:04:11 kofron Exp $
 * 
 * Copyright 2004
 *    Distributed Systems Research Group
 *    Department of Software Engineering
 *    Faculty of Mathematics and Physics
 *    Charles University, Prague
 *
 * Copyright 2005
 *    Formal Methods In Software Engineering Group
 *    Institute of Computer Science
 *    Academy of Sciences of the Czech Republic
 * 
 * This code was developed by Jan Kofron <kofron@nenya.ms.mff.cuni.cz>
 */

package SOFA.SOFAnode.Util.DFSRChecker.DFSR;

/**
 * This is a general type of exception that is thrown during the checking
 * process
 */
public abstract class CheckingException extends Exception {
    /** Creates a new instance of EndOfCheckingException */
    public CheckingException() {
    }

    /**
     * ctor Creates an instance with a textual description
     * 
     * @param message
     *            description of the exception
     */
    public CheckingException(String message) {
        super(message);
    }

    /**
     * Adds a message to the exception instance
     * @param message message to be added
     * @return this instance
     */
    abstract public CheckingException addMessage(String message);

}