/*
 * $Id: InfiniteActivityException.java,v 1.2 2005/07/08 12:04:11 kofron Exp $
 * 
 * Copyright 2004
 *    Distributed Systems Research Group
 *    Department of Software Engineering
 *    Faculty of Mathematics and Physics
 *    Charles University, Prague
 *
 * Copyright 2005
 *    Formal Methods In Software Engineering Group
 *    Institute of Computer Science
 *    Academy of Sciences of the Czech Republic
 * 
 * This code was developed by Jan Kofron <kofron@nenya.ms.mff.cuni.cz>
 */

package SOFA.SOFAnode.Util.DFSRChecker.DFSR;

/**
 * This exception is thrown when a bad activity is detected while traversing the
 * state space, more preciselly when leaving a cycle of the state space.
 */
public class InfiniteActivityException extends CheckingException {

    /**
     * Creates a new instance of InfiniteActivityException.
     */
    public InfiniteActivityException() {
    }

    /**
     * Creates a new instance of InfiniteActivityException.
     * 
     * @param message
     *            the description of the exception
     */
    public InfiniteActivityException(String message) {
        super(message);
    }

    /**
     * @see SOFA.SOFAnode.Util.objectweb.fractal.behprotocols.checker.DFSR.CheckingException#addMessage(java.lang.String)
     */
    public CheckingException addMessage(String message) {
        return new InfiniteActivityException(this.getMessage() != null ? this.getMessage() + message : message);
    }

}