/* 
 * $Id: IBackend.java,v 1.4 2005/07/08 12:04:11 kofron Exp $
 *
 * Copyright 2004
 *    Distributed Systems Research Group
 *    Department of Software Engineering
 *    Faculty of Mathematics and Physics
 *    Charles University, Prague
 *
 * Copyright 2005
 *    Formal Methods In Software Engineering Group
 *    Institute of Computer Science
 *    Academy of Sciences of the Czech Republic
 * 
 * This code was developed by Jan Kofron <kofron@nenya.ms.mff.cuni.cz>
 */

package SOFA.SOFAnode.Util.DFSRChecker.backend;


import SOFA.SOFAnode.Util.DFSRChecker.CheckingResult;
import SOFA.SOFAnode.Util.DFSRChecker.node.TreeNode;

/**
 * This is the checker backend interface for either checking or visualization.
 */
public interface IBackend {

    /**
     * Performs the backend action (i.e., compliance test or visualization).
     * 
     * @return the string with error description or null if no error occurs
     */
    public CheckingResult perform(TreeNode[] nodes, String[] synchroops, String[] unboundops);
}