/*
 * $Id: ProtocolReader.java,v 1.1 2005/07/13 07:27:49 kofron Exp $
 *
 * Copyright 2005
 *    Formal Methods In Software Engineering Group
 *    Institute of Computer Science
 *    Academy of Sciences of the Czech Republic
 * 
 * This code was developed by Jan Kofron <kofron@nenya.ms.mff.cuni.cz>
 */

package SOFA.SOFAnode.Util.DFSRChecker.parser;

import java.io.Reader;

/**
 * This class extends the @link java.io.Reader with capability to read and reset the current position in the underlying stream.
 */
public abstract class ProtocolReader extends Reader {


    /**
     * @return the index within the string being parsed
     * 
     */
    abstract public int getIndex();
    
    /**
     * resets index to 0 a start to count again
     */
    abstract public void resetIndex();
   
}
