/* $Id: ProtocolAlternative.java,v 1.2 2004/05/20 14:23:53 bures Exp $ */

package SOFA.SOFAnode.Util;

import java.util.Iterator;

class ProtocolAlternative extends ProtocolBinaryOperator {

    public ProtocolAlternative( Protocol l, Protocol r ) {
	super( "+",l,r );
    }
    
    public Protocol Copy() {
	return new ProtocolAlternative( left.Copy(), right.Copy() );
    }
    
    public Machine createMachine() {
        Debug.println(3, "Alternative create machine start:");
    
	machineImpl m1 = (machineImpl)left.createMachine();
	machineImpl m2 = (machineImpl)right.createMachine();
	
	if( m1 == null ) return m2;             // if m1 is null, return m2 or null
	if( m2 == null ) return m1;             // m1 is not not and m2 is null

	Debug.println(3, "Alternative first machine:" );
	((Printer)m1).Print(3);
	Debug.println(3, "Alternative second machine:" );
	((Printer)m2).Print(3);
		 
	boolean start_is_stop =  m2.Stop().containsKey( new Integer(m2.Start())); 
	int map[] = m1.AddStates( m2.states, m2.nextID );           // add all states form m2 to result 
	m1.Merge(m1.Start(), map[m2.Start()] );     // connect following states to result start
	for( Iterator i = m2.Stop().values().iterator(); i.hasNext(); )
	    m1.AddStop( map[ ((Integer)i.next()).intValue()] );           // add finish states from m2

	for( Iterator i = m2.Update().values().iterator(); i.hasNext(); )
	    m1.addUpdateEdge( map[ ((Integer)i.next()).intValue()] );           // add finish states from m2

//	m1.RemoveState( m2.Start() );   // remove m2 starting state
	
	if( start_is_stop )  m1.AddStop( m1.Start() ); 

	m1.Minimize();

        Debug.println(3, "Alternative create machine finished:");
	((Printer)m1).Print(3);
	
	return m1;    
    }

    public Protocol getSameType( Object p1, Object p2 ) {
	return new ProtocolAlternative( (Protocol)p1, (Protocol)p2 );
    }
}

