/* $Id: ProtocolBinaryOperator.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */

package SOFA.SOFAnode.Util;

abstract class ProtocolBinaryOperator extends ProtocolOperator {

    protected Protocol left;
    protected Protocol right;
    
    public ProtocolBinaryOperator( String operator, Protocol l, Protocol r ) {
	super( operator );
	left = l;
	right = r;
    }
    
    public boolean Restrict( ActionTokenArray a ) {
	boolean resultl = left.Restrict( a );
	boolean resultr = right.Restrict( a );
	
	if( resultl ) left = new ProtocolToken( 0 );
	if( resultr ) right = new ProtocolToken( 0 );
	
	return resultl && resultr;
    }

    public void Print( int level ) {
	super.Print(level);
	left.Print(level);
	right.Print(level);
	Debug.print( level, "----" );
	super.Print(level);
    }

    public Protocol Left() {
	return left;
    }

    public Protocol Right() {
	return right;
    }
}

