/* $Id: ProtocolComposition.java,v 1.2 2004/05/20 14:23:53 bures Exp $ */

package SOFA.SOFAnode.Util;

import java.util.Hashtable;
import java.util.Iterator;

class ProtocolComposition extends ProtocolBinaryOperator {

    protected ActionTokenArray sync;

    public ProtocolComposition( Protocol l, Protocol r, ActionTokenArray s ) {
	super( "#",l,r );
	sync = s;
    }
    
    public Protocol Copy() {
	return new ProtocolComposition( left.Copy(), right.Copy(), new ActionTokenArray( sync ) );
    }
    
    public Machine createMachine() {
    
	int i,j,n1,n2,t,e,f;

	Debug.println(2,"This is composition create machine");
	Hashtable synchronizations = new Hashtable();
	
        machineImpl m1 = (machineImpl)left.createMachine();
        machineImpl m2 = (machineImpl)right.createMachine();
	
        Debug.println( 2,"Composition create:");
        Debug.println( 2,"First machine:");
        ((Printer)m1).Print(2);
        Debug.println( 2,"Second machine:");
        ((Printer)m2).Print(2);

        Debug.println(2);

	int mapping [][] = new int[m1.nextID][m2.nextID];
        machineImpl m = new machineImpl( m1.nextID * m2.nextID );

        for( i = 0; i < m1.nextID; i++ )
	    for( j = 0; j < m2.nextID; j++ ) mapping[i][j] = m.addState();

	if( Debug.debug>1 ) {
        Debug.println(2, "Mapping:" );
        for( i = 0; i < m1.nextID; i++ )
	    for( j = 0; j < m2.nextID; j++ ) 
                Debug.println(2, "[" + i + "," + j + "] -> " + mapping[i][j]);
	}

	for( n1 = 0 ; n1< m1.nextID ; n1++ ) 
	    for( n2 = 0; n2 < m2.nextID; n2++ )
		for( t = 0 ; t < EdgeFactory.getActionTokensNum(); t ++ ){
		    Debug.println(3, "Working on transition "+t );
		    boolean nsynchro = !sync.containsWithEventName(t);
		    if( m1.states[n1][t] != null )
			if( nsynchro ) 
			     for( e = 0 ; e < m1.states[n1][t].used ; e++ )
			         m.addEdge( mapping[n1][n2],t,mapping[ m1.states[n1][t].data[e]][n2] );
			else if( m2.states[n2][ EdgeFactory.inverseActionTokens[t]] != null ) {
			    for( e = 0 ; e < m1.states[n1][t].used ; e++ )
				for( f = 0 ; f < m2.states[n2][ EdgeFactory.inverseActionTokens[t]].used ; f++ )
				    m.addEdge( mapping[n1][n2], EdgeFactory.tauActionTokens[t], mapping[m1.states[n1][t].data[e]][m2.states[n2][ EdgeFactory.inverseActionTokens[t]].data[f]]); 
                         }
		    if( nsynchro && m2.states[n2][t] != null )
			for( e = 0 ; e < m2.states[n2][t].used ; e++ )
			     m.addEdge( mapping[n1][n2],t,mapping[n1][m2.states[n2][t].data[e]] );
		}

	m.SetStart( mapping[m1.Start()][m2.Start()]);

        Iterator k = m1.Stop().values().iterator();
        while( k.hasNext() ) {
            int n1i = ((Integer)k.next()).intValue();
	    Iterator l = m2.Stop().values().iterator();
	    while( l.hasNext() ) m.AddStop(mapping[n1i][((Integer)l.next()).intValue()]);
        }

        k = m1.Update().values().iterator();
        while( k.hasNext() ) {
            int n1i = ((Integer)k.next()).intValue();
	    Iterator l = m2.Update().values().iterator();
	    while( l.hasNext() ) m.addUpdateEdge(mapping[n1i][((Integer)l.next()).intValue()]);
        }

	m.Minimize();

        Debug.println(2, "Composition create done:");
        ((Printer)m).Print(2);
        Debug.println(2);
        return m;    
    }
    
    public boolean Restrict( ActionTokenArray a ) {
	ActionTokenArray h = new ActionTokenArray( a );
	for( int i = 0 ; i< sync.size; i++ ) 
	    h.tokens[i] = sync.tokens[i] || h.tokens[i];
	Debug.print( 3, "Restriction passed to arguments: "+ h.toList() );
	return super.Restrict( h );
    }

    public Protocol getSameType( Object p1, Object p2 ) {
	return new ProtocolComposition( (Protocol)p1, (Protocol)p2, new ActionTokenArray( sync ) );
    }
}

