/* $Id: ProtocolRepetition.java,v 1.2 2004/05/20 14:23:53 bures Exp $ */

package SOFA.SOFAnode.Util;

import java.util.Iterator;

class ProtocolRepetition extends ProtocolOperator {

    protected Protocol nested;
    
    public ProtocolRepetition(  Protocol op ) {
	super( "*" );
	nested = op;
    }
    
    public Protocol Copy() {
	return new ProtocolRepetition( nested.Copy() );
    }
    
    public boolean Restrict( ActionTokenArray a ) {
	return nested.Restrict( a );
    }
    
    public Machine createMachine() {
        Machine result = nested.createMachine();
	Debug.println(3,"Repetition parameter:");
	((Printer)result).Print(3);
        Iterator i = result.Stop().values().iterator();
	while( i.hasNext() ) 
	    result.Merge( ((Integer)i.next()).intValue(), result.Start() );
	result.AddStop( result.Start() );

	result.Minimize();

	Debug.println(3,"Repetition result:");
	((Printer)result).Print(3);
	return result;
    }

    public void Print( int level ) {
	super.Print(level);
	nested.Print(level);
	Debug.println( level, "---- *");
    }

    public Protocol Left() {
	return nested;
    }

    public Protocol getSameType( Object p1, Object p2 ) {
	return new ProtocolRepetition( (Protocol)p1 );
    }
}

