/* $Id: ProtocolRestriction.java,v 1.2 2004/05/20 14:23:53 bures Exp $ */

package SOFA.SOFAnode.Util;


class ProtocolRestriction extends ProtocolOperator {

    protected ActionTokenArray restrict;
    protected Protocol nested;

    public ProtocolRestriction( Protocol l, ActionTokenArray r ) {
	super( "\\" );
	restrict = r;
	nested = l;
    }
    
    public Protocol Copy() {
	return new ProtocolRestriction( nested.Copy(), new ActionTokenArray( restrict ));
    }
    
    public Machine createMachine() {
        
	Machine m1 = nested.createMachine();
        
	m1.Restrict( restrict );

	m1.Minimize();

	return m1;
    }
    
    public boolean Restrict( ActionTokenArray a ) {
	ActionTokenArray h = new ActionTokenArray( a );
	for( int i = 0 ; i < a.size; i++ ) 
	    h.tokens[i] = h.tokens[i] || restrict.tokens[i];
	return nested.Restrict( h );
    }

    public void Print( int level ) {
	super.Print( level );
	Debug.println( level, "Restrict set: "+restrict.toList() );
	nested.Print( level );
    }

    public Protocol Left() {
	return nested;
    }

    public Protocol getSameType( Object p1, Object p2 ) {
	return new ProtocolRestriction( (Protocol)p1, new ActionTokenArray( restrict ) );
    }
}
