/* $Id: ProtocolToken.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */

package SOFA.SOFAnode.Util;

class ProtocolToken extends Protocol {

    private int token;

    public ProtocolToken( ActionToken elem ) {
	super( elem );
	token = EdgeFactory.getActionTokenIdx( elem );
    }

    public ProtocolToken( int elem ) {
	super( EdgeFactory.ActionTokens[elem] );
	token = elem;
    }

    public Protocol Copy() {
	return new ProtocolToken( new ActionToken( ((ActionToken)element).name ));
    }
        
    public boolean Restrict( ActionTokenArray a ) {
	if( token == 0 ) return true; //  "NULL"  
	if( !a.tokens[token] ) {
	    Debug.println(3, "Token "+EdgeFactory.ActionTokens[token].name+" is restricted out");
	    element = new ActionToken( "NULL" );
	    token = 0;
	    return true;
	} else return token == 0;
    }

    public Machine createMachine() {
    
	Machine result = new machineImpl();
	int start = result.addState();

	result.SetStart( start );
	
	switch( token ) {
	    case 0: result.AddStop( start ); break;
	    case 1: result.AddStop( start ); result.addUpdateEdge( start ); break;
	    default:
	      int stop = result.addState();
	      result.AddStop( stop );
	      result.addEdge( start, token, stop );
	}
	return result;
    }    

    public void Print( int level ) {
	if( token == 0 ) Debug.println( level, "NULL" );
	else ((Printer)EdgeFactory.ActionTokens[token]).Print( level );
    }

    public Protocol getSameType( Object p1, Object p2 ) {
	return new ProtocolToken( (ActionToken)((ProtocolToken)p1).getElement() );
    }
    
    public Protocol Left() {
	return this.Copy();
    }
}